package yibao_pay

type YibaoJoinCallback struct {
	CustomerIdentification string `json:"customerIdentification"`
	Response               string `json:"response"`
}
type YibaoJoinCallbackInfo struct {
	AuditOpinion        string `json:"auditOpinion"`
	ApplicationStatus   string `json:"applicationStatus"`
	ApplicationNo       string `json:"applicationNo"`
	RequestNo           string `json:"requestNo"`
	AgreementSignUrl    string `json:"agreementSignUrl"`
	ProgressDescription string `json:"progressDescription"`
}
type YibaoJoinCallbackPayInfo struct {
	ChannelOrderId   string `json:"channelOrderId"`
	OrderId          string `json:"orderId"`
	BankOrderId      string `json:"bankOrderId"`
	PaySuccessDate   string `json:"paySuccessDate"`
	Channel          string `json:"channel"`
	PayWay           string `json:"payWay"`
	UniqueOrderNo    string `json:"uniqueOrderNo"`
	OrderAmount      string `json:"orderAmount"`
	PayAmount        string `json:"payAmount"`
	PayerInfo        string `json:"payerInfo"`
	RealPayAmount    string `json:"realPayAmount"`
	ParentMerchantNo string `json:"parentMerchantNo"`
	MerchantNo       string `json:"merchantNo"`
	Status           string `json:"status"`
}
type YibaoJoinCallbackClearInfo struct {
	FeeMerchantNo    string `json:"feeMerchantNo"`
	OrderAmount      string `json:"orderAmount"`
	CsSuccessDate    string `json:"csSuccessDate"`
	OrderId          string `json:"orderId"`
	MerchantFee      string `json:"merchantFee"`
	CustomerFee      string `json:"customerFee"`
	ParentMerchantNo string `json:"parentMerchantNo"`
	UniqueOrderNo    string `json:"uniqueOrderNo"`
	FeeType          string `json:"feeType"`
	YpSettleAmount   string `json:"ypSettleAmount"`
	MerchantNo       string `json:"merchantNo"`
	Status           string `json:"status"`
}

var YibaoBank = []map[string]string{
	{"value": "ALEJHCUNZB", "name": "阿拉尔津汇村镇银行"},
	{"value": "ALSRCB", "name": "阿拉善农村商业银行"},
	{"value": "ALSZQFDCUNZB", "name": "阿拉善左旗方大村镇银行"},
	{"value": "ALSZQHHCUNZB", "name": "阿拉善左旗黄河村镇银行"},
	{"value": "ADXFCUNZB", "name": "安达幸福村镇银行"},
	{"value": "AGZCCUNZB", "name": "安国中成村镇银行"},
	{"value": "AHCHYZCUNZB", "name": "安徽巢湖扬子村镇银行"},
	{"value": "AHZYRCB", "name": "安徽枞阳农村商业银行"},
	{"value": "AHDTXHCUNZB", "name": "安徽当涂新华村镇银行"},
	{"value": "AHDSRCB", "name": "安徽砀山农村商业银行"},
	{"value": "AHDYMFCUNZB", "name": "安徽定远民丰村镇银行"},
	{"value": "AHDYRCB", "name": "安徽定远农村商业银行"},
	{"value": "AHDZRCB", "name": "安徽东至农村商业银行"},
	{"value": "AHDZYZCUNZB", "name": "安徽东至扬子村镇银行"},
	{"value": "AHFCRCB", "name": "安徽繁昌农村商业银行"},
	{"value": "AHFDHSCUNZB", "name": "安徽肥东湖商村镇银行"},
	{"value": "AHFDRCB", "name": "安徽肥东农村商业银行"},
	{"value": "AHFXRCB", "name": "安徽肥西农村商业银行"},
	{"value": "AHFXSYCUNZB", "name": "安徽肥西石银村镇银行"},
	{"value": "AHFTRCB", "name": "安徽凤台农村商业银行"},
	{"value": "AHFTTSCUNZB", "name": "安徽凤台通商村镇银行"},
	{"value": "AHFYLMCUNZB", "name": "安徽凤阳利民村镇银行"},
	{"value": "AHFYRCB", "name": "安徽凤阳农村商业银行"},
	{"value": "AHFNRCB", "name": "安徽阜南农村商业银行"},
	{"value": "AHGZRCB", "name": "安徽固镇农村商业银行"},
	{"value": "AHGZXHCUNZB", "name": "安徽固镇新淮河村镇银行"},
	{"value": "AHGDRCB", "name": "安徽广德农村商业银行"},
	{"value": "AHGDYZCUNZB", "name": "安徽广德扬子村镇银行"},
	{"value": "AHHSRCB", "name": "安徽含山农村商业银行"},
	{"value": "AHHXRCB", "name": "安徽和县农村商业银行"},
	{"value": "AHHXXHCUNZB", "name": "安徽和县新华村镇银行"},
	{"value": "AHHNJHCUNZB", "name": "安徽怀宁江淮村镇银行"},
	{"value": "AHHNRCB", "name": "安徽怀宁农村商业银行"},
	{"value": "AHHYBFCUNZB", "name": "安徽怀远本富村镇银行"},
	{"value": "AHHYRCB", "name": "安徽怀远农村商业银行"},
	{"value": "AHHSJQCUNZB", "name": "安徽黄山金桥村镇银行"},
	{"value": "AHHZTYCUNZB", "name": "安徽徽州铜源村镇银行"},
	{"value": "AHHQLHCUNZB", "name": "安徽霍邱联合村镇银行"},
	{"value": "AHQHRCB", "name": "安徽霍邱农村商业银行"},
	{"value": "AHHSLHCUNZB", "name": "安徽霍山联合村镇银行"},
	{"value": "AHHUOSRCB", "name": "安徽霍山农村商业银行"},
	{"value": "AHJXIRCB", "name": "安徽绩溪农村商业银行"},
	{"value": "AHJSRCB", "name": "安徽界首农村商业银行"},
	{"value": "AHJZJHCUNZB", "name": "安徽金寨江淮村镇银行"},
	{"value": "AHJZRCB", "name": "安徽金寨农村商业银行"},
	{"value": "AHJXRCB", "name": "安徽泾县农村商业银行"},
	{"value": "AHZXTYCUNZB", "name": "安徽泾县铜源村镇银行"},
	{"value": "AHJDRCB", "name": "安徽旌德农村商业银行"},
	{"value": "AHLARCB", "name": "安徽来安农村商业银行"},
	{"value": "AHLXRCB", "name": "安徽郎溪农村商业银行"},
	{"value": "AHLXXHCUNZB", "name": "安徽郎溪新华村镇银行"},
	{"value": "AHLXHSCUNZB", "name": "安徽利辛湖商村镇银行"},
	{"value": "AHLIXRCB", "name": "安徽利辛农村商业银行"},
	{"value": "AHLQRCB", "name": "安徽临泉农村商业银行"},
	{"value": "AHLZBFCUNZB", "name": "安徽灵璧本富村镇银行"},
	{"value": "AHLBRCB", "name": "安徽灵璧农村商业银行"},
	{"value": "AHLJRCB", "name": "安徽庐江农村商业银行"},
	{"value": "AHMASRCB", "name": "安徽马鞍山农村商业银行"},
	{"value": "AHMCHSCUNZB", "name": "安徽蒙城湖商村镇银行"},
	{"value": "AHMCRCB", "name": "安徽蒙城农村商业银行"},
	{"value": "AHMGMFCUNZB", "name": "安徽明光民丰村镇银行"},
	{"value": "AHMGRCB", "name": "安徽明光农村商业银行"},
	{"value": "AHNLRCB", "name": "安徽南陵农村商业银行"},
	{"value": "AHNGRCB", "name": "安徽宁国农村商业银行"},
	{"value": "AHNXS", "name": "安徽省农村信用社联合社"},
	{"value": "AHQMRCB", "name": "安徽祁门农村商业银行"},
	{"value": "AHQMTYCUNZB", "name": "安徽祁门铜源村镇银行"},
	{"value": "AHQSJHCUNZB", "name": "安徽潜山江淮村镇银行"},
	{"value": "AHQSRCB", "name": "安徽潜山农村商业银行"},
	{"value": "AHZCHSCUNZB", "name": "安徽谯城湖商村镇银行"},
	{"value": "AHQYJHCUNZB", "name": "安徽青阳九华村镇银行"},
	{"value": "AHQYRCB", "name": "安徽青阳农村商业银行"},
	{"value": "AHQJRCB", "name": "安徽全椒农村商业银行"},
	{"value": "AHSTRCB", "name": "安徽石台农村商业银行"},
	{"value": "AHSTYZCUNZB", "name": "安徽石台扬子村镇银行"},
	{"value": "AHSXLHCUNZB", "name": "安徽寿县联合村镇银行"},
	{"value": "AHSXRCB", "name": "安徽寿县农村商业银行"},
	{"value": "AHSCRCB", "name": "安徽舒城农村商业银行"},
	{"value": "AHSCZXCUNZB", "name": "安徽舒城正兴村镇银行"},
	{"value": "AHSIXRCB", "name": "安徽泗县农村商业银行"},
	{"value": "AHZXHSCUNZB", "name": "安徽濉溪湖商村镇银行"},
	{"value": "AHSXIRCB", "name": "安徽濉溪农村商业银行"},
	{"value": "AHTHRCB", "name": "安徽太和农村商业银行"},
	{"value": "AHTHJHCUNZB", "name": "安徽太湖江淮村镇银行"},
	{"value": "AHTHURCB", "name": "安徽太湖农村商业银行"},
	{"value": "AHTCRCB", "name": "安徽天长农村商业银行"},
	{"value": "AHTCJHCUNZB", "name": "安徽桐城江淮村镇银行"},
	{"value": "AHTONGCRCB", "name": "安徽桐城农村商业银行"},
	{"value": "AHTLTYCUNZB", "name": "安徽铜陵铜源村镇银行"},
	{"value": "AHWJRCB", "name": "安徽望江农村商业银行"},
	{"value": "AHWYHSCUNZB", "name": "安徽涡阳湖商村镇银行"},
	{"value": "AHWYRCB", "name": "安徽涡阳农村商业银行"},
	{"value": "AHWWRCB", "name": "安徽无为农村商业银行"},
	{"value": "AHWHRCB", "name": "安徽五河农村商业银行"},
	{"value": "AHWHYTCUNZB", "name": "安徽五河永泰村镇银行"},
	{"value": "AHZXJYCUNZB", "name": "安徽歙县嘉银村镇银行"},
	{"value": "AHXIXRCB", "name": "安徽歙县农村商业银行"},
	{"value": "AHXXRCB", "name": "安徽萧县农村商业银行"},
	{"value": "AHXAYH", "name": "安徽新安银行"},
	{"value": "AHXNDDCUNZB", "name": "安徽休宁大地村镇银行"},
	{"value": "AHXNRCB", "name": "安徽休宁农村商业银行"},
	{"value": "AHSSMFCUNZB", "name": "安徽宿松民丰村镇银行"},
	{"value": "AHSSRCB", "name": "安徽宿松农村商业银行"},
	{"value": "AHSZHHCUNZB", "name": "安徽宿州淮海村镇银行"},
	{"value": "AHSZRCB", "name": "安徽宿州农村商业银行"},
	{"value": "AHXZHSCUNZB", "name": "安徽宣州湖商村镇银行"},
	{"value": "AHYJRCB", "name": "安徽叶集农村商业银行"},
	{"value": "AHYXRCB", "name": "安徽黟县农村商业银行"},
	{"value": "AHZXXHHCUNZB", "name": "安徽黟县新淮河村镇银行"},
	{"value": "AHYSRCB", "name": "安徽颍上农村商业银行"},
	{"value": "AHYASPCUNZB", "name": "安徽裕安盛平村镇银行"},
	{"value": "AHYXHSCUNZB", "name": "安徽岳西湖商村镇银行"},
	{"value": "AHYXIRCB", "name": "安徽岳西农村商业银行"},
	{"value": "AHCFKYCUNZB", "name": "安徽长丰科源村镇银行"},
	{"value": "AHCFRCB", "name": "安徽长丰农村商业银行"},
	{"value": "AKRCB", "name": "安康农村商业银行"},
	{"value": "ALXLCUNZB", "name": "安龙兴龙村镇银行"},
	{"value": "ALCNSCUNZB", "name": "安陆楚农商村镇银行"},
	{"value": "APHMCUNZB", "name": "安平惠民村镇银行"},
	{"value": "AQRCB", "name": "安庆农村商业银行"},
	{"value": "AQBHCUNZB", "name": "安丘北海村镇银行"},
	{"value": "ASNYCUNZB", "name": "安塞农银村镇银行"},
	{"value": "ASRCB", "name": "安顺农村商业银行"},
	{"value": "ASXHNMCUNZB", "name": "安顺西航南马村镇银行"},
	{"value": "ASXXFMCUNZB", "name": "安顺西秀富民村镇银行"},
	{"value": "ATNSCUNZB", "name": "安图农商村镇银行"},
	{"value": "AXMSCUNZB", "name": "安溪民生村镇银行"},
	{"value": "AXDSCUNZB", "name": "安新大商村镇银行"},
	{"value": "AYZJCUNZB", "name": "安阳珠江村镇银行"},
	{"value": "AYRXCUNZB", "name": "安义融兴村镇银行"},
	{"value": "ASYH", "name": "鞍山银行"},
	{"value": "ASHANRCB", "name": "鞍山农村商业银行"},
	{"value": "AHHNCUNZB", "name": "敖汉惠农村镇银行"},
	{"value": "RBIAG", "name": "奥地利奥合国际银行"},
	{"value": "ADLYHXXL", "name": "澳大利亚和新西兰银行集团"},
	{"value": "LUSOBANK", "name": "澳门国际银行"},
	{"value": "CBA", "name": "澳洲联邦银行"},
	{"value": "HBL", "name": "巴基斯坦哈比银行"},
	{"value": "BYNEHTRCB", "name": "巴彦淖尔河套农村商业银行"},
	{"value": "BYNESLHHHCUNZB", "name": "巴彦淖尔市临河黄河村镇银行"},
	{"value": "BYNESWLTCUNZB", "name": "巴彦淖尔市乌拉特村镇银行"},
	{"value": "BYRXCUNZB", "name": "巴彦融兴村镇银行"},
	{"value": "BZRCB", "name": "巴中农村商业银行"},
	{"value": "BZSFCUNZB", "name": "霸州舜丰村镇银行"},
	{"value": "BCRCB", "name": "白城农村商业银行"},
	{"value": "BCZBHMCUNZB", "name": "白城洮北惠民村镇银行"},
	{"value": "BSHJHTCUNZB", "name": "白山浑江恒泰村镇银行"},
	{"value": "BSJYHHCUNZB", "name": "白山江源汇恒村镇银行"},
	{"value": "BSJYRCB", "name": "白山江源农村商业银行"},
	{"value": "BSJXCJCUNZB", "name": "百色靖西长江村镇银行"},
	{"value": "BSYJHRCUNZB", "name": "百色右江华润村镇银行"},
	{"value": "BXRXCUNZB", "name": "柏乡融信村镇银行"},
	{"value": "BQRXCUNZB", "name": "拜泉融兴村镇银行"},
	{"value": "BBRCB", "name": "蚌埠农村商业银行"},
	{"value": "BTRCB", "name": "包头农村商业银行"},
	{"value": "QSHTCUNZB", "name": "包头青山河套村镇银行"},
	{"value": "BTSDHJGCUNZB", "name": "包头市东河金谷村镇银行"},
	{"value": "BTSGXYTCUNZB", "name": "包头市高新银通村镇银行"},
	{"value": "BTSJYLNCUNZB", "name": "包头市九原立农村镇银行"},
	{"value": "BTSKDLMYCUNZB", "name": "包头市昆都仑蒙银村镇银行"},
	{"value": "BFYFCUNZB", "name": "宝丰豫丰村镇银行"},
	{"value": "BQGYCUNZB", "name": "宝清广益村镇银行"},
	{"value": "BDXHRCUNZB", "name": "保德县慧融村镇银行"},
	{"value": "BDYH", "name": "保定银行"},
	{"value": "BDMCQLFCUNZB", "name": "保定满城区利丰村镇银行"},
	{"value": "BDQYQXNSCUNZB", "name": "保定清苑区邢农商村镇银行"},
	{"value": "BKCNSCUNZB", "name": "保康楚农商村镇银行"},
	{"value": "BSCNCJCUNZB", "name": "保山昌宁长江村镇银行"},
	{"value": "BSLLCJCUNZB", "name": "保山龙陵长江村镇银行"},
	{"value": "BSLYHNSCUNZB", "name": "保山隆阳沪农商村镇银行"},
	{"value": "BSSDCJCUNZB", "name": "保山施甸长江村镇银行"},
	{"value": "BBWYH", "name": "广西北部湾银行"},
	{"value": "BCCB", "name": "北京银行"},
	{"value": "BJCPBSCUNZB", "name": "北京昌平发展村镇银行"},
	{"value": "BJDXHXCUNZB", "name": "北京大兴华夏村镇银行"},
	{"value": "BJDXJYCUNZB", "name": "北京大兴九银村镇银行"},
	{"value": "BJFSHNSCUNZB", "name": "北京房山沪农商村镇银行"},
	{"value": "BJHRRXCUNZB", "name": "北京怀柔融兴村镇银行"},
	{"value": "BJMTGZJCUNZB", "name": "北京门头沟珠江村镇银行"},
	{"value": "BJMYHFCUNZB", "name": "北京密云汇丰村镇银行"},
	{"value": "BRCB", "name": "北京农村商业银行"},
	{"value": "BJPGXHCUNZB", "name": "北京平谷新华村镇银行"},
	{"value": "SYYZCUNZB", "name": "北京顺义银座村镇银行"},
	{"value": "BJYQCUNZB", "name": "北京延庆村镇银行"},
	{"value": "BPSDCUNZB", "name": "北票盛都村镇银行"},
	{"value": "BTGMCUNZB", "name": "北屯国民村镇银行"},
	{"value": "BXSCCB", "name": "本溪市商业银行"},
	{"value": "BXFTCUNZB", "name": "本溪丰泰村镇银行"},
	{"value": "BXFYCUNZB", "name": "本溪丰业村镇银行"},
	{"value": "BXHFCUNZB", "name": "本溪禾丰村镇银行"},
	{"value": "BXTSCUNZB", "name": "本溪同盛村镇银行"},
	{"value": "KBC", "name": "比利时联合银行"},
	{"value": "BJFZCUNZB", "name": "毕节发展村镇银行"},
	{"value": "BYBBWCUNZB", "name": "宾阳北部湾村镇银行"},
	{"value": "BZHHCUNZB", "name": "滨州河海村镇银行"},
	{"value": "BINZRCB", "name": "滨州农村商业银行"},
	{"value": "BZYDRCB", "name": "亳州药都农村商业银行"},
	{"value": "BLGMCUNZB", "name": "博乐国民村镇银行"},
	{"value": "CBHB", "name": "渤海银行"},
	{"value": "CWSTCUNZB", "name": "苍梧深通村镇银行"},
	{"value": "CXJYCUNZB", "name": "沧县吉银村镇银行"},
	{"value": "CZYH", "name": "沧州银行"},
	{"value": "CZHXXHCUNZB", "name": "沧州海兴新华村镇银行"},
	{"value": "CZSYHQLCUNZB", "name": "沧州市运河青隆村镇银行"},
	{"value": "CZYSXHCUNZB", "name": "沧州盐山新华村镇银行"},
	{"value": "CHFMCUNZB", "name": "册亨富民村镇银行"},
	{"value": "ZXSBBWCUNZB", "name": "岑溪市北部湾村镇银行"},
	{"value": "CLPFCUNZB", "name": "茶陵浦发村镇银行"},
	{"value": "CHEYYQQMYCUNZB", "name": "察哈尔右翼前旗蒙银村镇银行"},
	{"value": "CJGMCUNZB", "name": "昌吉国民村镇银行"},
	{"value": "CLLACUNZB", "name": "昌乐乐安村镇银行"},
	{"value": "CLJYCUNZB", "name": "昌黎家银村镇银行"},
	{"value": "CTMXCUNZB", "name": "昌图民祥村镇银行"},
	{"value": "CYBHCUNZB", "name": "昌邑北海村镇银行"},
	{"value": "CDERCB", "name": "常德农村商业银行"},
	{"value": "CNZJCUNZB", "name": "常宁珠江村镇银行"},
	{"value": "CZXBZCCUNZB", "name": "常州新北中成村镇银行"},
	{"value": "CZZLCJCUNZB", "name": "常州钟楼长江村镇银行"},
	{"value": "CHRCB", "name": "巢湖农村商业银行"},
	{"value": "CYYH", "name": "朝阳银行"},
	{"value": "CYLCCUNZB", "name": "朝阳柳城村镇银行"},
	{"value": "CZCACJCUNZB", "name": "潮州潮安长江村镇银行"},
	{"value": "CZRCB", "name": "郴州农村商业银行"},
	{"value": "CAQLCUNZB", "name": "成安齐鲁村镇银行"},
	{"value": "CDYH", "name": "成都银行"},
	{"value": "CDRCB", "name": "成都农村商业银行"},
	{"value": "CDQBJRXCUNZB", "name": "成都青白江融兴村镇银行"},
	{"value": "CDSLCMCUNZB", "name": "成都双流诚民村镇银行"},
	{"value": "CDBANK", "name": "承德银行"},
	{"value": "CDXHSCUNZB", "name": "承德县恒升村镇银行"},
	{"value": "CZGCMSCUNZB", "name": "池州贵池民生村镇银行"},
	{"value": "CZJHRCB", "name": "池州九华农村商业银行"},
	{"value": "CPHNSCUNZB", "name": "茌平沪农商村镇银行"},
	{"value": "CCJYCUNZB", "name": "赤城家银村镇银行"},
	{"value": "CFSHSYLCUNZB", "name": "赤峰市红山玉龙村镇银行"},
	{"value": "CFSSSLNCUNZB", "name": "赤峰市松山立农村镇银行"},
	{"value": "CFSYBSYLCUNZB", "name": "赤峰市元宝山玉龙村镇银行"},
	{"value": "CFSSRCB", "name": "赤峰松山农村商业银行"},
	{"value": "CFYBSRCB", "name": "赤峰元宝山农村商业银行"},
	{"value": "CRJYCUNZB", "name": "崇仁九银村镇银行"},
	{"value": "CYCNSCUNZB", "name": "崇阳楚农商村镇银行"},
	{"value": "CYRCB", "name": "崇义农村商业银行"},
	{"value": "CZSYCUNZB", "name": "崇州上银村镇银行"},
	{"value": "CZDXCJCUNZB", "name": "崇左大新长江村镇银行"},
	{"value": "CZWDRCB", "name": "滁州皖东农村商业银行"},
	{"value": "CXHTCUNZB", "name": "楚雄红塔村镇银行"},
	{"value": "CXYHYXGS", "name": "创兴银行有限公司"},
	{"value": "CLHNSCUNZB", "name": "慈利沪农商村镇银行"},
	{"value": "CXMSCUNZB", "name": "慈溪民生村镇银行"},
	{"value": "CXQLCUNZB", "name": "磁县齐鲁村镇银行"},
	{"value": "ZYTYCUNZB", "name": "枞阳泰业村镇银行"},
	{"value": "CJYMCUNZB", "name": "从江月明村镇银行"},
	{"value": "DEHMMALHQBSCUNZB", "name": "达尔罕茂明安联合旗蒙商村镇银行"},
	{"value": "DZYX", "name": "达州银行"},
	{"value": "DZRCB", "name": "达州农村商业银行"},
	{"value": "DAHMCUNZB", "name": "大安惠民村镇银行"},
	{"value": "DCHZZZXXHCUNZB", "name": "大厂回族自治县新华村镇银行"},
	{"value": "DCSFCUNZB", "name": "大城舜丰村镇银行"},
	{"value": "DFFMCUNZB", "name": "大方富民村镇银行"},
	{"value": "DFYX", "name": "大丰银行"},
	{"value": "UOBCHINA", "name": "大华银行（中国）有限公司"},
	{"value": "DLBCCJCUNZB", "name": "大理宾川长江村镇银行"},
	{"value": "DLEYCJCUNZB", "name": "大理洱源长江村镇银行"},
	{"value": "DLGCZCCUNZB", "name": "大理古城中成村镇银行"},
	{"value": "DLWSCJCUNZB", "name": "大理巍山长江村镇银行"},
	{"value": "DLYH", "name": "大连银行"},
	{"value": "DLBSQZJCUNZB", "name": "大连保税区珠江村镇银行"},
	{"value": "DLGJZPFCUNZB", "name": "大连甘井子浦发村镇银行"},
	{"value": "DLJZLFCUNZB", "name": "大连金州联丰村镇银行"},
	{"value": "DLJJJSKFQZHCUNZB", "name": "大连经济技术开发区鑫汇村镇银行"},
	{"value": "DLLSKMYCUNZB", "name": "大连旅顺口蒙银村镇银行"},
	{"value": "DLRCB", "name": "大连农村商业银行"},
	{"value": "DLPLDHFCUNZB", "name": "大连普兰店汇丰村镇银行"},
	{"value": "DMHSCUNZB", "name": "大名恒升村镇银行"},
	{"value": "DQRCB", "name": "大庆农村商业银行"},
	{"value": "DTSNJQJDCUNZB", "name": "大同市南郊区京都村镇银行"},
	{"value": "DWHFCUNZB", "name": "大洼恒丰村镇银行"},
	{"value": "DWCNSCUNZB", "name": "大悟楚农商村镇银行"},
	{"value": "BNU", "name": "大西洋银行"},
	{"value": "DAHSING", "name": "大新银行（中国）有限公司"},
	{"value": "DXALRCB", "name": "大兴安岭农村商业银行"},
	{"value": "DYJYXMCUNZB", "name": "大邑交银兴民村镇银行"},
	{"value": "DZYHXGYXGS", "name": "大众银行（香港）有限公司"},
	{"value": "DXZDCUNZB", "name": "代县泓都村镇银行"},
	{"value": "DDYH", "name": "丹东银行"},
	{"value": "DDDACUNZB", "name": "丹东鼎安村镇银行"},
	{"value": "DDDYCUNZB", "name": "丹东鼎元村镇银行"},
	{"value": "DDFHCUNZB", "name": "丹东福汇村镇银行"},
	{"value": "DDRCB", "name": "丹东农村商业银行"},
	{"value": "DJKCNSCUNZB", "name": "丹江口楚农商村镇银行"},
	{"value": "DZFMCUNZB", "name": "丹寨富民村镇银行"},
	{"value": "COMMERZBANK", "name": "德国商业银行"},
	{"value": "DHMSCJCUNZB", "name": "德宏芒市长江村镇银行"},
	{"value": "DHDYCUNZB", "name": "德惠敦银村镇银行"},
	{"value": "DJCZCUNZB", "name": "德江长征村镇银行"},
	{"value": "DQHRCUNZB", "name": "德庆华润村镇银行"},
	{"value": "DXLHCUNZB", "name": "德兴蓝海村镇银行"},
	{"value": "DEYRCB", "name": "德阳农村商业银行"},
	{"value": "DB", "name": "德意志银行（中国）有限公司"},
	{"value": "DZYH", "name": "德州银行"},
	{"value": "DZLCRCB", "name": "德州陵城农村商业银行"},
	{"value": "DZLCYRCUNZB", "name": "德州陵城圆融村镇银行"},
	{"value": "DEZRCB", "name": "德州农村商业银行"},
	{"value": "DFQLCUNZB", "name": "登封齐鲁村镇银行"},
	{"value": "ZKMYCUNZB", "name": "磴口蒙银村镇银行"},
	{"value": "FIRSTBANK", "name": "第一商业银行"},
	{"value": "DAHFCUNZB", "name": "定安合丰村镇银行"},
	{"value": "DTHHCUNZB", "name": "定陶河海村镇银行"},
	{"value": "DXRCB", "name": "定西农村商业银行"},
	{"value": "DXFYCUNZB", "name": "定兴丰源村镇银行"},
	{"value": "DZZCCUNZB", "name": "定州中成村镇银行"},
	{"value": "DAQLCUNZB", "name": "东阿青隆村镇银行"},
	{"value": "BI", "name": "东方汇理银行（中国）有限公司"},
	{"value": "DFHFCUNZB", "name": "东方惠丰村镇银行"},
	{"value": "DFJYCUNZB", "name": "东丰吉银村镇银行"},
	{"value": "DGTHCUNZB", "name": "东港同合村镇银行"},
	{"value": "DGYH", "name": "东莞银行"},
	{"value": "DZCPXHCUNZB", "name": "东莞常平新华村镇银行"},
	{"value": "DZDLDYCUNZB", "name": "东莞大朗东盈村镇银行"},
	{"value": "DZHJHYCUNZB", "name": "东莞厚街华业村镇银行"},
	{"value": "DZHMCJCUNZB", "name": "东莞虎门长江村镇银行"},
	{"value": "DZHJZJCUNZB", "name": "东莞黄江珠江村镇银行"},
	{"value": "DGRCB", "name": "东莞农村商业银行"},
	{"value": "DZCACUNZB", "name": "东莞长安村镇银行"},
	{"value": "DGQLCUNZB", "name": "东光青隆村镇银行"},
	{"value": "DLNSCUNZB", "name": "东辽农商村镇银行"},
	{"value": "DNRSCUNZB", "name": "东宁润生村镇银行"},
	{"value": "DPHNSCUNZB", "name": "东平沪农商村镇银行"},
	{"value": "DSRZCUNZB", "name": "东山润鑫村镇银行"},
	{"value": "DWZMQNXKYCUNZB", "name": "东乌珠穆沁农信开元村镇银行"},
	{"value": "DXGMCUNZB", "name": "东兴国民村镇银行"},
	{"value": "HKBEA", "name": "东亚银行（中国）有限公司"},
	{"value": "DOYYH", "name": "东营银行"},
	{"value": "DYHKZCCUNZB", "name": "东营河口中成村镇银行"},
	{"value": "DYLSCUNZB", "name": "东营莱商村镇银行"},
	{"value": "DYRCB", "name": "东营农村商业银行"},
	{"value": "DYRHCUNZB", "name": "东营融和村镇银行"},
	{"value": "DYTYCUNZB", "name": "东源泰业村镇银行"},
	{"value": "DCJYCUNZB", "name": "都昌九银村镇银行"},
	{"value": "DJYJDCUNZB", "name": "都江堰金都村镇银行"},
	{"value": "DYRTCUNZB", "name": "都匀融通村镇银行"},
	{"value": "DSFMCUNZB", "name": "独山富民村镇银行"},
	{"value": "DEBTRSCUNZB", "name": "杜尔伯特润生村镇银行"},
	{"value": "DHJNCUNZB", "name": "敦化江南村镇银行"},
	{"value": "DHSJSCUNZB", "name": "敦煌市金盛村镇银行"},
	{"value": "VTB", "name": "俄罗斯外贸银行"},
	{"value": "EMSZCCUNZB", "name": "峨眉山中成村镇银行"},
	{"value": "EEDSYH", "name": "鄂尔多斯银行"},
	{"value": "EEDSRCB", "name": "鄂尔多斯农村商业银行"},
	{"value": "EEDSSDSMYCUNZB", "name": "鄂尔多斯市东胜蒙银村镇银行"},
	{"value": "EEDSSHTCUNZB", "name": "鄂尔多斯市罕台村镇银行"},
	{"value": "EEDSSKBSCUNZB", "name": "鄂尔多斯市康巴什村镇银行"},
	{"value": "EEDSSTLHJGCUNZB", "name": "鄂尔多斯市塔拉壕金谷村镇银行"},
	{"value": "EEDSSTJMYCUNZB", "name": "鄂尔多斯市天骄蒙银村镇银行"},
	{"value": "EEDSSTXMYCUNZB", "name": "鄂尔多斯市铁西蒙银村镇银行"},
	{"value": "ETKQHZCUNZB", "name": "鄂托克旗汇泽村镇银行"},
	{"value": "ETKQQMYCUNZB", "name": "鄂托克前旗蒙银村镇银行"},
	{"value": "ETKXSYCUNZB", "name": "鄂托克兴生源村镇银行"},
	{"value": "EWKBSCUNZB", "name": "鄂温克蒙商村镇银行"},
	{"value": "ELHTRCU", "name": "二连浩特农村合作银行"},
	{"value": "BNPPARIBAS", "name": "法国巴黎银行（中国）有限公司"},
	{"value": "NBPBK", "name": "法国外贸银行"},
	{"value": "SOCIETEGENERATE", "name": "法国兴业银行"},
	{"value": "FZXXTCUNZB", "name": "繁峙县新田村镇银行"},
	{"value": "FXDSCUNZB", "name": "范县德商村镇银行"},
	{"value": "FCGFCGMCUNZB", "name": "防城港防城国民村镇银行"},
	{"value": "FXCNSCUNZB", "name": "房县楚农商村镇银行"},
	{"value": "PHILIPPINESCB", "name": "菲律宾首都银行及信托"},
	{"value": "FXLZCUNZB", "name": "费县梁邹村镇银行"},
	{"value": "FYJYCUNZB", "name": "分宜九银村镇银行"},
	{"value": "FXXTXCUNZB", "name": "汾西县太行村镇银行"},
	{"value": "FXXYTCUNZB", "name": "汾西县亿通村镇银行"},
	{"value": "FYSJDCUNZB", "name": "汾阳市九都村镇银行"},
	{"value": "FCSYCUNZB", "name": "丰城顺银村镇银行"},
	{"value": "FCFYCUNZB", "name": "凤城丰益村镇银行"},
	{"value": "FHLMCUNZB", "name": "奉化罗蒙村镇银行"},
	{"value": "FXJYCUNZB", "name": "奉新九银村镇银行"},
	{"value": "FSGMSYCUNZB", "name": "佛山高明顺银村镇银行"},
	{"value": "FSNHXHCUNZB", "name": "佛山南海新华村镇银行"},
	{"value": "FSRCB", "name": "佛山农村商业银行"},
	{"value": "FFPFCUNZB", "name": "扶风浦发村镇银行"},
	{"value": "FGZYCUNZB", "name": "扶沟郑银村镇银行"},
	{"value": "FSSTCUNZB", "name": "扶绥深通村镇银行"},
	{"value": "FYHMCUNZB", "name": "扶余惠民村镇银行"},
	{"value": "FLNSCUNZB", "name": "浮梁农商村镇银行"},
	{"value": "FJDTJNSCUNZB", "name": "福建大田晋农商村镇银行"},
	{"value": "FJDHCGCUNZB", "name": "福建德化成功村镇银行"},
	{"value": "FJFAYNSCUNZB", "name": "福建福安渝农商村镇银行"},
	{"value": "FJFDHXCUNZB", "name": "福建福鼎恒兴村镇银行"},
	{"value": "FJFQHTRCB", "name": "福建福清汇通农村商业银行"},
	{"value": "FJFQTLCUNZB", "name": "福建福清泰隆村镇银行"},
	{"value": "FJFZRCB", "name": "福建福州农村商业银行"},
	{"value": "FJHXYH", "name": "福建海峡银行"},
	{"value": "FJHTB", "name": "福建华通银行"},
	{"value": "FJJORCB", "name": "福建建瓯农村商业银行"},
	{"value": "FJJORSCUNZB", "name": "福建建瓯瑞狮村镇银行"},
	{"value": "FJJYRSCUNZB", "name": "福建建阳瑞狮村镇银行"},
	{"value": "FJJLCGCUNZB", "name": "福建将乐成功村镇银行"},
	{"value": "FJJCCTHCUNZB", "name": "福建蕉城刺桐红村镇银行"},
	{"value": "FJJJRCB", "name": "福建晋江农村商业银行"},
	{"value": "FJLCHXCUNZB", "name": "福建连城杭兴村镇银行"},
	{"value": "FJLJHXCUNZB", "name": "福建连江恒欣村镇银行"},
	{"value": "FJLHRCB", "name": "福建龙海农村商业银行"},
	{"value": "FJLHTLCUNZB", "name": "福建龙海泰隆村镇银行"},
	{"value": "FJLYRCB", "name": "福建龙岩农村商业银行"},
	{"value": "FJLYHRCUNZB", "name": "福建罗源汇融村镇银行"},
	{"value": "FJMHMBCUNZB", "name": "福建闽侯民本村镇银行"},
	{"value": "FJMQRSCUNZB", "name": "福建闽清瑞狮村镇银行"},
	{"value": "FJNAHTCUNZB", "name": "福建南安汇通村镇银行"},
	{"value": "FJNARCB", "name": "福建南安农村商业银行"},
	{"value": "FJNPRCB", "name": "福建南平农村商业银行"},
	{"value": "FJNDRCB", "name": "福建宁德农村商业银行"},
	{"value": "FJNHCGCUNZB", "name": "福建宁化成功村镇银行"},
	{"value": "FJNXS", "name": "福建省农村信用社联合社"},
	{"value": "FJPTANRCB", "name": "福建平潭农村商业银行"},
	{"value": "FJPTYNSCUNZB", "name": "福建平潭渝农商村镇银行"},
	{"value": "FJPTRCB", "name": "福建莆田农村商业银行"},
	{"value": "FJQZTSTZQJNSCUNZB", "name": "福建泉州台商投资区晋农商村镇银行"},
	{"value": "FJSMRCB", "name": "福建三明农村商业银行"},
	{"value": "FJSXRCB", "name": "福建沙县农村商业银行"},
	{"value": "FJSXYNSCUNZB", "name": "福建沙县渝农商村镇银行"},
	{"value": "FJSHRCB", "name": "福建上杭农村商业银行"},
	{"value": "FJSSRCB", "name": "福建石狮农村商业银行"},
	{"value": "FJSSYRSCUNZB", "name": "福建石狮渝农商村镇银行"},
	{"value": "FJTNJNSCUNZB", "name": "福建泰宁晋农商村镇银行"},
	{"value": "FJWPHXCUNZB", "name": "福建武平杭兴村镇银行"},
	{"value": "FJWYSRCB", "name": "福建武夷山农村商业银行"},
	{"value": "FJXYRSCUNZB", "name": "福建仙游瑞狮村镇银行"},
	{"value": "FJXLJNSCUNZB", "name": "福建新罗晋农商村镇银行"},
	{"value": "FJYAHFCUNZB", "name": "福建永安汇丰村镇银行"},
	{"value": "FJYCZNSCUNZB", "name": "福建永春漳农商村镇银行"},
	{"value": "FJYDRSCUNZB", "name": "福建永定瑞狮村镇银行"},
	{"value": "FJYXCGCUNZB", "name": "福建尤溪成功村镇银行"},
	{"value": "FJZPMTCUNZB", "name": "福建漳平民泰村镇银行"},
	{"value": "FJZPRCB", "name": "福建漳平农村商业银行"},
	{"value": "FJZZRCB", "name": "福建漳州农村商业银行"},
	{"value": "FJCLRCB", "name": "福建长乐农村商业银行"},
	{"value": "FJCLTLCUNZB", "name": "福建长乐泰隆村镇银行"},
	{"value": "FJZAHTCUNZB", "name": "福建诏安汇通村镇银行"},
	{"value": "FJZHTLCUNZB", "name": "福建政和泰隆村镇银行"},
	{"value": "FQFMCUNZB", "name": "福泉富民村镇银行"},
	{"value": "FSYH", "name": "抚顺银行"},
	{"value": "FSDZFYCUNZB", "name": "抚顺东洲抚银村镇银行"},
	{"value": "FSSQYCUNZB", "name": "抚顺市清原村镇银行"},
	{"value": "FSSCFYCUNZB", "name": "抚顺顺城抚银村镇银行"},
	{"value": "FSWHFYCUNZB", "name": "抚顺望花抚银村镇银行"},
	{"value": "FSXBFYCUNZB", "name": "抚顺新宾抚银村镇银行"},
	{"value": "FSYYCUNZB", "name": "抚松榆银村镇银行"},
	{"value": "FZDXFMCUNZB", "name": "抚州东乡富民村镇银行"},
	{"value": "FZRCB", "name": "抚州农村商业银行"},
	{"value": "FCJYCUNZB", "name": "阜城家银村镇银行"},
	{"value": "FKJHCUNZB", "name": "阜康津汇村镇银行"},
	{"value": "FNMSCUNZB", "name": "阜宁民生村镇银行"},
	{"value": "FPDSCUNZB", "name": "阜平大商村镇银行"},
	{"value": "FXYH", "name": "阜新银行"},
	{"value": "FXRCB", "name": "阜新农村商业银行"},
	{"value": "FXNSCUNZB", "name": "阜新农商村镇银行"},
	{"value": "FYYDRCB", "name": "阜阳颍东农村商业银行"},
	{"value": "FYYHRCB", "name": "阜阳颍淮农村商业银行"},
	{"value": "FYYQRCB", "name": "阜阳颍泉农村商业银行"},
	{"value": "FDYH", "name": "富滇银行"},
	{"value": "FJXFCUNZB", "name": "富锦幸福村镇银行"},
	{"value": "FMPFCUNZB", "name": "富民浦发村镇银行"},
	{"value": "FYZCCUNZB", "name": "富蕴中成村镇银行"},
	{"value": "GSYH", "name": "甘肃银行"},
	{"value": "GSCXRCB", "name": "甘肃崇信农村商业银行"},
	{"value": "GSDHRCB", "name": "甘肃敦煌农村商业银行"},
	{"value": "GSGTRCB", "name": "甘肃高台农村商业银行"},
	{"value": "GSGLRCB", "name": "甘肃古浪农村商业银行"},
	{"value": "GSGZRCB", "name": "甘肃瓜州农村商业银行"},
	{"value": "GSHTRCB", "name": "甘肃华亭农村商业银行"},
	{"value": "GSHNRCB", "name": "甘肃会宁农村商业银行"},
	{"value": "GSJCRCB", "name": "甘肃泾川农村商业银行"},
	{"value": "GSJYRCB", "name": "甘肃靖远农村商业银行"},
	{"value": "GSJNRCB", "name": "甘肃静宁农村商业银行"},
	{"value": "GSKXRCB", "name": "甘肃康县农村商业银行"},
	{"value": "GSLIXRCB", "name": "甘肃礼县农村商业银行"},
	{"value": "GSLDRCB", "name": "甘肃两当农村商业银行"},
	{"value": "GSLINTRCB", "name": "甘肃临洮农村商业银行"},
	{"value": "GSLXRCB", "name": "甘肃临夏农村商业银行"},
	{"value": "GSLZRCB", "name": "甘肃临泽农村商业银行"},
	{"value": "GSLTRCB", "name": "甘肃灵台农村商业银行"},
	{"value": "GSLXIRCB", "name": "甘肃陇西农村商业银行"},
	{"value": "GSMLRCB", "name": "甘肃民乐农村商业银行"},
	{"value": "GSMQRCB", "name": "甘肃民勤农村商业银行"},
	{"value": "GSMXRCB", "name": "甘肃岷县农村商业银行"},
	{"value": "GSNXRCU", "name": "甘肃宁县农村合作银行"},
	{"value": "GSNXS", "name": "甘肃省农村信用社联合社"},
	{"value": "GSQARCB", "name": "甘肃秦安农村商业银行"},
	{"value": "GSSDRCB", "name": "甘肃山丹农村商业银行"},
	{"value": "GSTZRCB", "name": "甘肃天祝农村商业银行"},
	{"value": "GSXGJCCUNZB", "name": "甘肃西固金城村镇银行"},
	{"value": "GSXHRCB", "name": "甘肃西和农村商业银行"},
	{"value": "GSYCRCB", "name": "甘肃永昌农村商业银行"},
	{"value": "GSYZRCU", "name": "甘肃榆中农村合作银行"},
	{"value": "GSYMRCB", "name": "甘肃玉门农村商业银行"},
	{"value": "GSZLRCB", "name": "甘肃庄浪农村商业银行"},
	{"value": "GZBC", "name": "赣州银行"},
	{"value": "GANZRCB", "name": "赣州农村商业银行"},
	{"value": "GBDZCCUNZB", "name": "高碑店中成村镇银行"},
	{"value": "GMHMCUNZB", "name": "高密惠民村镇银行"},
	{"value": "GPSTXCUNZB", "name": "高平市太行村镇银行"},
	{"value": "GTQLCUNZB", "name": "高唐青隆村镇银行"},
	{"value": "ZCHSCUNZB", "name": "藁城恒升村镇银行"},
	{"value": "GJHNSCUNZB", "name": "个旧沪农商村镇银行"},
	{"value": "ICBC", "name": "中国工商银行"},
	{"value": "GZLHXCUNZB", "name": "公主岭华兴村镇银行"},
	{"value": "GZLPFCUNZB", "name": "公主岭浦发村镇银行"},
	{"value": "GYPFCUNZB", "name": "巩义浦发村镇银行"},
	{"value": "GQRCB", "name": "共青农村商业银行"},
	{"value": "GJSFMCUNZB", "name": "古交市阜民村镇银行"},
	{"value": "GJSHZCUNZB", "name": "古交市汇泽村镇银行"},
	{"value": "GTCTHCUNZB", "name": "古田刺桐红村镇银行"},
	{"value": "GAHSCUNZB", "name": "固安恒升村镇银行"},
	{"value": "GSTJCUNZB", "name": "固始天骄村镇银行"},
	{"value": "GYBSCUNZB", "name": "固阳蒙商村镇银行"},
	{"value": "GCJYCUNZB", "name": "故城家银村镇银行"},
	{"value": "GLHSCUNZB", "name": "关岭恒升村镇银行"},
	{"value": "CEB", "name": "中国光大银行"},
	{"value": "GZCTHCUNZB", "name": "光泽刺桐红村镇银行"},
	{"value": "GAHFCUNZB", "name": "广安恒丰村镇银行"},
	{"value": "GARCB", "name": "广安农村商业银行"},
	{"value": "GASYRCB", "name": "广安思源农村商业银行"},
	{"value": "GCNYCUNZB", "name": "广昌南银村镇银行"},
	{"value": "GDBLRCB", "name": "广东博罗农村商业银行"},
	{"value": "GDCZRCB", "name": "广东潮州农村商业银行"},
	{"value": "GDCHCSCUNZB", "name": "广东澄海潮商村镇银行"},
	{"value": "GDDPRCB", "name": "广东大埔农村商业银行"},
	{"value": "GDDQRCB", "name": "广东德庆农村商业银行"},
	{"value": "GDDYRCB", "name": "广东东源农村商业银行"},
	{"value": "GDEPHFCUNZB", "name": "广东恩平汇丰村镇银行"},
	{"value": "GDFSRCB", "name": "广东丰顺农村商业银行"},
	{"value": "GDFKRCB", "name": "广东封开农村商业银行"},
	{"value": "GDFGRCB", "name": "广东佛冈农村商业银行"},
	{"value": "GDGZRCB", "name": "广东高州农村商业银行"},
	{"value": "GDGNRCB", "name": "广东广宁农村商业银行"},
	{"value": "GDHPRCB", "name": "广东和平农村商业银行"},
	{"value": "GDHYNRCB", "name": "广东河源农村商业银行"},
	{"value": "GDHSRCB", "name": "广东鹤山农村商业银行"},
	{"value": "GDHXYH", "name": "广东华兴银行"},
	{"value": "GDHUAZRCB", "name": "广东化州农村商业银行"},
	{"value": "GDHJRCB", "name": "广东怀集农村商业银行"},
	{"value": "GDHDRCB", "name": "广东惠东农村商业银行"},
	{"value": "GDHZRCB", "name": "广东惠州农村商业银行"},
	{"value": "GDJLRCB", "name": "广东蕉岭农村商业银行"},
	{"value": "GDJDRCB", "name": "广东揭东农村商业银行"},
	{"value": "GDJXRCB", "name": "广东揭西农村商业银行"},
	{"value": "GDJYRCB", "name": "广东揭阳农村商业银行"},
	{"value": "GDKPRCB", "name": "广东开平农村商业银行"},
	{"value": "GDLECRCB", "name": "广东乐昌农村商业银行"},
	{"value": "GDLEIZRCB", "name": "广东雷州农村商业银行"},
	{"value": "GDLNRCB", "name": "广东连南农村商业银行"},
	{"value": "GDLPRCB", "name": "广东连平农村商业银行"},
	{"value": "GDLSRCB", "name": "广东连山农村商业银行"},
	{"value": "GDLZRCB", "name": "广东连州农村商业银行"},
	{"value": "GDLCRCB", "name": "广东龙川农村商业银行"},
	{"value": "GDLMRCB", "name": "广东龙门农村商业银行"},
	{"value": "GDLHRCB", "name": "广东陆河农村商业银行"},
	{"value": "GDLDRCB", "name": "广东罗定农村商业银行"},
	{"value": "GDMMRCB", "name": "广东茂名农村商业银行"},
	{"value": "GDMZRCB", "name": "广东梅州农村商业银行"},
	{"value": "GDNARCB", "name": "广东南澳农村商业银行"},
	{"value": "GDNHRCB", "name": "广东南海农村商业银行"},
	{"value": "GDNXRCB", "name": "广东南雄农村商业银行"},
	{"value": "GDNXS", "name": "广东省农村信用社联合社"},
	{"value": "GDPYRCB", "name": "广东平远农村商业银行"},
	{"value": "GDPNHCCUNZB", "name": "广东普宁汇成村镇银行"},
	{"value": "GDPNRCB", "name": "广东普宁农村商业银行"},
	{"value": "GDQXRCB", "name": "广东清新农村商业银行"},
	{"value": "GDQYRCB", "name": "广东清远农村商业银行"},
	{"value": "GDRHRCB", "name": "广东仁化农村商业银行"},
	{"value": "GDRYRCB", "name": "广东乳源农村商业银行"},
	{"value": "GDSXRCB", "name": "广东始兴农村商业银行"},
	{"value": "GDSHRCB", "name": "广东四会农村商业银行"},
	{"value": "GDSHTLCUNZB", "name": "广东四会泰隆村镇银行"},
	{"value": "GDSXIRCB", "name": "广东遂溪农村商业银行"},
	{"value": "GDTSRCB", "name": "广东台山农村商业银行"},
	{"value": "GDWYRCB", "name": "广东翁源农村商业银行"},
	{"value": "GDWHRCB", "name": "广东五华农村商业银行"},
	{"value": "GDXFRCB", "name": "广东新丰农村商业银行"},
	{"value": "GDXXRCB", "name": "广东新兴农村商业银行"},
	{"value": "GDXYRCB", "name": "广东信宜农村商业银行"},
	{"value": "GDXNRCB", "name": "广东兴宁农村商业银行"},
	{"value": "GDXWRCB", "name": "广东徐闻农村商业银行"},
	{"value": "GDYCRCB", "name": "广东阳春农村商业银行"},
	{"value": "GDYJRCB", "name": "广东阳江农村商业银行"},
	{"value": "GDYSRCB", "name": "广东阳山农村商业银行"},
	{"value": "GDYDERCB", "name": "广东英德农村商业银行"},
	{"value": "GDYDTLRCB", "name": "广东英德泰隆村镇银行"},
	{"value": "GDZJRCB", "name": "广东紫金农村商业银行"},
	{"value": "CGB", "name": "广发银行"},
	{"value": "GFGXCUNZB", "name": "广丰广信村镇银行"},
	{"value": "GHZJCUNZB", "name": "广汉珠江村镇银行"},
	{"value": "GRLZCUNZB", "name": "广饶梁邹村镇银行"},
	{"value": "GSCNSCUNZB", "name": "广水楚农商村镇银行"},
	{"value": "GXBSYJRCU", "name": "广西百色右江农村合作银行"},
	{"value": "GXBLLYCUNZB", "name": "广西北流柳银村镇银行"},
	{"value": "GXBBLYCUNZB", "name": "广西博白柳银村镇银行"},
	{"value": "GXCXRCB", "name": "广西岑溪农村商业银行"},
	{"value": "GXCZGNRCB", "name": "广西崇左农村商业银行"},
	{"value": "GXDAXRCB", "name": "广西大新农村商业银行"},
	{"value": "GXDXRCB", "name": "广西东兴农村商业银行"},
	{"value": "GXFSRCB", "name": "广西扶绥农村商业银行"},
	{"value": "GXFCRCB", "name": "广西富川农村商业银行"},
	{"value": "GXGCRCB", "name": "广西恭城农村商业银行"},
	{"value": "GXGYRCB", "name": "广西灌阳农村商业银行"},
	{"value": "GXGLLJRCU", "name": "广西桂林漓江农村合作银行"},
	{"value": "GXGPGYCUNZB", "name": "广西桂平桂银村镇银行"},
	{"value": "GXHZGDRCU", "name": "广西贺州桂东农村合作银行"},
	{"value": "GXHXGSCUNZB", "name": "广西横县桂商村镇银行"},
	{"value": "GXJXRCB", "name": "广西靖西农村商业银行"},
	{"value": "GXLBGZRCU", "name": "广西来宾农村商业银行"},
	{"value": "GXLEYRCB", "name": "广西乐业农村商业银行"},
	{"value": "GXLGRCB", "name": "广西临桂农村商业银行"},
	{"value": "GXLYRCB", "name": "广西凌云农村商业银行"},
	{"value": "GXLCRCU", "name": "广西柳城农村商业银行"},
	{"value": "GXLJLYCUNZB", "name": "广西柳江柳银村镇银行"},
	{"value": "GXLJRCU", "name": "广西柳江农村合作银行"},
	{"value": "GXLSRCB", "name": "广西龙胜农村商业银行"},
	{"value": "GXLZRCB", "name": "广西龙州农村商业银行"},
	{"value": "GXLARCB", "name": "广西隆安农村商业银行"},
	{"value": "GXLLRCB", "name": "广西隆林农村商业银行"},
	{"value": "GXLCLYCUNZB", "name": "广西陆川柳银村镇银行"},
	{"value": "GXLCRCB", "name": "广西陆川农村商业银行"},
	{"value": "GXLUZRCB", "name": "广西鹿寨农村商业银行"},
	{"value": "GXLZYNSCUNZB", "name": "广西鹿寨渝农商村镇银行"},
	{"value": "GXMASRCB", "name": "广西马山农村商业银行"},
	{"value": "GXMSRCB", "name": "广西蒙山农村商业银行"},
	{"value": "GXNPRCB", "name": "广西那坡农村商业银行"},
	{"value": "GXNMRCB", "name": "广西宁明农村商业银行"},
	{"value": "GXNXS", "name": "广西壮族自治区农村信用社联合社"},
	{"value": "GXPGRCU", "name": "广西平果农村合作银行"},
	{"value": "GXPLRCU", "name": "广西平乐农村合作银行"},
	{"value": "GXPNGYCUNZB", "name": "广西平南桂银村镇银行"},
	{"value": "GXPXRCB", "name": "广西凭祥农村商业银行"},
	{"value": "GXPBGMCUNZB", "name": "广西浦北国民村镇银行"},
	{"value": "GXPBRCB", "name": "广西浦北农村商业银行"},
	{"value": "GXQZSQNGMCUNZB", "name": "广西钦州市钦南国民村镇银行"},
	{"value": "GXQZRCU", "name": "广西全州农村合作银行"},
	{"value": "GXRXGYCUNZB", "name": "广西容县桂银村镇银行"},
	{"value": "GXRARCB", "name": "广西融安农村商业银行"},
	{"value": "GXRSLYCUNZB", "name": "广西融水柳银村镇银行"},
	{"value": "GXSLGMCUNZB", "name": "广西上林国民村镇银行"},
	{"value": "GXSLRCB", "name": "广西上林农村商业银行"},
	{"value": "GXSSRCB", "name": "广西上思农村商业银行"},
	{"value": "GXTXGYCUNZB", "name": "广西藤县桂银村镇银行"},
	{"value": "GXTDRCB", "name": "广西天等农村商业银行"},
	{"value": "GXTDONGRCB", "name": "广西田东农村商业银行"},
	{"value": "GXTLRCB", "name": "广西田林农村商业银行"},
	{"value": "GXTYRCB", "name": "广西田阳农村商业银行"},
	{"value": "GXXLRCB", "name": "广西西林农村商业银行"},
	{"value": "GXXZRCU", "name": "广西象州农村合作银行"},
	{"value": "GXXAMXCUNZB", "name": "广西兴安民兴村镇银行"},
	{"value": "GXXARCU", "name": "广西兴安农村合作银行"},
	{"value": "GXXYLYCUNZB", "name": "广西兴业柳银村镇银行"},
	{"value": "GXYSRCU", "name": "广西阳朔农村商业银行"},
	{"value": "GXYZRCU", "name": "广西宜州农村合作银行"},
	{"value": "GXYHGMCUNZB", "name": "广西银海国民村镇银行"},
	{"value": "GXYFRCU", "name": "广西永福农村商业银行"},
	{"value": "GXYFXHCUNZB", "name": "广西鱼峰信合村镇银行"},
	{"value": "GXZPRCB", "name": "广西昭平农村商业银行"},
	{"value": "GXZYRCB", "name": "广西资源农村商业银行"},
	{"value": "GYSBSGMCUNZB", "name": "广元市发展村镇银行"},
	{"value": "GYSGSCUNZB", "name": "广元市贵商村镇银行"},
	{"value": "GUAZYH", "name": "广州银行"},
	{"value": "GZBYMTCUNZB", "name": "广州白云民泰村镇银行"},
	{"value": "GZCHLYCUNZB", "name": "广州从化柳银村镇银行"},
	{"value": "GZFZXHCUNZB", "name": "广州番禺新华村镇银行"},
	{"value": "GZHDCZCUNZB", "name": "广州花都稠州村镇银行"},
	{"value": "GZHPHMCUNZB", "name": "广州黄埔惠民村镇银行"},
	{"value": "GZHPRHCUNZB", "name": "广州黄埔融和村镇银行"},
	{"value": "GZRCB", "name": "广州农村商业银行"},
	{"value": "GZZCCJCUNZB", "name": "广州增城长江村镇银行"},
	{"value": "GAXQFZCUNZB", "name": "贵安新区发展村镇银行"},
	{"value": "GDHSCUNZB", "name": "贵定恒升村镇银行"},
	{"value": "GXJYCUNZB", "name": "贵溪九银村镇银行"},
	{"value": "GYYH", "name": "贵阳银行"},
	{"value": "GYBYDXCUNZB", "name": "贵阳白云德信村镇银行"},
	{"value": "GYGSHFMCUNZB", "name": "贵阳观山湖富民村镇银行"},
	{"value": "GYHXJSCUNZB", "name": "贵阳花溪建设村镇银行"},
	{"value": "GYNMFMCUNZB", "name": "贵阳南明富民村镇银行"},
	{"value": "GYRCB", "name": "贵阳农村商业银行"},
	{"value": "GYWDFMCUNZB", "name": "贵阳乌当富民村镇银行"},
	{"value": "GYXHKJCUNZB", "name": "贵阳小河科技村镇银行"},
	{"value": "GYYYFMCUNZB", "name": "贵阳云岩富民村镇银行"},
	{"value": "GUZYH", "name": "贵州银行"},
	{"value": "GZALRCB", "name": "贵州安龙农村商业银行"},
	{"value": "GZBJRCB", "name": "贵州毕节农村商业银行"},
	{"value": "GZCJRCB", "name": "贵州从江农村商业银行"},
	{"value": "GZDFRCB", "name": "贵州大方农村商业银行"},
	{"value": "GZDZRCB", "name": "贵州丹寨农村商业银行"},
	{"value": "GZDAOZRCB", "name": "贵州道真农村商业银行"},
	{"value": "GZDYRCB", "name": "贵州都匀农村商业银行"},
	{"value": "GZDSRCB", "name": "贵州独山农村商业银行"},
	{"value": "GZFGRCB", "name": "贵州凤冈农村商业银行"},
	{"value": "GZFQRCB", "name": "贵州福泉农村商业银行"},
	{"value": "GZGLRCB", "name": "贵州关岭农村商业银行"},
	{"value": "GZHZRCB", "name": "贵州赫章农村商业银行"},
	{"value": "GZHXRCB", "name": "贵州花溪农村商业银行"},
	{"value": "GZHPRCB", "name": "贵州黄平农村商业银行"},
	{"value": "GZHSRCB", "name": "贵州惠水农村商业银行"},
	{"value": "GZKLRCB", "name": "贵州凯里农村商业银行"},
	{"value": "GZLPRCB", "name": "贵州黎平农村商业银行"},
	{"value": "GZLBRCB", "name": "贵州荔波农村商业银行"},
	{"value": "GZLLRCB", "name": "贵州龙里农村商业银行"},
	{"value": "GZMJRCB", "name": "贵州麻江农村商业银行"},
	{"value": "GZMTRCB", "name": "贵州湄潭农村商业银行"},
	{"value": "GZNXS", "name": "贵州省农村信用社联合社"},
	{"value": "GZPTRCB", "name": "贵州平塘农村商业银行"},
	{"value": "GZPARCB", "name": "贵州普安农村商业银行"},
	{"value": "GZPDRCB", "name": "贵州普定农村商业银行"},
	{"value": "GZQXRCB", "name": "贵州黔西农村商业银行"},
	{"value": "GZQZRCB", "name": "贵州清镇农村商业银行"},
	{"value": "GZQLRCB", "name": "贵州晴隆农村商业银行"},
	{"value": "GZRHMRCB", "name": "贵州仁怀茅台农村商业银行"},
	{"value": "GZSDRCB", "name": "贵州三都农村商业银行"},
	{"value": "GZSSRCB", "name": "贵州三穗农村商业银行"},
	{"value": "GZSNRCB", "name": "贵州思南农村商业银行"},
	{"value": "GZTZRCB", "name": "贵州天柱农村商业银行"},
	{"value": "GZTZIRCB", "name": "贵州桐梓农村商业银行"},
	{"value": "GZWARCB", "name": "贵州瓮安农村商业银行"},
	{"value": "GZWDRCB", "name": "贵州乌当农村商业银行"},
	{"value": "GZWCRCB", "name": "贵州务川农村商业银行"},
	{"value": "GZXFRCB", "name": "贵州息烽农村商业银行"},
	{"value": "GZXRRCB", "name": "贵州兴仁农村商业银行"},
	{"value": "GZXYRCB", "name": "贵州兴义农村商业银行"},
	{"value": "GZXWRCB", "name": "贵州修文农村商业银行"},
	{"value": "GZYQRCB", "name": "贵州余庆农村商业银行"},
	{"value": "GZZFRCB", "name": "贵州贞丰农村商业银行"},
	{"value": "GZZYUANRCB", "name": "贵州镇远农村商业银行"},
	{"value": "GZZJRCB", "name": "贵州织金农村商业银行"},
	{"value": "GZZYRCB", "name": "贵州紫云农村商业银行"},
	{"value": "GZZYHHGRCB", "name": "贵州遵义红花岗农村商业银行"},
	{"value": "GZZYHCRCB", "name": "贵州遵义汇川农村商业银行"},
	{"value": "GZZYIRCB", "name": "贵州遵义农村商业银行"},
	{"value": "GLYH", "name": "桂林银行"},
	{"value": "GLGMCUNZB", "name": "桂林国民村镇银行"},
	{"value": "GYHNSCUNZB", "name": "桂阳沪农商村镇银行"},
	{"value": "CDBB", "name": "国家开发银行"},
	{"value": "GMYHZHYXGS", "name": "国民银行（中国）有限公司"},
	{"value": "CATHAYBK", "name": "国泰世华商业银行"},
	{"value": "HEBYH", "name": "哈尔滨银行"},
	{"value": "HEBACNSCUNZB", "name": "哈尔滨阿城农商村镇银行"},
	{"value": "HEBBZCUNZB", "name": "哈尔滨宾洲村镇银行"},
	{"value": "HEBHLPFCUNZB", "name": "哈尔滨呼兰浦发村镇银行"},
	{"value": "HEBRCB", "name": "哈尔滨农村商业银行"},
	{"value": "HEBNXCUNZB", "name": "哈尔滨农信村镇银行"},
	{"value": "HEBXFCUNZB", "name": "哈尔滨幸福村镇银行"},
	{"value": "HMSCCB", "name": "哈密市商业银行"},
	{"value": "HMHXGMCUNZB", "name": "哈密红星国民村镇银行"},
	{"value": "HMTSCUNZB", "name": "哈密天山村镇银行"},
	{"value": "HKLHRCB", "name": "海口联合农村商业银行"},
	{"value": "HKRCB", "name": "海口农村商业银行"},
	{"value": "HKSNCUNZB", "name": "海口苏南村镇银行"},
	{"value": "HLYDCUNZB", "name": "海林远东村镇银行"},
	{"value": "HLHFCUNZB", "name": "海伦惠丰村镇银行"},
	{"value": "HNYH", "name": "海南银行"},
	{"value": "HNBSRCB", "name": "海南白沙农村商业银行"},
	{"value": "HNBSCJCUNZB", "name": "海南白沙长江村镇银行"},
	{"value": "HNBTRXCUNZB", "name": "海南保亭融兴村镇银行"},
	{"value": "HNCJCJCUNZB", "name": "海南昌江长江村镇银行"},
	{"value": "HNCMRCB", "name": "海南澄迈农村商业银行"},
	{"value": "HNCMCJCUNZB", "name": "海南澄迈长江村镇银行"},
	{"value": "HNZZLSCUNZB", "name": "海南儋州绿色村镇银行"},
	{"value": "HNLGRCB", "name": "海南临高农村商业银行"},
	{"value": "HNNXS", "name": "海南省农村信用社联合社"},
	{"value": "HNQZCJCUNZB", "name": "海南琼中长江村镇银行"},
	{"value": "HNTCRCB", "name": "海南屯昌农村商业银行"},
	{"value": "HNTCCJCUNZB", "name": "海南屯昌长江村镇银行"},
	{"value": "HNWCRCB", "name": "海南文昌农村商业银行"},
	{"value": "HNWZSCJCUNZB", "name": "海南五指山长江村镇银行"},
	{"value": "HYZJCUNZB", "name": "海阳珠江村镇银行"},
	{"value": "HDCB", "name": "邯郸银行"},
	{"value": "HDFXHSCUNZB", "name": "邯郸肥乡恒升村镇银行"},
	{"value": "HDHSQLCUNZB", "name": "邯郸邯山齐鲁村镇银行"},
	{"value": "HDYNQLCUNZB", "name": "邯郸永年齐鲁村镇银行"},
	{"value": "HSHMCUNZB", "name": "含山惠民村镇银行"},
	{"value": "HCPFCUNZB", "name": "韩城浦发村镇银行"},
	{"value": "KDBK", "name": "韩国产业银行"},
	{"value": "DGB", "name": "韩国大邱银行"},
	{"value": "BSB", "name": "韩国釜山银行"},
	{"value": "HYYH", "name": "韩亚银行（中国）有限公司"},
	{"value": "HKYH", "name": "汉口银行"},
	{"value": "HZHTPZJLCUNZB", "name": "汉中汉台铺镇聚利村镇银行"},
	{"value": "XTLFCUNZB", "name": "行唐利丰村镇银行"},
	{"value": "HJDZCUNZB", "name": "杭锦大众村镇银行"},
	{"value": "HJHQHTCUNZB", "name": "杭锦后旗河套村镇银行"},
	{"value": "HZYH", "name": "杭州银行"},
	{"value": "HZLHRCB", "name": "杭州联合农村商业银行"},
	{"value": "HFKJRCB", "name": "合肥科技农村商业银行"},
	{"value": "HPGMCUNZB", "name": "合浦国民村镇银行"},
	{"value": "HSXJCCUNZB", "name": "合水县金城村镇银行"},
	{"value": "HYHMCUNZB", "name": "合阳惠民村镇银行"},
	{"value": "TCBBANK", "name": "合作金库商业银行"},
	{"value": "HLDYCUNZB", "name": "和龙敦银村镇银行"},
	{"value": "HSXGDCUNZB", "name": "和顺县贵都村镇银行"},
	{"value": "HZSZCUNZB", "name": "和政神舟村镇银行"},
	{"value": "HBYH", "name": "河北银行"},
	{"value": "HBAGRCB", "name": "河北安国农村商业银行"},
	{"value": "HBAPRCB", "name": "河北安平农村商业银行"},
	{"value": "HBBZRCB", "name": "河北霸州农村商业银行"},
	{"value": "HBBXRCB", "name": "河北柏乡农村商业银行"},
	{"value": "HEBBDRCB", "name": "河北保定农村商业银行"},
	{"value": "HBCZRCB", "name": "河北沧州农村商业银行"},
	{"value": "HBCDRHRCB", "name": "河北承德热河农村商业银行"},
	{"value": "HBDCRCB", "name": "河北大厂农村商业银行"},
	{"value": "HBDMRCB", "name": "河北大名农村商业银行"},
	{"value": "HBDZRCB", "name": "河北定州农村商业银行"},
	{"value": "HBFNRCB", "name": "河北丰宁农村商业银行"},
	{"value": "HBFCRCB", "name": "河北阜城农村商业银行"},
	{"value": "HBGBDRCB", "name": "河北高碑店农村商业银行"},
	{"value": "HBGYRCB", "name": "河北沽源农村商业银行"},
	{"value": "HEBGARCB", "name": "河北固安农村商业银行"},
	{"value": "HBGZRCB", "name": "河北广宗农村商业银行"},
	{"value": "HBHDRCB", "name": "河北邯郸农村商业银行"},
	{"value": "HBHSRCB", "name": "河北衡水农村商业银行"},
	{"value": "HBHLRCB", "name": "河北怀来农村商业银行"},
	{"value": "HBHHRCB", "name": "河北黄骅农村商业银行"},
	{"value": "HBJIZRCB", "name": "河北鸡泽农村商业银行"},
	{"value": "HBYZRCB", "name": "河北冀州农村商业银行"},
	{"value": "HBJINZRCB", "name": "河北晋州农村商业银行"},
	{"value": "HBJJRCB", "name": "河北井陉农村商业银行"},
	{"value": "HBJZRCB", "name": "河北景州农村商业银行"},
	{"value": "HEBJLRCB", "name": "河北巨鹿农村商业银行"},
	{"value": "HBKCRCB", "name": "河北宽城农村商业银行"},
	{"value": "HBLSRCB", "name": "河北涞水农村商业银行"},
	{"value": "HBLZBYRCB", "name": "河北蠡州北银农村商业银行"},
	{"value": "HBLCRCB", "name": "河北临城农村商业银行"},
	{"value": "HBLXRCB", "name": "河北临西农村商业银行"},
	{"value": "HBLINGSRCB", "name": "河北灵寿农村商业银行"},
	{"value": "HBLLRCB", "name": "河北卢龙农村商业银行"},
	{"value": "HBLNRCB", "name": "河北滦南农村商业银行"},
	{"value": "HBLPRCB", "name": "河北滦平农村商业银行"},
	{"value": "HBLZRCB", "name": "河北滦州农村商业银行"},
	{"value": "HBNHRCB", "name": "河北南和农村商业银行"},
	{"value": "HBNPRCB", "name": "河北南皮农村商业银行"},
	{"value": "HBNJRCB", "name": "河北宁晋农村商业银行"},
	{"value": "HEBNXS", "name": "河北省农村信用社联合社"},
	{"value": "HBPSRCB", "name": "河北平山农村商业银行"},
	{"value": "HBQARCB", "name": "河北迁安农村商业银行"},
	{"value": "HBQHRCB", "name": "河北清河农村商业银行"},
	{"value": "HBRXRCB", "name": "河北任县农村商业银行"},
	{"value": "HEBSHRCB", "name": "河北三河农村商业银行"},
	{"value": "HBSHRCB", "name": "河北沙河农村商业银行"},
	{"value": "HBSXRCB", "name": "河北涉县农村商业银行"},
	{"value": "HEBSZRCB", "name": "河北深州农村商业银行"},
	{"value": "HBTSCFDRCB", "name": "河北唐山曹妃甸农村商业银行"},
	{"value": "HBTSRCB", "name": "河北唐山农村商业银行"},
	{"value": "HBWCRCB", "name": "河北围场农村商业银行"},
	{"value": "HBWARCB", "name": "河北文安农村商业银行"},
	{"value": "HBWUQRCB", "name": "河北武强农村商业银行"},
	{"value": "HBXXRCB", "name": "河北献县农村商业银行"},
	{"value": "HBXHRCB", "name": "河北香河农村商业银行"},
	{"value": "HBXJRCB", "name": "河北辛集农村商业银行"},
	{"value": "HBXTRCB", "name": "河北邢台农村商业银行"},
	{"value": "HBXZRCB", "name": "河北邢州农村商业银行"},
	{"value": "HBYYRCB", "name": "河北阳原农村商业银行"},
	{"value": "HBYQRCB", "name": "河北永清农村商业银行"},
	{"value": "HBYTRCB", "name": "河北玉田农村商业银行"},
	{"value": "HEBYSRCB", "name": "河北元氏农村商业银行"},
	{"value": "HBZQRCB", "name": "河北枣强农村商业银行"},
	{"value": "HBZBRCB", "name": "河北张北农村商业银行"},
	{"value": "HBZDRCB", "name": "河北正定农村商业银行"},
	{"value": "HBZLRCB", "name": "河北涿鹿农村商业银行"},
	{"value": "HBZZRCB", "name": "河北涿州农村商业银行"},
	{"value": "HJRHCUNZB", "name": "河间融惠村镇银行"},
	{"value": "HJSLDCUNZB", "name": "河津市龙都村镇银行"},
	{"value": "HNAYSDRCB", "name": "河南安阳商都农村商业银行"},
	{"value": "HNAYXZRCB", "name": "河南安阳相州农村商业银行"},
	{"value": "HNBFRCB", "name": "河南宝丰农村商业银行"},
	{"value": "HNBJRCB", "name": "河南汴京农村商业银行"},
	{"value": "HNBARCB", "name": "河南博爱农村商业银行"},
	{"value": "HNDFRCB", "name": "河南登封农村商业银行"},
	{"value": "HNDZRCB", "name": "河南邓州农村商业银行"},
	{"value": "HNFXRCB", "name": "河南范县农村商业银行"},
	{"value": "HNFCFYCUNZB", "name": "河南方城凤裕村镇银行"},
	{"value": "HNFGRCB", "name": "河南扶沟农村商业银行"},
	{"value": "HNGYRCB", "name": "河南巩义农村商业银行"},
	{"value": "HNGSRCB", "name": "河南固始农村商业银行"},
	{"value": "HNGSHRCB", "name": "河南光山农村商业银行"},
	{"value": "HNHUAXRCB", "name": "河南滑县农村商业银行"},
	{"value": "HNHBRCB", "name": "河南淮滨农村商业银行"},
	{"value": "HNHCRCB", "name": "河南潢川农村商业银行"},
	{"value": "HNHXRCB", "name": "河南辉县农村商业银行"},
	{"value": "HNHJRCB", "name": "河南获嘉农村商业银行"},
	{"value": "HNJYRCB", "name": "河南济源农村商业银行"},
	{"value": "HNXUNXRCB", "name": "河南浚县农村商业银行"},
	{"value": "HNLKRCB", "name": "河南兰考农村商业银行"},
	{"value": "HNLUSRCB", "name": "河南卢氏农村商业银行"},
	{"value": "HNLUYRCB", "name": "河南鹿邑农村商业银行"},
	{"value": "HNZCMFCUNZB", "name": "河南栾川民丰村镇银行"},
	{"value": "HNLCRCB", "name": "河南栾川农村商业银行"},
	{"value": "HNLUOSRCB", "name": "河南罗山农村商业银行"},
	{"value": "HNLNRCB", "name": "河南洛宁农村商业银行"},
	{"value": "HNMJRCB", "name": "河南孟津农村商业银行"},
	{"value": "HNMZRCB", "name": "河南孟州农村商业银行"},
	{"value": "HNBYRCB", "name": "河南泌阳农村商业银行"},
	{"value": "HNMCRCB", "name": "河南渑池农村商业银行"},
	{"value": "HNMQRCB", "name": "河南民权农村商业银行"},
	{"value": "HNNLRCB", "name": "河南南乐农村商业银行"},
	{"value": "HNNZRCB", "name": "河南南召农村商业银行"},
	{"value": "HNNEIXRCB", "name": "河南内乡农村商业银行"},
	{"value": "HENNXS", "name": "河南省农村信用社联合社"},
	{"value": "HNPYRCB", "name": "河南平舆农村商业银行"},
	{"value": "HNQXRCB", "name": "河南杞县农村商业银行"},
	{"value": "HNQYJNCUNZB", "name": "河南沁阳江南村镇银行"},
	{"value": "HNQINYRCB", "name": "河南沁阳农村商业银行"},
	{"value": "HNQFRCB", "name": "河南清丰农村商业银行"},
	{"value": "HNQSRCB", "name": "河南确山农村商业银行"},
	{"value": "HNNNRCB", "name": "河南汝南农村商业银行"},
	{"value": "HNRNTLCUNZB", "name": "河南汝南泰隆村镇银行"},
	{"value": "HNRYRCB", "name": "河南汝阳农村商业银行"},
	{"value": "HNRZRCB", "name": "河南汝州农村商业银行"},
	{"value": "HNSSRCB", "name": "河南商水农村商业银行"},
	{"value": "HNSSXNSCUNZB", "name": "河南商水厦农商村镇银行"},
	{"value": "HNSCRCB", "name": "河南上蔡农村商业银行"},
	{"value": "HNSHEQRCB", "name": "河南社旗农村商业银行"},
	{"value": "HNSQRCB", "name": "河南沈丘农村商业银行"},
	{"value": "HNSXRCB", "name": "河南嵩县农村商业银行"},
	{"value": "HNSUIPRCB", "name": "河南遂平农村商业银行"},
	{"value": "HNTQRCB", "name": "河南台前农村商行银行"},
	{"value": "HNTKRCB", "name": "河南太康农村商业银行"},
	{"value": "HNTYRCB", "name": "河南汤阴农村商业银行"},
	{"value": "HNTXRCB", "name": "河南通许农村商业银行"},
	{"value": "HNTBRCB", "name": "河南桐柏农村商业银行"},
	{"value": "HNWSRCB", "name": "河南尉氏农村商业银行"},
	{"value": "HNWZRCB", "name": "河南武陟农村商业银行"},
	{"value": "HNWGRCB", "name": "河南舞钢农村商业银行"},
	{"value": "HNXHXNSCUNZB", "name": "河南西华厦农商村镇银行"},
	{"value": "HNXPRCB", "name": "河南西平农村商业银行"},
	{"value": "HNXIXRCB", "name": "河南西峡农村商业银行"},
	{"value": "HENXXRCB", "name": "河南息县农村商业银行"},
	{"value": "HNXIANGCRCB", "name": "河南襄城农村商业银行"},
	{"value": "HENXCRCB", "name": "河南项城农村商业银行"},
	{"value": "HNXARCB", "name": "河南新安农村商业银行"},
	{"value": "HNXCRCB", "name": "河南新蔡农村商业银行"},
	{"value": "HNXMRCB", "name": "河南新密农村商业银行"},
	{"value": "HNXXRCB", "name": "河南新县农村商业银行"},
	{"value": "XXPYRCB", "name": "河南新乡农村商业银行"},
	{"value": "HNXZRCB", "name": "河南新郑农村商业银行"},
	{"value": "HNXWRCB", "name": "河南修武农村商业银行"},
	{"value": "HNXCXDRCB", "name": "河南许昌许都农村商业银行"},
	{"value": "HNYLRCB", "name": "河南鄢陵农村商业银行"},
	{"value": "HENYJRCB", "name": "河南延津农村商业银行"},
	{"value": "HNYSRCB", "name": "河南偃师农村商业银行"},
	{"value": "HNYEXRCB", "name": "河南叶县农村商业银行"},
	{"value": "HNYXTLCUNZB", "name": "河南叶县泰隆村镇银行"},
	{"value": "HNYICRCB", "name": "河南伊川农村商业银行"},
	{"value": "HNYYRCB", "name": "河南宜阳农村商业银行"},
	{"value": "HNYMRCB", "name": "河南义马农村商业银行"},
	{"value": "HNXYRCB", "name": "河南荥阳农村商业银行"},
	{"value": "HNYCRCB", "name": "河南永城农村商业银行"},
	{"value": "HNYYANRCB", "name": "河南原阳农村商业银行"},
	{"value": "HNCGRCB", "name": "河南长葛农村商业银行"},
	{"value": "HNCYRCB", "name": "河南长垣农村商业银行"},
	{"value": "HNZCRCB", "name": "河南柘城农村商业银行"},
	{"value": "HNZPRCB", "name": "河南镇平农村商业银行"},
	{"value": "HNZYRCB", "name": "河南正阳农村商业银行"},
	{"value": "HNZMRCB", "name": "河南中牟农村商业银行"},
	{"value": "HLAZYH", "name": "荷兰安智银行"},
	{"value": "HLHZYH", "name": "荷兰合作银行"},
	{"value": "HZMDBHCUNZB", "name": "菏泽牡丹北海村镇银行"},
	{"value": "HZRCB", "name": "菏泽农村商业银行"},
	{"value": "HZBBDYCUNZB", "name": "贺州八步东盈村镇银行"},
	{"value": "HZFMCUNZB", "name": "赫章富民村镇银行"},
	{"value": "HEBIRCB", "name": "鹤壁农村商业银行"},
	{"value": "HSZJCUNZB", "name": "鹤山珠江村镇银行"},
	{"value": "HHERCB", "name": "黑河农村商业银行"},
	{"value": "HLJBQRCB", "name": "黑龙江宝清农村商业银行"},
	{"value": "HLJBARCB", "name": "黑龙江北安农村商业银行"},
	{"value": "HLJBZRCB", "name": "黑龙江宾州农村商业银行"},
	{"value": "HLJDNRCB", "name": "黑龙江东宁农村商业银行"},
	{"value": "HLJDEBTRCB", "name": "黑龙江杜尔伯特农村商业银行"},
	{"value": "HLJFZRCB", "name": "黑龙江方正农村商业银行"},
	{"value": "HLJFYRCB", "name": "黑龙江抚远农村商业银行"},
	{"value": "HLJFYURCB", "name": "黑龙江富裕农村商业银行"},
	{"value": "HLJGNRCB", "name": "黑龙江甘南农村商业银行"},
	{"value": "HLJHMRCB", "name": "黑龙江呼玛农村商业银行"},
	{"value": "HLJHLRCB", "name": "黑龙江虎林农村商业银行"},
	{"value": "HLJJDRCB", "name": "黑龙江鸡东农村商业银行"},
	{"value": "HLJJIXRCB", "name": "黑龙江鸡西农村商业银行"},
	{"value": "HLJJXRCB", "name": "黑龙江集贤农村商业银行"},
	{"value": "HLJJSJRCB", "name": "黑龙江建三江农村商业银行"},
	{"value": "HLJKDRCB", "name": "黑龙江克东农村商业银行"},
	{"value": "HLJKSRCB", "name": "黑龙江克山农村商业银行"},
	{"value": "HLJLDRCB", "name": "黑龙江林甸农村商业银行"},
	{"value": "HLJLBRCB", "name": "黑龙江萝北农村商业银行"},
	{"value": "HLJMISRCB", "name": "黑龙江密山农村商业银行"},
	{"value": "HLJMSRCB", "name": "黑龙江明水农村商业银行"},
	{"value": "HLJMHRCB", "name": "黑龙江漠河农村商业银行"},
	{"value": "HLJNHRCB", "name": "黑龙江讷河农村商业银行"},
	{"value": "HLJNJRCB", "name": "黑龙江嫩江农村商业银行"},
	{"value": "HLJNXS", "name": "黑龙江省农村信用社联合社"},
	{"value": "HLJRHRCB", "name": "黑龙江饶河农村商业银行"},
	{"value": "HLJSBRCB", "name": "黑龙江绥滨农村商业银行"},
	{"value": "HLJSFHRCB", "name": "黑龙江绥芬河农村商业银行"},
	{"value": "HLJSLRCB", "name": "黑龙江绥棱农村商业银行"},
	{"value": "HLJSWRCB", "name": "黑龙江孙吴农村商业银行"},
	{"value": "HLJTHRCB", "name": "黑龙江塔河农村商业银行"},
	{"value": "HLJTLRCB", "name": "黑龙江泰来农村商业银行"},
	{"value": "HLJTYRCB", "name": "黑龙江汤原农村商业银行"},
	{"value": "HLJTONGHRCB", "name": "黑龙江通河农村商业银行"},
	{"value": "HLJTJRCB", "name": "黑龙江同江农村商业银行"},
	{"value": "HLJWCRCB", "name": "黑龙江五常农村商业银行"},
	{"value": "HLJWDLCRCB", "name": "黑龙江五大连池农村商业银行"},
	{"value": "HLJXKRCB", "name": "黑龙江逊克农村商业银行"},
	{"value": "HLJYSRCB", "name": "黑龙江延寿农村商业银行"},
	{"value": "HLJYYRCB", "name": "黑龙江友谊农村商业银行"},
	{"value": "HLJZYRCB", "name": "黑龙江肇源农村商业银行"},
	{"value": "HLJZZRCB", "name": "黑龙江肇州农村商业银行"},
	{"value": "EGB", "name": "恒丰银行"},
	{"value": "HSB", "name": "恒生银行（中国）有限公司"},
	{"value": "HFHTCUNZB", "name": "横峰恒通村镇银行"},
	{"value": "HNPFCUNZB", "name": "衡南浦发村镇银行"},
	{"value": "HSYH", "name": "衡水银行"},
	{"value": "HSJZFYCUNZB", "name": "衡水冀州丰源村镇银行"},
	{"value": "HYRCB", "name": "衡阳农村商业银行"},
	{"value": "HYXHNSCUNZB", "name": "衡阳县沪农商村镇银行"},
	{"value": "HDXHDCUNZB", "name": "洪洞县洪都村镇银行"},
	{"value": "HHRXCUNZB", "name": "洪湖融兴村镇银行"},
	{"value": "HMSTXCUNZB", "name": "侯马市太行村镇银行"},
	{"value": "HHHTJQHTCUNZB", "name": "呼和浩特金桥河套村镇银行"},
	{"value": "HHHTSRYMYCUNZB", "name": "呼和浩特市如意蒙银村镇银行"},
	{"value": "HHHTSSHJGCUNZB", "name": "呼和浩特市赛罕金谷村镇银行"},
	{"value": "HHHTSSHMYCUNZB", "name": "呼和浩特市赛罕蒙银村镇银行"},
	{"value": "HHHTSXCMYCUNZB", "name": "呼和浩特市新城蒙银村镇银行"},
	{"value": "HHHTSYQMYCUNZB", "name": "呼和浩特市玉泉蒙银村镇银行"},
	{"value": "HLBERCB", "name": "呼伦贝尔农村商业银行"},
	{"value": "HTBJHCUNZB", "name": "呼图壁津汇村镇银行"},
	{"value": "HGXJRCUNZB", "name": "壶关县晋融村镇银行"},
	{"value": "HLDYH", "name": "葫芦岛银行"},
	{"value": "HLDGXCUNZB", "name": "葫芦岛国信村镇银行"},
	{"value": "HLDRCB", "name": "葫芦岛农村商业银行"},
	{"value": "HUBYH", "name": "湖北银行"},
	{"value": "HBALRCB", "name": "湖北安陆农村商业银行"},
	{"value": "HBBDRCB", "name": "湖北巴东农村商业银行"},
	{"value": "HBBKRCB", "name": "湖北保康农村商业银行"},
	{"value": "HBCBRCB", "name": "湖北赤壁农村商业银行"},
	{"value": "HBCBCJCUNZB", "name": "湖北赤壁长江村镇银行"},
	{"value": "HBCYRCB", "name": "湖北崇阳农村商业银行"},
	{"value": "HBDWRCB", "name": "湖北大悟农村商业银行"},
	{"value": "HBDAYRCB", "name": "湖北大冶农村商业银行"},
	{"value": "HBDYTLCUNZB", "name": "湖北大冶泰隆村镇银行"},
	{"value": "HBDJKRCB", "name": "湖北丹江口农村商业银行"},
	{"value": "HBDYRCB", "name": "湖北当阳农村商业银行"},
	{"value": "HBEZRCB", "name": "湖北鄂州农村商业银行"},
	{"value": "HBESRCB", "name": "湖北恩施农村商业银行"},
	{"value": "HBFXRCB", "name": "湖北房县农村商业银行"},
	{"value": "HBGARCB", "name": "湖北公安农村商业银行"},
	{"value": "HBGCRCB", "name": "湖北谷城农村商业银行"},
	{"value": "HBGSRCB", "name": "湖北广水农村商业银行"},
	{"value": "HBHCRCB", "name": "湖北汉川农村商业银行"},
	{"value": "HBHCNYCUNZB", "name": "湖北汉川农银村镇银行"},
	{"value": "HBHFRCB", "name": "湖北鹤峰农村商业银行"},
	{"value": "HBHARCB", "name": "湖北红安农村商业银行"},
	{"value": "HBHACJCUNZB", "name": "湖北红安长江村镇银行"},
	{"value": "HUBHHRCB", "name": "湖北洪湖农村商业银行"},
	{"value": "HBHGRCB", "name": "湖北黄冈农村商业银行"},
	{"value": "HBHMRCB", "name": "湖北黄梅农村商业银行"},
	{"value": "HBJYRCB", "name": "湖北嘉鱼农村商业银行"},
	{"value": "HBJYWJCUNZB", "name": "湖北嘉鱼吴江村镇银行"},
	{"value": "HBJLIRCB", "name": "湖北监利农村商业银行"},
	{"value": "HBJSRCB", "name": "湖北建始农村商业银行"},
	{"value": "HBJLRCB", "name": "湖北江陵农村商业银行"},
	{"value": "HBJINGSRCB", "name": "湖北京山农村商业银行"},
	{"value": "HBJMDDBSCUNZB", "name": "湖北荆门掇刀德通村镇银行"},
	{"value": "HBJMRCB", "name": "湖北荆门农村商业银行"},
	{"value": "HUBJZRCB", "name": "湖北荆州农村商业银行"},
	{"value": "HBLFRCB", "name": "湖北来凤农村商业银行"},
	{"value": "HBLHKRCB", "name": "湖北老河口农村商业银行"},
	{"value": "HUBLCRCB", "name": "湖北利川农村商业银行"},
	{"value": "HBLTRCB", "name": "湖北罗田农村商业银行"},
	{"value": "HBMCHFCUNZB", "name": "湖北麻城汇丰村镇银行"},
	{"value": "HBMCRCB", "name": "湖北麻城农村商业银行"},
	{"value": "HBNZRCB", "name": "湖北南漳农村商业银行"},
	{"value": "HBNXS", "name": "湖北省农村信用社联合社"},
	{"value": "HBQCRCB", "name": "湖北蕲春农村商业银行"},
	{"value": "HBQJRCB", "name": "湖北潜江农村商业银行"},
	{"value": "HBSXIARCB", "name": "湖北三峡农村商业银行"},
	{"value": "HBSYRCB", "name": "湖北沙洋农村商业银行"},
	{"value": "HBSNJRCB", "name": "湖北神农架农村商业银行"},
	{"value": "HBSHIYRCB", "name": "湖北十堰农村商业银行"},
	{"value": "HBSSRCB", "name": "湖北石首农村商业银行"},
	{"value": "HBSZIRCB", "name": "湖北松滋农村商业银行"},
	{"value": "HBSZZDHFCUNZB", "name": "湖北随州曾都汇丰村镇银行"},
	{"value": "HBSZRCB", "name": "湖北随州农村商业银行"},
	{"value": "HBTMHFCUNZB", "name": "湖北天门汇丰村镇银行"},
	{"value": "HBTMRCB", "name": "湖北天门农村商业银行"},
	{"value": "HBTCRCB", "name": "湖北通城农村商业银行"},
	{"value": "HBTONGSRCB", "name": "湖北通山农村商业银行"},
	{"value": "HBTFRCB", "name": "湖北团风农村商业银行"},
	{"value": "HBWFRCB", "name": "湖北五峰农村商业银行"},
	{"value": "HBWDSRCB", "name": "湖北武当山农村商业银行"},
	{"value": "HBWXRCB", "name": "湖北武穴农村商业银行"},
	{"value": "HBXISRCB", "name": "湖北浠水农村商业银行"},
	{"value": "HUBXTRCB", "name": "湖北仙桃农村商业银行"},
	{"value": "HBXAWNSCUNZB", "name": "湖北咸安武农商村镇银行"},
	{"value": "HBXACJCUNZB", "name": "湖北咸安长江村镇银行"},
	{"value": "HBXFRCB", "name": "湖北咸丰农村商业银行"},
	{"value": "HBXNRCB", "name": "湖北咸宁农村商业银行"},
	{"value": "HBXYRCB", "name": "湖北襄阳农村商业银行"},
	{"value": "HBXCRCB", "name": "湖北孝昌农村商业银行"},
	{"value": "HBXGRCB", "name": "湖北孝感农村商业银行"},
	{"value": "HBXSRCB", "name": "湖北兴山农村商业银行"},
	{"value": "HBXERCB", "name": "湖北宣恩农村商业银行"},
	{"value": "HBYXRCB", "name": "湖北阳新农村商业银行"},
	{"value": "HBYICRCB", "name": "湖北宜城农村商业银行"},
	{"value": "HBYDRCB", "name": "湖北宜都农村商业银行"},
	{"value": "HBYSRCB", "name": "湖北英山农村商业银行"},
	{"value": "HBYSCJCUNZB", "name": "湖北英山长江村镇银行"},
	{"value": "HBYCRCB", "name": "湖北应城农村商业银行"},
	{"value": "HBYARCB", "name": "湖北远安农村商业银行"},
	{"value": "HBYMRCB", "name": "湖北云梦农村商业银行"},
	{"value": "HBYXIRCB", "name": "湖北郧西农村商业银行"},
	{"value": "HBYUNXRCB", "name": "湖北郧县农村商业银行"},
	{"value": "HBZYRCB", "name": "湖北枣阳农村商业银行"},
	{"value": "HBCYANRCB", "name": "湖北长阳农村商业银行"},
	{"value": "HBZJRCB", "name": "湖北枝江农村商业银行"},
	{"value": "HBZXRCB", "name": "湖北钟祥农村商业银行"},
	{"value": "HBZSRCB", "name": "湖北竹山农村商业银行"},
	{"value": "HBZXIRCB", "name": "湖北竹溪农村商业银行"},
	{"value": "HBZGRCB", "name": "湖北秭归农村商业银行"},
	{"value": "HKJYCUNZB", "name": "湖口九银村镇银行"},
	{"value": "HNAHRCB", "name": "湖南安化农村商业银行"},
	{"value": "HNAHXHCUNZB", "name": "湖南安化湘淮村镇银行"},
	{"value": "HNARRCB", "name": "湖南安仁农村商业银行"},
	{"value": "HNARXYCUNZB", "name": "湖南安仁新阳村镇银行"},
	{"value": "HNAXRCB", "name": "湖南安乡农村商业银行"},
	{"value": "HUNBJRCB", "name": "湖南保靖农村商业银行"},
	{"value": "HNCLRCB", "name": "湖南茶陵农村商业银行"},
	{"value": "HNCNRCB", "name": "湖南常宁农村商业银行"},
	{"value": "HNCXRCB", "name": "湖南辰溪农村商业银行"},
	{"value": "HNCBRCB", "name": "湖南城步农村商业银行"},
	{"value": "HNCILRCB", "name": "湖南慈利农村商业银行"},
	{"value": "HNDXRCB", "name": "湖南道县农村商业银行"},
	{"value": "HNDXSRCUNZB", "name": "湖南道县神农村镇银行"},
	{"value": "HNDARCB", "name": "湖南东安农村商业银行"},
	{"value": "HNDAXLCUNZB", "name": "湖南东安星龙村镇银行"},
	{"value": "HNDKRCB", "name": "湖南洞口农村商业银行"},
	{"value": "HNDKTNSCUNZB", "name": "湖南洞口潭农商村镇银行"},
	{"value": "HNFHRCB", "name": "湖南凤凰农村商业银行"},
	{"value": "HNGZRCB", "name": "湖南古丈农村商业银行"},
	{"value": "HNGDRCB", "name": "湖南桂东农村商业银行"},
	{"value": "HUNGYRCB", "name": "湖南桂阳农村商业银行"},
	{"value": "HNHANSRCB", "name": "湖南汉寿农村商业银行"},
	{"value": "HNHSXLCUNZB", "name": "湖南汉寿星龙村镇银行"},
	{"value": "HNHDRCB", "name": "湖南衡东农村商业银行"},
	{"value": "HNHDXYCUNZB", "name": "湖南衡东新阳村镇银行"},
	{"value": "HNHNRCB", "name": "湖南衡南农村商业银行"},
	{"value": "HNHSRCB", "name": "湖南衡山农村商业银行"},
	{"value": "HNHSTNSCUNZB", "name": "湖南衡山潭农商村镇银行"},
	{"value": "HNHYHZRCB", "name": "湖南衡阳衡州农村商业银行"},
	{"value": "HUNHJRCB", "name": "湖南洪江农村商业银行"},
	{"value": "HNHYRCB", "name": "湖南花垣农村商业银行"},
	{"value": "HNHRRCB", "name": "湖南华容农村商业银行"},
	{"value": "HNHRXLCUNZB", "name": "湖南华容星龙村镇银行"},
	{"value": "HNHTRCB", "name": "湖南会同农村商业银行"},
	{"value": "HNJISRCB", "name": "湖南吉首农村商业银行"},
	{"value": "HNJHERCB", "name": "湖南嘉禾农村商业银行"},
	{"value": "HNJHRCB", "name": "湖南江华农村商业银行"},
	{"value": "HNJHXYCUNZB", "name": "湖南江华新阳村镇银行"},
	{"value": "HNJYONGRCB", "name": "湖南江永农村商业银行"},
	{"value": "HNJSRCB", "name": "湖南津市农村商业银行"},
	{"value": "HNJSXHCUNZB", "name": "湖南津市湘淮村镇银行"},
	{"value": "HNJZRCB", "name": "湖南靖州农村商业银行"},
	{"value": "HNLANSRCB", "name": "湖南蓝山农村商业银行"},
	{"value": "HNLSSNCUNZB", "name": "湖南蓝山神农村镇银行"},
	{"value": "HNLEIYRCB", "name": "湖南耒阳农村商业银行"},
	{"value": "HNLSJRCB", "name": "湖南冷水江农村商业银行"},
	{"value": "HNLSJXHCUNZB", "name": "湖南冷水江湘淮村镇银行"},
	{"value": "HNLIXRCB", "name": "湖南澧县农村商业银行"},
	{"value": "HNLLRCB", "name": "湖南醴陵农村商业银行"},
	{"value": "HNLYRCB", "name": "湖南涟源农村商业银行"},
	{"value": "HNLLIRCB", "name": "湖南临澧农村商业银行"},
	{"value": "HNLWRCB", "name": "湖南临武农村商业银行"},
	{"value": "HNLXRCB", "name": "湖南临湘农村商业银行"},
	{"value": "HNZYJHCUNZB", "name": "湖南浏阳江淮村镇银行"},
	{"value": "HNLYANGRCB", "name": "湖南浏阳农村商业银行"},
	{"value": "HNLSRCB", "name": "湖南龙山农村商业银行"},
	{"value": "HNLHRCB", "name": "湖南隆回农村商业银行"},
	{"value": "HNLHXJCUNZB", "name": "湖南隆回湘江村镇银行"},
	{"value": "HNLDRCB", "name": "湖南娄底农村商业银行"},
	{"value": "HNLUXRCB", "name": "湖南泸溪农村商业银行"},
	{"value": "HNMYRCB", "name": "湖南麻阳农村商业银行"},
	{"value": "HNMLRCB", "name": "湖南汨罗农村商业银行"},
	{"value": "HNNANXRCB", "name": "湖南南县农村商业银行"},
	{"value": "HNNXXJCUNZB", "name": "湖南南县湘江村镇银行"},
	{"value": "HNNANYRCB", "name": "湖南南岳农村商业银行"},
	{"value": "HNNXRCB", "name": "湖南宁乡农村商业银行"},
	{"value": "HNNYRCB", "name": "湖南宁远农村商业银行"},
	{"value": "HNNYTNSCUNZB", "name": "湖南宁远潭农商村镇银行"},
	{"value": "HUNNXS", "name": "湖南省农村信用社联合社"},
	{"value": "HNPJHFCUNZB", "name": "湖南平江汇丰村镇银行"},
	{"value": "HNPJRCB", "name": "湖南平江农村商业银行"},
	{"value": "HNQDRCB", "name": "湖南祁东农村商业银行"},
	{"value": "HNQYRCB", "name": "湖南祁阳农村商业银行"},
	{"value": "HNRCRCB", "name": "湖南汝城农村商业银行"},
	{"value": "HNRCXYCUNZB", "name": "湖南汝城新阳村镇银行"},
	{"value": "HNSZRCB", "name": "湖南桑植农村商业银行"},
	{"value": "HUNSSRCB", "name": "湖南韶山农村商业银行"},
	{"value": "HNSDRCB", "name": "湖南邵东农村商业银行"},
	{"value": "HNSDXHCUNZB", "name": "湖南邵东湘淮村镇银行"},
	{"value": "HUNSYRCB", "name": "湖南邵阳昭阳农村商业银行"},
	{"value": "HNSYXJCUNZB", "name": "湖南邵阳湘江村镇银行"},
	{"value": "HNSMRCB", "name": "湖南石门农村商业银行"},
	{"value": "HNSFRCB", "name": "湖南双峰农村商业银行"},
	{"value": "HNSPRCB", "name": "湖南双牌农村商业银行"},
	{"value": "HNSNRCB", "name": "湖南绥宁农村商业银行"},
	{"value": "HNTJRCB", "name": "湖南桃江农村商业银行"},
	{"value": "HUNTYRCB", "name": "湖南桃源农村商业银行"},
	{"value": "HNTYXHCUNZB", "name": "湖南桃源湘淮村镇银行"},
	{"value": "HNTDRCB", "name": "湖南通道农村商业银行"},
	{"value": "HUNWGRCB", "name": "湖南武冈农村商业银行"},
	{"value": "HNXJXQRCB", "name": "湖南湘江新区农村商业银行"},
	{"value": "HNXTTYRCB", "name": "湖南湘潭天易农村商业银行"},
	{"value": "HNXTXHCUNZB", "name": "湖南湘潭湘淮村镇银行"},
	{"value": "HUNXXRCB", "name": "湖南湘乡农村商业银行"},
	{"value": "HUNXYRCB", "name": "湖南湘阴农村商业银行"},
	{"value": "HNXYXLCUNZB", "name": "湖南湘阴星龙村镇银行"},
	{"value": "HNXHRCB", "name": "湖南新化农村商业银行"},
	{"value": "HNXHXLCUNZB", "name": "湖南新化星龙村镇银行"},
	{"value": "HNXHUANGRCB", "name": "湖南新晃农村商业银行"},
	{"value": "HNXNRCB", "name": "湖南新宁农村商业银行"},
	{"value": "HNXNTNSCUNZB", "name": "湖南新宁潭农商村镇银行"},
	{"value": "HNXINSRCB", "name": "湖南新邵农村商业银行"},
	{"value": "HNXSXHCUNZB", "name": "湖南新邵湘淮村镇银行"},
	{"value": "HNXTRCB", "name": "湖南新田农村商业银行"},
	{"value": "HNXSRCB", "name": "湖南星沙农村商业银行"},
	{"value": "HUNXPRCB", "name": "湖南溆浦农村商业银行"},
	{"value": "HNXPXJCUNZB", "name": "湖南溆浦湘江村镇银行"},
	{"value": "HUNYANLRCB", "name": "湖南炎陵农村商业银行"},
	{"value": "HNYZRCB", "name": "湖南宜章农村商业银行"},
	{"value": "HUNYSRCB", "name": "湖南永顺农村商业银行"},
	{"value": "HNYXRCB", "name": "湖南永兴农村商业银行"},
	{"value": "HNYOUXRCB", "name": "湖南攸县农村商业银行"},
	{"value": "HNYXTNSCUNZB", "name": "湖南攸县潭农商村镇银行"},
	{"value": "HNYJRCB", "name": "湖南沅江农村商业银行"},
	{"value": "HUNYLRCB", "name": "湖南沅陵农村商业银行"},
	{"value": "HNYLXYCUNZB", "name": "湖南沅陵新阳村镇银行"},
	{"value": "HNYYBLRCB", "name": "湖南岳阳巴陵农村商业银行"},
	{"value": "HUNYYRCB", "name": "湖南岳阳农村商业银行"},
	{"value": "HNYYXJCUNZB", "name": "湖南岳阳湘江村镇银行"},
	{"value": "HNZJRCB", "name": "湖南芷江农村商业银行"},
	{"value": "HNZJXJCUNZB", "name": "湖南芷江湘江村镇银行"},
	{"value": "HNZFRCB", "name": "湖南中方农村商业银行"},
	{"value": "HNZFXYCUNZB", "name": "湖南中方新阳村镇银行"},
	{"value": "HNZZZJRCB", "name": "湖南株洲珠江农村商业银行"},
	{"value": "HNZXRCB", "name": "湖南资兴农村商业银行"},
	{"value": "HUZYH", "name": "湖州银行"},
	{"value": "HZWXRCB", "name": "湖州吴兴农村商业银行"},
	{"value": "CITIBANK", "name": "花旗银行"},
	{"value": "EASTWESTBANK", "name": "华美银行"},
	{"value": "HNCCB", "name": "华南商业银行"},
	{"value": "OCBC", "name": "华侨永亨银行（中国）有限公司"},
	{"value": "HRXJYH", "name": "华融湘江银行"},
	{"value": "CMBCN", "name": "华商银行"},
	{"value": "HXB", "name": "华夏银行"},
	{"value": "COB", "name": "华一银行"},
	{"value": "HDBSCUNZB", "name": "化德蒙商村镇银行"},
	{"value": "ZCRXCUNZB", "name": "桦川融兴村镇银行"},
	{"value": "ZDHMCUNZB", "name": "桦甸惠民村镇银行"},
	{"value": "ZNRXCUNZB", "name": "桦南融兴村镇银行"},
	{"value": "HHRCB", "name": "怀化农村商业银行"},
	{"value": "HLLFCUNZB", "name": "怀来利丰村镇银行"},
	{"value": "HRXRHCUNZB", "name": "怀仁县慧融村镇银行"},
	{"value": "HBRCB", "name": "淮北农村商业银行"},
	{"value": "HNHHRCB", "name": "淮南淮河农村商业银行"},
	{"value": "HNTSRCB", "name": "淮南通商农村商业银行"},
	{"value": "HTQLCUNZB", "name": "桓台青隆村镇银行"},
	{"value": "HZQLCUNZB", "name": "黄骅青隆村镇银行"},
	{"value": "HPZXCUNZB", "name": "黄平振兴村镇银行"},
	{"value": "HSHZRCB", "name": "黄山徽州农村商业银行"},
	{"value": "HSTPRCB", "name": "黄山太平农村商业银行"},
	{"value": "HSTXRCB", "name": "黄山屯溪农村商业银行"},
	{"value": "HSRCB", "name": "黄石农村商业银行"},
	{"value": "ZCJYCUNZB", "name": "珲春吉银村镇银行"},
	{"value": "HNYYCUNZB", "name": "辉南榆银村镇银行"},
	{"value": "HXZJCUNZB", "name": "辉县珠江村镇银行"},
	{"value": "AHCB", "name": "徽商银行"},
	{"value": "HFB", "name": "汇丰银行（中国）有限公司"},
	{"value": "HNHSCUNZB", "name": "会宁会师村镇银行"},
	{"value": "HAZCCUNZB", "name": "惠安中成村镇银行"},
	{"value": "HDHMCUNZB", "name": "惠东惠民村镇银行"},
	{"value": "HSHSCUNZB", "name": "惠水恒升村镇银行"},
	{"value": "HZBLCJCUNZB", "name": "惠州博罗长江村镇银行"},
	{"value": "HZZZDYCUNZB", "name": "惠州仲恺东盈村镇银行"},
	{"value": "HYXHRCUNZB", "name": "浑源县慧融村镇银行"},
	{"value": "HLGLMYCUNZB", "name": "霍林郭勒蒙银村镇银行"},
	{"value": "JACZCUNZB", "name": "吉安稠州村镇银行"},
	{"value": "JARCB", "name": "吉安农村商业银行"},
	{"value": "JLYH", "name": "吉林银行"},
	{"value": "JLATRCB", "name": "吉林安图农村商业银行"},
	{"value": "JLCYYYCUNZB", "name": "吉林昌邑榆银村镇银行"},
	{"value": "JLCYHMCUNZB", "name": "吉林船营惠民村镇银行"},
	{"value": "JLCCRCB", "name": "吉林春城农村商业银行"},
	{"value": "JLDARCB", "name": "吉林大安农村商业银行"},
	{"value": "JLHDNCYH", "name": "吉林德惠农村商业银行"},
	{"value": "JLDFRCB", "name": "吉林东丰农村商业银行"},
	{"value": "JLDHRCB", "name": "吉林敦化农村商业银行"},
	{"value": "JLFMHMCUNZB", "name": "吉林丰满惠民村镇银行"},
	{"value": "JLGZLRCB", "name": "吉林公主岭农村商业银行"},
	{"value": "JLGELSRCB", "name": "吉林郭尔罗斯农村商业银行"},
	{"value": "JLHLRCB", "name": "吉林和龙农村商业银行"},
	{"value": "JLHDRCB", "name": "吉林桦甸农村商业银行"},
	{"value": "JLHCRCB", "name": "吉林环城农村商业银行"},
	{"value": "JLHCHUNRCB", "name": "吉林珲春农村商业银行"},
	{"value": "JLHNRCB", "name": "吉林辉南农村商业银行"},
	{"value": "JLHJRCB", "name": "吉林浑江农村商业银行"},
	{"value": "JLJARCB", "name": "吉林集安农村商业银行"},
	{"value": "JLJHRCB", "name": "吉林蛟河农村商业银行"},
	{"value": "JLJYRCB", "name": "吉林靖宇农村商业银行"},
	{"value": "JLJTRCB", "name": "吉林九台农村商业银行"},
	{"value": "JLLJRCB", "name": "吉林临江农村商业银行"},
	{"value": "JLLHRCB", "name": "吉林柳河农村商业银行"},
	{"value": "JLLONGJRCB", "name": "吉林龙井农村商业银行"},
	{"value": "JLLTHYCUNZB", "name": "吉林龙潭华益村镇银行"},
	{"value": "JLNARCB", "name": "吉林农安农村商业银行"},
	{"value": "JLNXS", "name": "吉林省农村信用社联合社"},
	{"value": "JLPSRCB", "name": "吉林磐石农村商业银行"},
	{"value": "JLSLRCB", "name": "吉林舒兰农村商业银行"},
	{"value": "JLSYRCB", "name": "吉林双阳农村商业银行"},
	{"value": "JLTHHKRCB", "name": "吉林通化海科农村商业银行"},
	{"value": "JLWQRCB", "name": "吉林汪清农村商业银行"},
	{"value": "JLYLYH", "name": "吉林亿联银行"},
	{"value": "JLYJRCB", "name": "吉林永吉农村商业银行"},
	{"value": "JLYSRCB", "name": "吉林榆树农村商业银行"},
	{"value": "JLZLRCB", "name": "吉林镇赉农村商业银行"},
	{"value": "JSLLCUNZB", "name": "吉水庐陵村镇银行"},
	{"value": "JXXTCUNZB", "name": "吉县新田村镇银行"},
	{"value": "JZZJCUNZB", "name": "吉州珠江村镇银行"},
	{"value": "JAHZCUNZB", "name": "集安惠鑫村镇银行"},
	{"value": "JXRSCUNZB", "name": "集贤润生村镇银行"},
	{"value": "CHIYUBANK", "name": "集友银行有限公司"},
	{"value": "JNGXBHCUNZB", "name": "济南高新北海村镇银行"},
	{"value": "JNHYHNSCUNZB", "name": "济南槐荫沪农商村镇银行"},
	{"value": "JNRCB", "name": "济南农村商业银行"},
	{"value": "JNCQHNSCUNZB", "name": "济南长清沪农商村镇银行"},
	{"value": "JNYH", "name": "济宁银行"},
	{"value": "JNGXCUNZB", "name": "济宁高新村镇银行"},
	{"value": "JNLHCUNZB", "name": "济宁蓝海村镇银行"},
	{"value": "JNINGRCB", "name": "济宁农村商业银行"},
	{"value": "JNRSCUNZB", "name": "济宁儒商村镇银行"},
	{"value": "JYBHCUNZB", "name": "济阳北海村镇银行"},
	{"value": "JYQLCUNZB", "name": "济源齐鲁村镇银行"},
	{"value": "JSXHDCUNZB", "name": "稷山县河东村镇银行"},
	{"value": "SCTABK", "name": "加拿大丰业银行"},
	{"value": "JXCCB", "name": "嘉兴银行"},
	{"value": "JYGRCB", "name": "嘉峪关农村商业银行"},
	{"value": "ZXGTCUNZB", "name": "郏县广天村镇银行"},
	{"value": "QWZCCUNZB", "name": "犍为中成村镇银行"},
	{"value": "JCHCCUNZB", "name": "建昌恒昌村镇银行"},
	{"value": "CCB", "name": "中国建设银行"},
	{"value": "JHZCCUNZB", "name": "建湖中成村镇银行"},
	{"value": "JNCTHCUNZB", "name": "建宁刺桐红村镇银行"},
	{"value": "JPHSCUNZB", "name": "建平红山村镇银行"},
	{"value": "JSHNSCUNZB", "name": "建水沪农商村镇银行"},
	{"value": "JHFMCUNZB", "name": "剑河富民村镇银行"},
	{"value": "JKCZCUNZB", "name": "江口长征村镇银行"},
	{"value": "JLCNSCUNZB", "name": "江陵楚农商村镇银行"},
	{"value": "JMKPCJCUNZB", "name": "江门开平长江村镇银行"},
	{"value": "JMRCB", "name": "江门农村商业银行"},
	{"value": "JMXHXHCUNZB", "name": "江门新会新华村镇银行"},
	{"value": "JSBCHINA", "name": "江苏银行"},
	{"value": "JSBYJCCUNZB", "name": "江苏宝应锦程村镇银行"},
	{"value": "JSBYRCB", "name": "江苏宝应农村商业银行"},
	{"value": "JSBHRCB", "name": "江苏滨海农村商业银行"},
	{"value": "CSRCB", "name": "江苏常熟农村商业银行"},
	{"value": "JSDFJNCUNZB", "name": "江苏大丰江南村镇银行"},
	{"value": "JSDFRCB", "name": "江苏大丰农村商业银行"},
	{"value": "JSDTMYCUNZB", "name": "江苏丹徒蒙银村镇银行"},
	{"value": "JSDYBDCUNZB", "name": "江苏丹阳苏银村镇银行"},
	{"value": "JSDYRCB", "name": "江苏丹阳农村商业银行"},
	{"value": "JSDHRCB", "name": "江苏东海农村商业银行"},
	{"value": "JSDHZNSCUNZB", "name": "江苏东海张农商村镇银行"},
	{"value": "JSDTCZCUNZB", "name": "江苏东台稠州村镇银行"},
	{"value": "JSDTRCB", "name": "江苏东台农村商业银行"},
	{"value": "JSFXMFCUNZB", "name": "江苏丰县民丰村镇银行"},
	{"value": "JSFXRCB", "name": "江苏丰县农村商业银行"},
	{"value": "JSFNRCB", "name": "江苏阜宁农村商业银行"},
	{"value": "JSGYRCB", "name": "江苏赣榆农村商业银行"},
	{"value": "JSGYTSCUNZB", "name": "江苏赣榆通商村镇银行"},
	{"value": "JSGCRCB", "name": "江苏高淳农村商业银行"},
	{"value": "JSGAOYRCB", "name": "江苏高邮农村商业银行"},
	{"value": "JSGNMFCUNZB", "name": "江苏灌南民丰村镇银行"},
	{"value": "JSGNRCB", "name": "江苏灌南农村商业银行"},
	{"value": "JSGYMFCUNZB", "name": "江苏灌云民丰村镇银行"},
	{"value": "JSGYUNRCB", "name": "江苏灌云农村商业银行"},
	{"value": "HARCB", "name": "江苏海安农村商业银行"},
	{"value": "JSHAYHCUNZB", "name": "江苏海安盐海村镇银行"},
	{"value": "JSHMRCB", "name": "江苏海门农村商业银行"},
	{"value": "JSZJLHCUNZB", "name": "江苏邗江联合村镇银行"},
	{"value": "JSZJMTCUNZB", "name": "江苏邗江民泰村镇银行"},
	{"value": "HZJYGCUNZB", "name": "江苏洪泽金阳光村镇银行"},
	{"value": "JSHZRCB", "name": "江苏洪泽农村商业银行"},
	{"value": "HAGDCUNZB", "name": "江苏淮安光大村镇银行"},
	{"value": "JSHARCB", "name": "江苏淮安农村商业银行"},
	{"value": "JSHSMTCUNZB", "name": "江苏惠山民泰村镇银行"},
	{"value": "JSJIANHRCB", "name": "江苏建湖农村商业银行"},
	{"value": "JSJDJYCUNZB", "name": "江苏江都吉银村镇银行"},
	{"value": "JSJDRCB", "name": "江苏江都农村商业银行"},
	{"value": "JSJNRCB", "name": "江苏江南农村商业银行"},
	{"value": "JSJNSYCUNZB", "name": "江苏江宁上银村镇银行"},
	{"value": "JSJYRCB", "name": "江苏江阴农村商业银行"},
	{"value": "JSJYANRCB", "name": "江苏姜堰农村商业银行"},
	{"value": "JHMTCUNZB", "name": "江苏金湖民泰村镇银行"},
	{"value": "JSJHRCB", "name": "江苏金湖农村商业银行"},
	{"value": "JSJJRCB", "name": "江苏靖江农村商业银行"},
	{"value": "JSJJRFCUNZB", "name": "江苏靖江润丰村镇银行"},
	{"value": "JSJRRCB", "name": "江苏句容农村商业银行"},
	{"value": "KSRCB", "name": "江苏昆山农村商业银行"},
	{"value": "JSZSMFCUNZB", "name": "江苏溧水民丰村镇银行"},
	{"value": "JSLSRCB", "name": "江苏溧水农村商业银行"},
	{"value": "JSLIANSRCB", "name": "江苏涟水农村商业银行"},
	{"value": "LSTSCUNZB", "name": "江苏涟水太商村镇银行"},
	{"value": "JSMFRCB", "name": "江苏民丰农村商业银行"},
	{"value": "JSNTRCB", "name": "江苏南通农村商业银行"},
	{"value": "JSNTRGBSCUNZB", "name": "南通如皋润泽村镇银行"},
	{"value": "JSNXS", "name": "江苏省农村信用社联合社"},
	{"value": "JSPXHYCUNZB", "name": "江苏沛县汉源村镇银行"},
	{"value": "JSPXRCB", "name": "江苏沛县农村商业银行"},
	{"value": "JSZZLHCUNZB", "name": "江苏邳州陇海村镇银行"},
	{"value": "JSPZRCB", "name": "江苏邳州农村商业银行"},
	{"value": "JSQDRCB", "name": "江苏启东农村商业银行"},
	{"value": "JSQDZJCUNZB", "name": "江苏启东珠江村镇银行"},
	{"value": "JSRDRCB", "name": "江苏如东农村商业银行"},
	{"value": "JSRDRXCUNZB", "name": "江苏如东融兴村镇银行"},
	{"value": "JSRGRCB", "name": "江苏如皋农村商业银行"},
	{"value": "JSSYRCB", "name": "江苏射阳农村商业银行"},
	{"value": "JSSYTSCUNZB", "name": "江苏射阳太商村镇银行"},
	{"value": "JSSYDWCUNZB", "name": "江苏沭阳东吴村镇银行"},
	{"value": "JSSHUYRCB", "name": "江苏沭阳农村商业银行"},
	{"value": "JSSHDWCUNZB", "name": "江苏泗洪东吴村镇银行"},
	{"value": "JSSHRCB", "name": "江苏泗洪农村商业银行"},
	{"value": "JSSIYDWCUNZB", "name": "江苏泗阳东吴村镇银行"},
	{"value": "JSSIYRCB", "name": "江苏泗阳农村商业银行"},
	{"value": "SUNINGBANK", "name": "江苏苏商银行"},
	{"value": "JSSNRCB", "name": "江苏睢宁农村商业银行"},
	{"value": "JSTXRCB", "name": "江苏泰兴农村商业银行"},
	{"value": "JSTZRCB", "name": "江苏泰州农村商业银行"},
	{"value": "JSTZHSCUNZB", "name": "江苏通州华商村镇银行"},
	{"value": "JSTSXZCUNZB", "name": "江苏铜山锡州村镇银行"},
	{"value": "JSXSRCB", "name": "江苏响水农村商业银行"},
	{"value": "JSXYHYCUNZB", "name": "江苏新沂汉源村镇银行"},
	{"value": "JSXINYRCB", "name": "江苏新沂农村商业银行"},
	{"value": "JSXHRCB", "name": "江苏兴化农村商业银行"},
	{"value": "JSSUYDWCUNZB", "name": "江苏宿豫东吴村镇银行"},
	{"value": "JSXYRCB", "name": "江苏盱眙农村商业银行"},
	{"value": "XYZJCUNZB", "name": "江苏盱眙珠江村镇银行"},
	{"value": "JSYCRCB", "name": "江苏盐城农村商业银行"},
	{"value": "JSYANGZRCB", "name": "江苏扬中农村商业银行"},
	{"value": "JISYZRCB", "name": "江苏扬州农村商业银行"},
	{"value": "JSYZBSCUNZB", "name": "扬州仪征玉丰村镇银行"},
	{"value": "JSYZRCB", "name": "江苏仪征农村商业银行"},
	{"value": "JSYXRCB", "name": "江苏宜兴农村商业银行"},
	{"value": "JSZJGRCB", "name": "江苏张家港农村商业银行"},
	{"value": "JSZJGYNSCUNZB", "name": "江苏张家港渝农商村镇银行"},
	{"value": "JSCJCCB", "name": "江苏长江商业银行"},
	{"value": "JSZJRCB", "name": "江苏镇江农村商业银行"},
	{"value": "JSZIJRCB", "name": "江苏紫金农村商业银行"},
	{"value": "NCYH", "name": "江西银行(南昌银行)"},
	{"value": "JXAFRCB", "name": "江西安福农村商业银行"},
	{"value": "JXAYIRCB", "name": "江西安义农村商业银行"},
	{"value": "JXAYRCB", "name": "江西安远农村商业银行"},
	{"value": "JXCRRCB", "name": "江西崇仁农村商业银行"},
	{"value": "JXDYRCB", "name": "江西大余农村商业银行"},
	{"value": "JXDEXRCB", "name": "江西德兴农村商业银行"},
	{"value": "JXDNRCB", "name": "江西定南农村商业银行"},
	{"value": "JXDXRCB", "name": "江西东乡农村商业银行"},
	{"value": "JXDCRCB", "name": "江西都昌农村商业银行"},
	{"value": "JXFCRCB", "name": "江西丰城农村商业银行"},
	{"value": "JXFXRCB", "name": "江西奉新农村商业银行"},
	{"value": "JXGANCRCB", "name": "江西赣昌农村商业银行"},
	{"value": "JXGXRCB", "name": "江西赣县农村商业银行"},
	{"value": "GZYZCUNZB", "name": "江西赣州银座村镇银行"},
	{"value": "JXGAFMCUNZB", "name": "江西高安富民村镇银行"},
	{"value": "JXGARCB", "name": "江西高安农村商业银行"},
	{"value": "JXGCRCB", "name": "江西广昌农村商业银行"},
	{"value": "JXGFRCB", "name": "江西广丰农村商业银行"},
	{"value": "JXGXINRCB", "name": "江西广信农村商业银行"},
	{"value": "JXHFRCB", "name": "江西横峰农村商业银行"},
	{"value": "JXHKRCB", "name": "江西湖口农村商业银行"},
	{"value": "JXHCRCB", "name": "江西会昌农村商业银行"},
	{"value": "JXJSRCB", "name": "江西吉水农村商业银行"},
	{"value": "JXJZRCB", "name": "江西江州农村商业银行"},
	{"value": "JXJXIRCB", "name": "江西金溪农村商业银行"},
	{"value": "JXJXRCB", "name": "江西进贤农村商业银行"},
	{"value": "JXJGSRCB", "name": "江西井冈山农村商业银行"},
	{"value": "JXJARCB", "name": "江西靖安农村商业银行"},
	{"value": "JXLARCB", "name": "江西乐安农村商业银行"},
	{"value": "JXLCRCB", "name": "江西黎川农村商业银行"},
	{"value": "JXLHFMCUNZB", "name": "江西莲花富民村镇银行"},
	{"value": "JXLHRCB", "name": "江西莲花农村商业银行"},
	{"value": "JXLNRCB", "name": "江西龙南农村商业银行"},
	{"value": "JXLXFMCUNZB", "name": "江西芦溪富民村镇银行"},
	{"value": "JXLXRCB", "name": "江西芦溪农村商业银行"},
	{"value": "JXLLRCB", "name": "江西庐陵农村商业银行"},
	{"value": "JXLSRCB", "name": "江西庐山农村商业银行"},
	{"value": "JXNCRCB", "name": "江西南城农村商业银行"},
	{"value": "JXNFRCB", "name": "江西南丰农村商业银行"},
	{"value": "JXNDRCB", "name": "江西宁都农村商业银行"},
	{"value": "JXNXS", "name": "江西省农村信用社联合社"},
	{"value": "JXPZRCB", "name": "江西彭泽农村商业银行"},
	{"value": "JXPYRCB", "name": "江西鄱阳农村商业银行"},
	{"value": "JXQSRCB", "name": "江西铅山农村商业银行"},
	{"value": "JXQNRCB", "name": "江西全南农村商业银行"},
	{"value": "JXRCRCB", "name": "江西瑞昌农村商业银行"},
	{"value": "JXRJGDCUNZB", "name": "江西瑞金光大村镇银行"},
	{"value": "JXRJRCB", "name": "江西瑞金农村商业银行"},
	{"value": "JXSGFMCUNZB", "name": "江西上高富民村镇银行"},
	{"value": "JXSGRCB", "name": "江西上高农村商业银行"},
	{"value": "JXSLFMCUNZB", "name": "江西上栗富民村镇银行"},
	{"value": "JXSLRCB", "name": "江西上栗农村商业银行"},
	{"value": "JXSYRCB", "name": "江西上犹农村商业银行"},
	{"value": "JXSCRCB", "name": "江西石城农村商业银行"},
	{"value": "JXSUICRCB", "name": "江西遂川农村商业银行"},
	{"value": "JXTHRCB", "name": "江西泰和农村商业银行"},
	{"value": "JXTGRCB", "name": "江西铜鼓农村商业银行"},
	{"value": "JXWLRCB", "name": "江西湾里农村商业银行"},
	{"value": "JXWARCB", "name": "江西万安农村商业银行"},
	{"value": "JXWNRCB", "name": "江西万年农村商业银行"},
	{"value": "JXWZRCB", "name": "江西万载农村商业银行"},
	{"value": "JXWUNRCB", "name": "江西武宁农村商业银行"},
	{"value": "JXZYJHCUNZB", "name": "江西婺源江淮村镇银行"},
	{"value": "JXWYRCB", "name": "江西婺源农村商业银行"},
	{"value": "JXXJRCB", "name": "江西峡江农村商业银行"},
	{"value": "JXXGANRCB", "name": "江西新干农村商业银行"},
	{"value": "JXXINJRCB", "name": "江西新建农村商业银行"},
	{"value": "JXXFRCB", "name": "江西信丰农村商业银行"},
	{"value": "JXXZJHCUNZB", "name": "江西信州江淮村镇银行"},
	{"value": "JXXGRCB", "name": "江西兴国农村商业银行"},
	{"value": "JXXGXHCUNZB", "name": "江西兴国新华村镇银行"},
	{"value": "JXXSRCB", "name": "江西修水农村商业银行"},
	{"value": "JXXWRCB", "name": "江西寻乌农村商业银行"},
	{"value": "JXYIFRCB", "name": "江西宜丰农村商业银行"},
	{"value": "JXYHRCB", "name": "江西宜黄农村商业银行"},
	{"value": "JXYYRCB", "name": "江西弋阳农村商业银行"},
	{"value": "JXYFRCB", "name": "江西永丰农村商业银行"},
	{"value": "JXYXRCB", "name": "江西永新农村商业银行"},
	{"value": "JXYXIURCB", "name": "江西永修农村商业银行"},
	{"value": "JXYDRCB", "name": "江西于都农村商业银行"},
	{"value": "JXYGRCB", "name": "江西余干农村商业银行"},
	{"value": "JXYSRCB", "name": "江西玉山农村商业银行"},
	{"value": "YMBANK", "name": "江西裕民银行"},
	{"value": "JXZSRCB", "name": "江西樟树农村商业银行"},
	{"value": "JXZXRCB", "name": "江西资溪农村商业银行"},
	{"value": "JYPFCUNZB", "name": "江阴浦发村镇银行"},
	{"value": "JCXTXCUNZB", "name": "交城县太行村镇银行"},
	{"value": "JKXRDCUNZB", "name": "交口县融都村镇银行"},
	{"value": "BOCO", "name": "交通银行"},
	{"value": "ZHJYCUNZB", "name": "蛟河吉银村镇银行"},
	{"value": "JZJFRCB", "name": "焦作解放农村商业银行"},
	{"value": "JZSCCB", "name": "焦作中旅银行"},
	{"value": "JXSHDCUNZB", "name": "介休市华都村镇银行"},
	{"value": "JINCRCB", "name": "金昌农村商业银行"},
	{"value": "JHYH", "name": "金华银行"},
	{"value": "JSFMCUNZB", "name": "金沙富民村镇银行"},
	{"value": "JTHJCUNZB", "name": "金堂汇金村镇银行"},
	{"value": "JXFSCUNZB", "name": "金溪抚商村镇银行"},
	{"value": "JZHYCUNZB", "name": "金寨徽银村镇银行"},
	{"value": "JINZYH", "name": "锦州银行"},
	{"value": "JZRCB", "name": "锦州农村商业银行"},
	{"value": "JZSSNSCUNZB", "name": "锦州松山农商村镇银行"},
	{"value": "JZTHJYCUNZB", "name": "锦州太和锦银村镇银行"},
	{"value": "EXIMBANK", "name": "中国进出口银行"},
	{"value": "JXRFCUNZB", "name": "进贤瑞丰村镇银行"},
	{"value": "JCRCB", "name": "晋城农村商业银行"},
	{"value": "JSYH", "name": "晋商银行"},
	{"value": "JZKFQRCB", "name": "晋中开发区农村商业银行"},
	{"value": "JZSYCRXCUNZB", "name": "晋中市榆次融信村镇银行"},
	{"value": "JZSZQHFCUNZB", "name": "晋中市左权华丰村镇银行"},
	{"value": "JZHSCUNZB", "name": "晋州恒升村镇银行"},
	{"value": "JMDBHMCUNZB", "name": "荆门东宝惠民村镇银行"},
	{"value": "SDMSCUNZB", "name": "旌德民商村镇银行"},
	{"value": "JGSJYCUNZB", "name": "井冈山九银村镇银行"},
	{"value": "JDZCJJYCUNZB", "name": "景德镇昌江九银村镇银行"},
	{"value": "JDZRCB", "name": "景德镇农村商业银行"},
	{"value": "JHMSCUNZB", "name": "景洪民生村镇银行"},
	{"value": "JXFYCUNZB", "name": "景县丰源村镇银行"},
	{"value": "JAJYCUNZB", "name": "靖安九银村镇银行"},
	{"value": "JYQFCUNZB", "name": "靖宇乾丰村镇银行"},
	{"value": "JJYH", "name": "九江银行"},
	{"value": "JJGQCUNZB", "name": "九江共青村镇银行"},
	{"value": "JJHTCUNZB", "name": "九江恒通村镇银行"},
	{"value": "JJLSZYCUNZB", "name": "九江庐山浔银村镇银行"},
	{"value": "JJRCB", "name": "九江农村商业银行"},
	{"value": "JTLJCUNZB", "name": "九台龙嘉村镇银行"},
	{"value": "JQRCB", "name": "酒泉农村商业银行"},
	{"value": "JXJGCUNZB", "name": "莒县金谷村镇银行"},
	{"value": "JLRXCUNZB", "name": "巨鹿融信村镇银行"},
	{"value": "JRSNCUNZB", "name": "句容苏南村镇银行"},
	{"value": "YCBSCUNZB", "name": "鄄城牡丹村镇银行"},
	{"value": "ZLZCCUNZB", "name": "筠连中成村镇银行"},
	{"value": "JXZYCUNZB", "name": "浚县郑银村镇银行"},
	{"value": "KLQYLCUNZB", "name": "喀喇沁玉龙村镇银行"},
	{"value": "KFSDRCB", "name": "开封宋都农村商业银行"},
	{"value": "KFXDFCUNZB", "name": "开封新东方村镇银行"},
	{"value": "KLMYCUNZB", "name": "开鲁蒙银村镇银行"},
	{"value": "KASIKORNBANK", "name": "开泰银行"},
	{"value": "KXTYCUNZB", "name": "重庆开州泰业村镇银行"},
	{"value": "KYFMCUNZB", "name": "开阳富民村镇银行"},
	{"value": "KYXYSCUNZB", "name": "开原象牙山村镇银行"},
	{"value": "KYHNSCUNZB", "name": "开远沪农商村镇银行"},
	{"value": "KLDNCUNZB", "name": "凯里东南村镇银行"},
	{"value": "KBYFCUNZB", "name": "康保银丰村镇银行"},
	{"value": "KLMYJLGMCUNZB", "name": "克拉玛依金龙国民村镇银行"},
	{"value": "KSRSCUNZB", "name": "克山润生村镇银行"},
	{"value": "KLLACUNZB", "name": "垦利乐安村镇银行"},
	{"value": "KCGMCUNZB", "name": "库车国民村镇银行"},
	{"value": "KELSCCB", "name": "库尔勒市商业银行"},
	{"value": "KCRXCUNZB", "name": "宽城融兴村镇银行"},
	{"value": "KDBFCUNZB", "name": "宽甸百丰村镇银行"},
	{"value": "KTGMCUNZB", "name": "奎屯国民村镇银行"},
	{"value": "KLYH", "name": "昆仑银行"},
	{"value": "KMALHNSCUNZB", "name": "昆明官渡沪农商村镇银行"},
	{"value": "KMCGHXCUNZB", "name": "昆明呈贡华夏村镇银行"},
	{"value": "KMDCZCCUNZB", "name": "昆明东川中成村镇银行"},
	{"value": "KMGDRCU", "name": "昆明官渡农村合作银行"},
	{"value": "KMJNRFCUNZB", "name": "昆明晋宁融丰村镇银行"},
	{"value": "KMLQZCCUNZB", "name": "昆明禄劝中成村镇银行"},
	{"value": "KMMJPZCCUNZB", "name": "昆明马金铺中成村镇银行"},
	{"value": "KMSLZCCUNZB", "name": "昆明石林中成村镇银行"},
	{"value": "KMWHCJCUNZB", "name": "昆明五华长江村镇银行"},
	{"value": "KMYLRFCUNZB", "name": "昆明宜良融丰村镇银行"},
	{"value": "KSLCCUNZB", "name": "昆山鹿城村镇银行"},
	{"value": "LBXZCJCUNZB", "name": "来宾象州长江村镇银行"},
	{"value": "ISBC", "name": "莱商银行"},
	{"value": "LWZCCUNZB", "name": "莱芜中成村镇银行"},
	{"value": "LWZJCUNZB", "name": "莱芜珠江村镇银行"},
	{"value": "LYJDCUNZB", "name": "莱阳胶东村镇银行"},
	{"value": "LZZJCUNZB", "name": "莱州珠江村镇银行"},
	{"value": "ZSLFCUNZB", "name": "涞水利丰村镇银行"},
	{"value": "LKQLCUNZB", "name": "兰考齐鲁村镇银行"},
	{"value": "LXNSCUNZB", "name": "兰西农商村镇银行"},
	{"value": "LZYH", "name": "兰州银行"},
	{"value": "LZANSZCUNZB", "name": "兰州安宁神舟村镇银行"},
	{"value": "LZGLXHCUNZB", "name": "兰州皋兰新华村镇银行"},
	{"value": "LZRCB", "name": "兰州农村商业银行"},
	{"value": "LZQLHXHCUNZB", "name": "兰州七里河新华村镇银行"},
	{"value": "LZYDXHCUNZB", "name": "兰州永登新华村镇银行"},
	{"value": "ZXHRCUNZB", "name": "岚县慧融村镇银行"},
	{"value": "ZZRXCUNZB", "name": "阆中融兴村镇银行"},
	{"value": "LFYH", "name": "廊坊银行"},
	{"value": "LFKFQRSCUNZB", "name": "廊坊开发区融商村镇银行"},
	{"value": "LFSACQHMCUNZB", "name": "廊坊市安次区惠民村镇银行"},
	{"value": "LFSGYSFCUNZB", "name": "廊坊市广阳舜丰村镇银行"},
	{"value": "LAHDCUNZB", "name": "乐安洪都村镇银行"},
	{"value": "LDHFCUNZB", "name": "乐东惠丰村镇银行"},
	{"value": "LLYRCUNZB", "name": "乐陵圆融村镇银行"},
	{"value": "LPRXCUNZB", "name": "乐平融兴村镇银行"},
	{"value": "LSSCCB", "name": "乐山市商业银行"},
	{"value": "LSJZMFCUNZB", "name": "乐山嘉州民富村镇银行"},
	{"value": "LSKLCUNZB", "name": "乐山昆仑村镇银行"},
	{"value": "LSSJRCB", "name": "乐山三江农村商业银行"},
	{"value": "LTSFCUNZB", "name": "乐亭舜丰村镇银行"},
	{"value": "LZHMCUNZB", "name": "雷州惠民村镇银行"},
	{"value": "LYRXCUNZB", "name": "耒阳融兴村镇银行"},
	{"value": "LSYTCUNZB", "name": "梨树源泰村镇银行"},
	{"value": "LCFSCUNZB", "name": "黎川抚商村镇银行"},
	{"value": "ZXHNSCUNZB", "name": "澧县沪农商村镇银行"},
	{"value": "ZLHNSCUNZB", "name": "醴陵沪农商村镇银行"},
	{"value": "LJGCFDCUNZB", "name": "丽江古城富滇村镇银行"},
	{"value": "LJGCRCB", "name": "丽江古城农村商业银行"},
	{"value": "LJYSCJCUNZB", "name": "丽江永胜长江村镇银行"},
	{"value": "LJYLCJCUNZB", "name": "丽江玉龙长江村镇银行"},
	{"value": "LBFMCUNZB", "name": "荔波富民村镇银行"},
	{"value": "ZYPFCUNZB", "name": "溧阳浦发村镇银行"},
	{"value": "LYGDFRCB", "name": "连云港东方农村商业银行"},
	{"value": "LYHNSCUNZB", "name": "涟源沪农商村镇银行"},
	{"value": "LCXWLTCUNZB", "name": "凉城县乌拉特村镇银行"},
	{"value": "LSRCB", "name": "凉山农村商业银行"},
	{"value": "LNBZJYCUNZB", "name": "辽宁北镇锦银村镇银行"},
	{"value": "LNBXNFRCB", "name": "辽宁本溪南芬农村商业银行"},
	{"value": "LNCZHTCUNZB", "name": "辽宁辰州汇通村镇银行"},
	{"value": "LNDSQLFCUNZB", "name": "辽宁大石桥隆丰村镇银行"},
	{"value": "LNDSQRCB", "name": "辽宁大石桥农村商业银行"},
	{"value": "LNDWRCB", "name": "辽宁大洼农村商业银行"},
	{"value": "LNDTCUNZB", "name": "辽宁灯塔村镇银行"},
	{"value": "LNDTRCB", "name": "辽宁灯塔农村商业银行"},
	{"value": "LNDGRCB", "name": "辽宁东港农村商业银行"},
	{"value": "LNFCRCB", "name": "辽宁凤城农村商业银行"},
	{"value": "LNGZRCB", "name": "辽宁盖州农村商业银行"},
	{"value": "LNHCJHCUNZB", "name": "辽宁海城金海村镇银行"},
	{"value": "LNHCRCB", "name": "辽宁海城农村商业银行"},
	{"value": "LNHSJYCUNZB", "name": "辽宁黑山锦银村镇银行"},
	{"value": "LNHRJYCUNZB", "name": "辽宁桓仁锦银村镇银行"},
	{"value": "LNHRRCB", "name": "辽宁桓仁农村商业银行"},
	{"value": "LNJPRCB", "name": "辽宁建平农村商业银行"},
	{"value": "LNKZJYCUNZB", "name": "辽宁喀左锦银村镇银行"},
	{"value": "LNKDRCB", "name": "辽宁宽甸农村商业银行"},
	{"value": "LNLHJYCUNZB", "name": "辽宁凌海锦银村镇银行"},
	{"value": "LNNXS", "name": "辽宁省农村信用社联合社"},
	{"value": "LNQSJQCUNZB", "name": "辽宁千山金泉村镇银行"},
	{"value": "LNQYRCB", "name": "辽宁清原农村商业银行"},
	{"value": "LNSBRCB", "name": "辽宁沈本农村商业银行"},
	{"value": "LNSDCUNZB", "name": "辽宁沈东村镇银行"},
	{"value": "LNSFRCB", "name": "辽宁沈抚农村商业银行"},
	{"value": "LNSSCUNZB", "name": "辽宁首山村镇银行"},
	{"value": "LNTAJACUNZB", "name": "辽宁台安金安村镇银行"},
	{"value": "LNTZHCUNZB", "name": "辽宁太子河村镇银行"},
	{"value": "LNXBRCB", "name": "辽宁新宾农村商业银行"},
	{"value": "LNXMRCB", "name": "辽宁新民农村商业银行"},
	{"value": "LNXCRCB", "name": "辽宁兴城农村商业银行"},
	{"value": "LNZYJYCUNZB", "name": "辽宁岫岩金玉村镇银行"},
	{"value": "LNXYRCB", "name": "辽宁岫岩农村商业银行"},
	{"value": "LNYXJYCUNZB", "name": "辽宁义县锦银村镇银行"},
	{"value": "LNZWJTCUNZB", "name": "辽宁彰武金通村镇银行"},
	{"value": "LNZXYH", "name": "辽宁振兴银行"},
	{"value": "LYLDRCB", "name": "辽阳辽东农村商业银行"},
	{"value": "LYANGRCB", "name": "辽阳农村商业银行"},
	{"value": "LYLSYYCUNZB", "name": "辽源龙山榆银村镇银行"},
	{"value": "LYRCB", "name": "辽源农村商业银行"},
	{"value": "LYXAQYYCUNZB", "name": "辽源西安区榆银村镇银行"},
	{"value": "LCHNSCUNZB", "name": "聊城沪农商村镇银行"},
	{"value": "LCRCB", "name": "聊城农村商业银行"},
	{"value": "LZMSCUNZB", "name": "林芝民生村镇银行"},
	{"value": "LZZYCUNZB", "name": "林州中原村镇银行"},
	{"value": "LCLXHNSCUNZB", "name": "临沧临翔沪农商村镇银行"},
	{"value": "LCPFCUNZB", "name": "临川浦发村镇银行"},
	{"value": "LFSYDQHDCUNZB", "name": "临汾市尧都区惠都村镇银行"},
	{"value": "LGHFCUNZB", "name": "临高惠丰村镇银行"},
	{"value": "LJZYCUNZB", "name": "临江蛟银村镇银行"},
	{"value": "LZHNSCUNZB", "name": "临澧沪农商村镇银行"},
	{"value": "LQHNSCUNZB", "name": "临清沪农商村镇银行"},
	{"value": "LSYH", "name": "临商银行"},
	{"value": "LSMFCUNZB", "name": "临沭民丰村镇银行"},
	{"value": "LZXJCCUNZB", "name": "临洮县金城村镇银行"},
	{"value": "LWPFCUNZB", "name": "临武浦发村镇银行"},
	{"value": "LXQDCUNZB", "name": "临县泉都村镇银行"},
	{"value": "LZXXTCUNZB", "name": "临猗县新田村镇银行"},
	{"value": "LYHDQSCUNZB", "name": "临沂河东齐商村镇银行"},
	{"value": "LBRFCUNZB", "name": "灵宝融丰村镇银行"},
	{"value": "LCSTCUNZB", "name": "灵川深通村镇银行"},
	{"value": "LQXCQCUNZB", "name": "灵丘县长青村镇银行"},
	{"value": "LSTYCUNZB", "name": "灵山泰业村镇银行"},
	{"value": "LSXHMCUNZB", "name": "灵石县汇民村镇银行"},
	{"value": "LYTYCUNZB", "name": "凌源天元村镇银行"},
	{"value": "LCXTXCUNZB", "name": "陵川县太行村镇银行"},
	{"value": "LSHMCUNZB", "name": "陵水惠民村镇银行"},
	{"value": "LHMYCUNZB", "name": "柳河蒙银村镇银行"},
	{"value": "LLHZCUNZB", "name": "柳林汇泽村镇银行"},
	{"value": "LIUZYH", "name": "柳州银行"},
	{"value": "LARCB", "name": "六安农村商业银行"},
	{"value": "LPSLZFMCUNZB", "name": "六盘水六枝富民村镇银行"},
	{"value": "LPSRCB", "name": "六盘水农村商业银行"},
	{"value": "LPSZSLDCUNZB", "name": "六盘水钟山凉都村镇银行"},
	{"value": "LCRHCUNZB", "name": "龙川融和村镇银行"},
	{"value": "LJYH", "name": "龙江银行"},
	{"value": "LJYYCUNZB", "name": "龙井榆银村镇银行"},
	{"value": "LLGFCUNZB", "name": "龙里国丰村镇银行"},
	{"value": "LDLPSCUNZB", "name": "隆德六盘山村镇银行"},
	{"value": "LNSWDJQCUNZB", "name": "陇南市武都金桥村镇银行"},
	{"value": "LNWDRCU", "name": "陇南武都农村合作银行"},
	{"value": "LXSZCUNZB", "name": "陇西神舟村镇银行"},
	{"value": "LFXSHCUNZB", "name": "娄烦县三禾村镇银行"},
	{"value": "LLJYCUNZB", "name": "卢龙家银村镇银行"},
	{"value": "LSZYCUNZB", "name": "卢氏中原村镇银行"},
	{"value": "LJHMCUNZB", "name": "庐江惠民村镇银行"},
	{"value": "LSJYYSCUNZB", "name": "庐山九银艺术村镇银行"},
	{"value": "LSZCCUNZB", "name": "泸水中成村镇银行"},
	{"value": "ZXYTCUNZB", "name": "泸县元通村镇银行"},
	{"value": "HZSCCB", "name": "泸州市商业银行"},
	{"value": "LZJYRCB", "name": "泸州江阳农村商业银行"},
	{"value": "LZLMTRCB", "name": "泸州龙马潭农村商业银行"},
	{"value": "LUZRCB", "name": "泸州农村商业银行"},
	{"value": "LQHSCUNZB", "name": "鹿泉恒升村镇银行"},
	{"value": "LFLCFDCUNZB", "name": "禄丰龙城富滇村镇银行"},
	{"value": "LNZCCUNZB", "name": "滦南中成村镇银行"},
	{"value": "LPSYCUNZB", "name": "滦平盛阳村镇银行"},
	{"value": "LXZCCUNZB", "name": "滦州中成村镇银行"},
	{"value": "LDFZCUNZB", "name": "罗甸发展村镇银行"},
	{"value": "LTCNSCUNZB", "name": "罗田楚农商村镇银行"},
	{"value": "LYBC", "name": "洛阳银行"},
	{"value": "LUOYRCB", "name": "洛阳农村商业银行"},
	{"value": "ZHSZCBSCUNZB", "name": "漯河市郾城发展村镇银行"},
	{"value": "LLXYHTCUNZB", "name": "吕梁孝义汇通村镇银行"},
	{"value": "MLXYLCB", "name": "马来西亚联昌银行"},
	{"value": "MALAYSIABANK", "name": "马来西亚马来亚银行"},
	{"value": "MZLRCB", "name": "满洲里农村商业银行"},
	{"value": "MMDBCJCUNZB", "name": "茂名电白长江村镇银行"},
	{"value": "MMGZCJCUNZB", "name": "茂名高州长江村镇银行"},
	{"value": "MSRCB", "name": "眉山农村商业银行"},
	{"value": "MHKMSCUNZB", "name": "梅河口民生村镇银行"},
	{"value": "MXKJCUNZB", "name": "梅州客家村镇银行"},
	{"value": "MZKSB", "name": "梅州客商银行"},
	{"value": "BAC", "name": "美国银行有限公司"},
	{"value": "AMERICANBUILTEASTBANK", "name": "美国建东银行"},
	{"value": "BTCB", "name": "蒙商银行(包商银行)"},
	{"value": "BMOBK", "name": "蒙特利尔银行"},
	{"value": "MZHNSCUNZB", "name": "蒙自沪农商村镇银行"},
	{"value": "MCHZZZXRXCUNZB", "name": "孟村回族自治县融信村镇银行"},
	{"value": "MJMFCUNZB", "name": "孟津民丰村镇银行"},
	{"value": "MZSYCUNZB", "name": "孟州射阳村镇银行"},
	{"value": "MLHNSCUNZB", "name": "弥勒沪农商村镇银行"},
	{"value": "MYYCCUNZB", "name": "泌阳玉川村镇银行"},
	{"value": "MSMYCUNZB", "name": "密山民意村镇银行"},
	{"value": "MYCCB", "name": "绵阳市商业银行"},
	{"value": "MZPFCUNZB", "name": "绵竹浦发村镇银行"},
	{"value": "MCQLCUNZB", "name": "渑池齐鲁村镇银行"},
	{"value": "MQRXCUNZB", "name": "民勤融信村镇银行"},
	{"value": "MQDSCUNZB", "name": "民权德商村镇银行"},
	{"value": "CMBC", "name": "中国民生银行"},
	{"value": "MINTAIBANK", "name": "浙江民泰商业银行"},
	{"value": "JPMC", "name": "摩根大通银行（中国）有限公司"},
	{"value": "MGSDL", "name": "摩根士丹利国际"},
	{"value": "MLDWBSCUNZB", "name": "莫力达瓦蒙商村镇银行"},
	{"value": "MPJDCUNZB", "name": "牟平胶东村镇银行"},
	{"value": "MLYDCUNZB", "name": "穆棱远东村镇银行"},
	{"value": "NYFMCUNZB", "name": "纳雍富民村镇银行"},
	{"value": "NBXZCCUNZB", "name": "南部县中成村镇银行"},
	{"value": "NCCDJYCUNZB", "name": "南昌昌东九银村镇银行"},
	{"value": "NCDFCUNZB", "name": "南昌大丰村镇银行"},
	{"value": "NCRCB", "name": "南昌农村商业银行"},
	{"value": "NCXJHTCUNZB", "name": "南昌新建恒通村镇银行"},
	{"value": "NCFMCUNZB", "name": "南城富民村镇银行"},
	{"value": "NCJLZCCUNZB", "name": "南充嘉陵中成村镇银行"},
	{"value": "NCHONGRCB", "name": "南充农村商业银行"},
	{"value": "NFJDCUNZB", "name": "南丰桔都村镇银行"},
	{"value": "NHRXCUNZB", "name": "南和融信村镇银行"},
	{"value": "NJNKCUNZB", "name": "南江农科村镇银行"},
	{"value": "NJYH", "name": "南京银行"},
	{"value": "NJLHJYCUNZB", "name": "南京六合九银村镇银行"},
	{"value": "NJPKJFCUNZB", "name": "南京浦口靖发村镇银行"},
	{"value": "NJZCCUNZB", "name": "南靖中成村镇银行"},
	{"value": "NKGSCUNZB", "name": "南康赣商村镇银行"},
	{"value": "NLTPCUNZB", "name": "南陵太平村镇银行"},
	{"value": "NNJNGMCUNZB", "name": "南宁江南国民村镇银行"},
	{"value": "NNLACJCUNZB", "name": "南宁隆安长江村镇银行"},
	{"value": "NNMSCJCUNZB", "name": "南宁马山长江村镇银行"},
	{"value": "NNWMLJCUNZB", "name": "南宁武鸣漓江村镇银行"},
	{"value": "NNXNCJCUNZB", "name": "南宁兴宁长江村镇银行"},
	{"value": "NPRXCUNZB", "name": "南皮融信村镇银行"},
	{"value": "NYCUNZB", "name": "南阳村镇银行"},
	{"value": "NOBC", "name": "南洋商业银行（中国）有限公司"},
	{"value": "GDNYYH", "name": "广东南粤银行"},
	{"value": "ZHRXCUNZB", "name": "讷河融兴村镇银行"},
	{"value": "NJXLCUNZB", "name": "内江兴隆村镇银行"},
	{"value": "NMGYH", "name": "内蒙古银行"},
	{"value": "NMGAESRCB", "name": "内蒙古阿尔山农村商业银行"},
	{"value": "NMGALKEQRCB", "name": "内蒙古阿鲁科尔沁农村商业银行"},
	{"value": "NMGCHEYYQQRCB", "name": "内蒙古察哈尔右翼前旗农村商业银行"},
	{"value": "NMGELCRCB", "name": "内蒙古鄂伦春农村商业银行"},
	{"value": "NMGETKRCB", "name": "内蒙古鄂托克农村商业银行"},
	{"value": "NMGETKQQRCB", "name": "内蒙古鄂托克前旗农村商业银行"},
	{"value": "NMGHLGEBSCUNZB", "name": "内蒙古和林格尔蒙商村镇银行"},
	{"value": "HHHTJGRCB", "name": "内蒙古呼和浩特金谷农村商业银行"},
	{"value": "NMGKSKTRCB", "name": "内蒙古克什克腾农村商业银行"},
	{"value": "NMGNCRCB", "name": "内蒙古宁城农村商业银行"},
	{"value": "NMGNXS", "name": "内蒙古自治区农村信用社联合社"},
	{"value": "NMGSBRCB", "name": "内蒙古陕坝农村商业银行"},
	{"value": "NMGTPSRCB", "name": "内蒙古太仆寺农村商业银行"},
	{"value": "NMGTMTYQRCB", "name": "内蒙古土默特右旗农村商业银行"},
	{"value": "NMGTKTLNCUNZB", "name": "内蒙古托克托立农村镇银行"},
	{"value": "NMGTKTRCB", "name": "内蒙古托克托农村商业银行"},
	{"value": "NMGWLTRCB", "name": "内蒙古乌拉特农村商业银行"},
	{"value": "NMGWYRCB", "name": "内蒙古五原农村商业银行"},
	{"value": "NMGXWZMQRCB", "name": "内蒙古西乌珠穆沁农村商业银行"},
	{"value": "NMGYKSRCB", "name": "内蒙古牙克石农村商业银行"},
	{"value": "NMGYJHLRCB", "name": "内蒙古伊金霍洛农村商业银行"},
	{"value": "NJXFCUNZB", "name": "嫩江幸福村镇银行"},
	{"value": "NARXCUNZB", "name": "宁安融兴村镇银行"},
	{"value": "NBYH", "name": "宁波银行"},
	{"value": "NBBLRCB", "name": "宁波北仑农村商业银行"},
	{"value": "NBCXRCB", "name": "宁波慈溪农村商业银行"},
	{"value": "NBDHYH", "name": "宁波东海银行"},
	{"value": "NBFHRCB", "name": "宁波奉化农村商业银行"},
	{"value": "NBHSPFCUNZB", "name": "宁波海曙浦发村镇银行"},
	{"value": "NBJBFMCUNZB", "name": "宁波江北富民村镇银行"},
	{"value": "NBNHRCB", "name": "宁波宁海农村商业银行"},
	{"value": "NBSHZGMCUNZB", "name": "宁波市海曙国民村镇银行"},
	{"value": "NBTSYH", "name": "宁波通商银行"},
	{"value": "NBYZRCB", "name": "宁波鄞州农村商业银行"},
	{"value": "NBYYRCB", "name": "宁波余姚农村商业银行"},
	{"value": "NBZHRCB", "name": "宁波镇海农村商业银行"},
	{"value": "NCBSCUNZB", "name": "宁城蒙商村镇银行"},
	{"value": "NGMSCUNZB", "name": "宁国民生村镇银行"},
	{"value": "NJJDCUNZB", "name": "宁津胶东村镇银行"},
	{"value": "NJMSCUNZB", "name": "宁晋民生村镇银行"},
	{"value": "NLDSCUNZB", "name": "宁陵德商村镇银行"},
	{"value": "NWXRDCUNZB", "name": "宁武县瑞都村镇银行"},
	{"value": "NXYH", "name": "宁夏银行"},
	{"value": "NXGYRCB", "name": "宁夏固原农村商业银行"},
	{"value": "NXHLHSCUNZB", "name": "宁夏贺兰回商村镇银行"},
	{"value": "NXHLRCB", "name": "宁夏贺兰农村商业银行"},
	{"value": "NXHSBHFCUNZB", "name": "宁夏红寺堡汇发村镇银行"},
	{"value": "NXHHRCB", "name": "宁夏黄河农村商业银行"},
	{"value": "NXHNHLSCUNZB", "name": "宁夏惠农贺兰山村镇银行"},
	{"value": "NXLWRCB", "name": "宁夏灵武农村商业银行"},
	{"value": "NXNDBFCUNZB", "name": "宁夏宁东本富村镇银行"},
	{"value": "NXNXS", "name": "宁夏回族自治区农村信用社联合社"},
	{"value": "NXPYHLSCUNZB", "name": "宁夏彭阳贺兰山村镇银行"},
	{"value": "NXPYRCB", "name": "宁夏彭阳农村商业银行"},
	{"value": "NXPLRCB", "name": "宁夏平罗农村商业银行"},
	{"value": "NXQTXHLSCUNZB", "name": "宁夏青铜峡贺兰山村镇银行"},
	{"value": "NXSZSRCB", "name": "宁夏石嘴山农村商业银行"},
	{"value": "NXTXJHCUNZB", "name": "宁夏同心津汇村镇银行"},
	{"value": "NXTXRCB", "name": "宁夏同心农村商业银行"},
	{"value": "NXWZRCB", "name": "宁夏吴忠农村商业银行"},
	{"value": "NXXJHFCUNZB", "name": "宁夏西吉汇发村镇银行"},
	{"value": "NXXJRCB", "name": "宁夏西吉农村商业银行"},
	{"value": "NXXXHLSCUNZB", "name": "宁夏西夏贺兰山村镇银行"},
	{"value": "NXYCHFCUNZB", "name": "宁夏盐池汇发村镇银行"},
	{"value": "NXYCRCB", "name": "宁夏盐池农村商业银行"},
	{"value": "NXYNHFCUNZB", "name": "宁夏永宁汇发村镇银行"},
	{"value": "NXYZJHCUNZB", "name": "宁夏原州津汇村镇银行"},
	{"value": "NXZNRCB", "name": "宁夏中宁农村商业银行"},
	{"value": "NXZNQYCUNZB", "name": "宁夏中宁青银村镇银行"},
	{"value": "NXZWRCB", "name": "宁夏中卫农村商业银行"},
	{"value": "NXHNSCUNZB", "name": "宁乡沪农商村镇银行"},
	{"value": "NYHNSCUNZB", "name": "宁阳沪农商村镇银行"},
	{"value": "NABYCUNZB", "name": "农安北银村镇银行"},
	{"value": "NYFZYH", "name": "中国农业发展银行"},
	{"value": "ABC", "name": "中国农业银行"},
	{"value": "NORWAYBANK", "name": "挪威银行公共"},
	{"value": "PZHRCB", "name": "攀枝花农村商业银行"},
	{"value": "BKB", "name": "盘谷银行"},
	{"value": "PJSCCB", "name": "盘锦市商业银行"},
	{"value": "PSATCUNZB", "name": "盘山安泰村镇银行"},
	{"value": "PZWHCUNZB", "name": "盘州万和村镇银行"},
	{"value": "PSJYCUNZB", "name": "磐石吉银村镇银行"},
	{"value": "PSZJCUNZB", "name": "彭山珠江村镇银行"},
	{"value": "PZJYCUNZB", "name": "彭泽九银村镇银行"},
	{"value": "PZMSCUNZB", "name": "彭州民生村镇银行"},
	{"value": "PLMSCUNZB", "name": "蓬莱民生村镇银行"},
	{"value": "SDB", "name": "平安银行(深圳发展银行)"},
	{"value": "PBDLCUNZB", "name": "平坝鼎立村镇银行"},
	{"value": "PCNKCUNZB", "name": "平昌农科村镇银行"},
	{"value": "PDSYH", "name": "平顶山银行"},
	{"value": "PDSWDRCB", "name": "平顶山卫东农村商业银行"},
	{"value": "PDCDCUNZB", "name": "平定县昌都村镇银行"},
	{"value": "PGGMCUNZB", "name": "平果国民村镇银行"},
	{"value": "PHRFCUNZB", "name": "平和润丰村镇银行"},
	{"value": "PLZZRXCUNZB", "name": "平凉崆峒融兴村镇银行"},
	{"value": "PLRCB", "name": "平凉农村商业银行"},
	{"value": "PLSJNCJCUNZB", "name": "平凉市静宁成纪村镇银行"},
	{"value": "PLXHDCUNZB", "name": "平陆县河东村镇银行"},
	{"value": "PLSHCUNZB", "name": "平罗沙湖村镇银行"},
	{"value": "PQHSCUNZB", "name": "平泉恒升村镇银行"},
	{"value": "PSXBPJYCUNZB", "name": "平山西柏坡冀银村镇银行"},
	{"value": "PTFMCUNZB", "name": "平塘富民村镇银行"},
	{"value": "PYXJRCUNZB", "name": "平遥县晋融村镇银行"},
	{"value": "PYLHCUNZB", "name": "平阴蓝海村镇银行"},
	{"value": "PYYCCUNZB", "name": "平舆玉川村镇银行"},
	{"value": "PYYRCUNZB", "name": "平原圆融村镇银行"},
	{"value": "PNCTHCUNZB", "name": "屏南刺桐红村镇银行"},
	{"value": "PXAYFMCUNZB", "name": "萍乡安源富民村镇银行"},
	{"value": "PXRCB", "name": "萍乡农村商业银行"},
	{"value": "PXXDHHCUNZB", "name": "萍乡湘东黄海村镇银行"},
	{"value": "PYHTCUNZB", "name": "鄱阳恒通村镇银行"},
	{"value": "PYRCB", "name": "濮阳农村商业银行"},
	{"value": "ZYZYCUNZB", "name": "濮阳中原村镇银行"},
	{"value": "PCZCCUNZB", "name": "浦城中成村镇银行"},
	{"value": "SPDB", "name": "上海浦东发展银行"},
	{"value": "SPDSV", "name": "浦发硅谷银行"},
	{"value": "PAPHCUNZB", "name": "普安普惠村镇银行"},
	{"value": "PDFMCUNZB", "name": "普定富民村镇银行"},
	{"value": "PEMSCUNZB", "name": "普洱民生村镇银行"},
	{"value": "QHJDCUNZB", "name": "齐河胶东村镇银行"},
	{"value": "QLYH", "name": "齐鲁银行"},
	{"value": "QQHERCB", "name": "齐齐哈尔农村商业银行"},
	{"value": "QSYH", "name": "齐商银行"},
	{"value": "QXJRCUNZB", "name": "祁县晋融村镇银行"},
	{"value": "QYCUNZB", "name": "祁阳村镇银行"},
	{"value": "QTLFCUNZB", "name": "奇台利丰村镇银行"},
	{"value": "ZXZYCUNZB", "name": "淇县中原村镇银行"},
	{"value": "ZJMSCUNZB", "name": "綦江民生村镇银行"},
	{"value": "IBKK", "name": "企业银行（中国）有限公司"},
	{"value": "QAXLCUNZB", "name": "迁安襄隆村镇银行"},
	{"value": "QGXYGCUNZB", "name": "前郭县阳光村镇银行"},
	{"value": "QAHMCUNZB", "name": "乾安惠民村镇银行"},
	{"value": "QXHDCUNZB", "name": "黔西花都村镇银行"},
	{"value": "QXNYLPFCUNZB", "name": "黔西南义龙浦发村镇银行"},
	{"value": "QHDYH", "name": "秦皇岛银行"},
	{"value": "QHDFNJYCUNZB", "name": "秦皇岛抚宁家银村镇银行"},
	{"value": "QYXCQCUNZB", "name": "沁源县长青村镇银行"},
	{"value": "QDYH", "name": "青岛银行"},
	{"value": "QDCYZJCUNZB", "name": "青岛城阳珠江村镇银行"},
	{"value": "QDHDSFCUNZB", "name": "青岛黄岛舜丰村镇银行"},
	{"value": "QDJMHMCUNZB", "name": "青岛即墨惠民村镇银行"},
	{"value": "QDJZZCCUNZB", "name": "青岛胶州中成村镇银行"},
	{"value": "QDLXYTCUNZB", "name": "青岛莱西元泰村镇银行"},
	{"value": "QDZSJYCUNZB", "name": "青岛崂山交银村镇银行"},
	{"value": "QDRCB", "name": "青岛农村商业银行"},
	{"value": "QDPDHMCUNZB", "name": "青岛平度惠民村镇银行"},
	{"value": "QDXHAHHCUNZB", "name": "青岛西海岸海汇村镇银行"},
	{"value": "QHYH", "name": "青海银行"},
	{"value": "QHCDMRCB", "name": "青海柴达木农村商业银行"},
	{"value": "QHDTRCB", "name": "青海大通农村商业银行"},
	{"value": "QHDLRCB", "name": "青海都兰农村商业银行"},
	{"value": "QHGCRCB", "name": "青海刚察农村商业银行"},
	{"value": "QHGEMRCB", "name": "青海格尔木农村商业银行"},
	{"value": "QHGHRCB", "name": "青海共和农村商业银行"},
	{"value": "QHGDRCB", "name": "青海贵德农村商业银行"},
	{"value": "QHGNRCB", "name": "青海贵南农村商业银行"},
	{"value": "QHGLRCB", "name": "青海果洛农村商业银行"},
	{"value": "QHHDPARCB", "name": "青海海东农村商业银行"},
	{"value": "QHHYANRCB", "name": "青海海晏农村商业银行"},
	{"value": "QHHNRCB", "name": "青海河南农村商业银行"},
	{"value": "QHHZRCB", "name": "青海互助农村商业银行"},
	{"value": "QHHYRCB", "name": "青海湟源农村商业银行"},
	{"value": "QHHZHRCB", "name": "青海湟中农村商业银行"},
	{"value": "QHZZSJCUNZB", "name": "青海湟中三江村镇银行"},
	{"value": "QHLDSJCUNZB", "name": "青海乐都三江村镇银行"},
	{"value": "QHMYDTCUNZB", "name": "青海门源大通村镇银行"},
	{"value": "QHMYRCB", "name": "青海门源农村商业银行"},
	{"value": "QHNXS", "name": "青海省农村信用社联合社"},
	{"value": "QHPADTCUNZB", "name": "青海平安大通村镇银行"},
	{"value": "QHQLRCB", "name": "青海祁连农村商业银行"},
	{"value": "QHTDRCB", "name": "青海同德农村商业银行"},
	{"value": "QHTRRCB", "name": "青海同仁农村商业银行"},
	{"value": "QHWLRCB", "name": "青海乌兰农村商业银行"},
	{"value": "QHXNRCB", "name": "青海西宁农村商业银行"},
	{"value": "QHXHRCB", "name": "青海兴海农村商业银行"},
	{"value": "QHXUNHRCB", "name": "青海循化农村商业银行"},
	{"value": "QHYSRCB", "name": "青海玉树农村商业银行"},
	{"value": "QLRXCUNZB", "name": "青龙融兴村镇银行"},
	{"value": "QXQLCUNZB", "name": "青县青隆村镇银行"},
	{"value": "QYLLCUNZB", "name": "青原庐陵村镇银行"},
	{"value": "QHJNCUNZB", "name": "清河金农村镇银行"},
	{"value": "QXHMCUNZB", "name": "清徐惠民村镇银行"},
	{"value": "QXJSCUNZB", "name": "清徐晋商村镇银行"},
	{"value": "QYQXHMCUNZB", "name": "清远清新惠民村镇银行"},
	{"value": "QZXBCUNZB", "name": "清镇兴邦村镇银行"},
	{"value": "QLXACUNZB", "name": "晴隆兴安村镇银行"},
	{"value": "QCXJCCUNZB", "name": "庆城县金城村镇银行"},
	{"value": "QYRCB", "name": "庆阳农村商业银行"},
	{"value": "QYSXFRXCUNZB", "name": "庆阳市西峰瑞信村镇银行"},
	{"value": "QYLACUNZB", "name": "庆云乐安村镇银行"},
	{"value": "ZZGMCUNZB", "name": "邛崃国民村镇银行"},
	{"value": "QHDZCUNZB", "name": "琼海大众村镇银行"},
	{"value": "QJSCCB", "name": "曲靖市商业银行"},
	{"value": "QJFYFDCUNZB", "name": "曲靖富源富滇村镇银行"},
	{"value": "QJHZCJCUNZB", "name": "曲靖会泽长江村镇银行"},
	{"value": "QJHMCUNZB", "name": "曲靖惠民村镇银行"},
	{"value": "QJXWCJCUNZB", "name": "曲靖宣威长江村镇银行"},
	{"value": "QWXXTCUNZB", "name": "曲沃县新田村镇银行"},
	{"value": "QYZCCUNZB", "name": "曲阳中成村镇银行"},
	{"value": "QZHSCUNZB", "name": "曲周恒升村镇银行"},
	{"value": "QZYH", "name": "泉州银行"},
	{"value": "QZRCB", "name": "泉州农村商业银行"},
	{"value": "QSZYCUNZB", "name": "确山郑银村镇银行"},
	{"value": "RPRHCUNZB", "name": "饶平融和村镇银行"},
	{"value": "RYMSCUNZB", "name": "饶阳民商村镇银行"},
	{"value": "RHMYCUNZB", "name": "仁怀蒙银村镇银行"},
	{"value": "RSMFCUNZB", "name": "仁寿民富村镇银行"},
	{"value": "RQCUNZB", "name": "任丘村镇银行"},
	{"value": "RXXNSCUNZB", "name": "任县邢农商村镇银行"},
	{"value": "RBHBB", "name": "日本横滨银行"},
	{"value": "MEIGIN", "name": "日本名古屋银行"},
	{"value": "JAPANYAMAGUCHIBANK", "name": "日本山口银行"},
	{"value": "RZYH", "name": "日照银行"},
	{"value": "RZDGRCB", "name": "日照东港农村商业银行"},
	{"value": "RZHNSCUNZB", "name": "日照沪农商村镇银行"},
	{"value": "RZJYCUNZB", "name": "日照九银村镇银行"},
	{"value": "RZLSRCB", "name": "日照岚山农村商业银行"},
	{"value": "RZLHCUNZB", "name": "日照蓝海村镇银行"},
	{"value": "RCXNSCUNZB", "name": "容城邢农商村镇银行"},
	{"value": "RZYCCUNZB", "name": "汝州玉川村镇银行"},
	{"value": "RSTJCUNZB", "name": "乳山天骄村镇银行"},
	{"value": "RCJYCUNZB", "name": "瑞昌九银村镇银行"},
	{"value": "RDYHYXGS", "name": "瑞典银行有限公司"},
	{"value": "RDBOSA", "name": "瑞典北欧斯安银行有限公司"},
	{"value": "RLHNSCUNZB", "name": "瑞丽沪农商村镇银行"},
	{"value": "UBS", "name": "瑞士银行有限公司"},
	{"value": "SWISSCB", "name": "瑞士信贷银行"},
	{"value": "RSSY", "name": "瑞穗实业银行（中国）有限公司"},
	{"value": "SDFMCUNZB", "name": "三都富民村镇银行"},
	{"value": "SHMYCUNZB", "name": "三河蒙银村镇银行"},
	{"value": "SMBC", "name": "三井住友银行（中国）有限公司"},
	{"value": "TOKYOMITSUBISHIBANK", "name": "三菱东京日联银行"},
	{"value": "SMXHBRCB", "name": "三门峡湖滨农村商业银行"},
	{"value": "SMXSZRCB", "name": "三门峡陕州农村商业银行"},
	{"value": "SSZJCUNZB", "name": "三水珠江村镇银行"},
	{"value": "csxbank", "name": "湖南三湘银行股份有限公司"},
	{"value": "SYHMCUNZB", "name": "三亚惠民村镇银行"},
	{"value": "SYRCB", "name": "三亚农村商业银行"},
	{"value": "SHXTCUNZB", "name": "沙河襄通村镇银行"},
	{"value": "XMYH", "name": "厦门银行"},
	{"value": "XIB", "name": "厦门国际银行"},
	{"value": "XMRCB", "name": "厦门农村商业银行"},
	{"value": "XMTANYCUNZB", "name": "厦门同安农银村镇银行"},
	{"value": "XMXAMSCUNZB", "name": "厦门翔安民生村镇银行"},
	{"value": "SDAQRCB", "name": "山东安丘农村商业银行"},
	{"value": "SDBXRCB", "name": "山东博兴农村商业银行"},
	{"value": "SDBXXHCUNZB", "name": "山东博兴新华村镇银行"},
	{"value": "SDCXRCB", "name": "山东曹县农村商业银行"},
	{"value": "SDCLRCB", "name": "山东昌乐农村商业银行"},
	{"value": "SDCYRCB", "name": "山东昌邑农村商业银行"},
	{"value": "SDCWHYCUNZB", "name": "山东成武汉源村镇银行"},
	{"value": "SDCWRCB", "name": "山东成武农村商业银行"},
	{"value": "SDCPRCB", "name": "山东茌平农村商业银行"},
	{"value": "SDDXRCB", "name": "山东单县农村商业银行"},
	{"value": "SDDTRCB", "name": "山东定陶农村商业银行"},
	{"value": "SDDARCB", "name": "山东东阿农村商业银行"},
	{"value": "SDDMRCB", "name": "山东东明农村商业银行"},
	{"value": "SDDPRCB", "name": "山东东平农村商业银行"},
	{"value": "SDFCMFCUNZB", "name": "山东肥城民丰村镇银行"},
	{"value": "SDFCRCB", "name": "山东肥城农村商业银行"},
	{"value": "SDFXRCB", "name": "山东费县农村商业银行"},
	{"value": "SDGMRCB", "name": "山东高密农村商业银行"},
	{"value": "SDGQHJCUNZB", "name": "山东高青汇金村镇银行"},
	{"value": "SDGQRCB", "name": "山东高青农村商业银行"},
	{"value": "SDGTRCB", "name": "山东高唐农村商业银行"},
	{"value": "SDGXQFCUNZB", "name": "山东冠县齐丰村镇银行"},
	{"value": "SDGRRCB", "name": "山东广饶农村商业银行"},
	{"value": "SDHYRCB", "name": "山东海阳农村商业银行"},
	{"value": "SDHTRCB", "name": "山东桓台农村商业银行"},
	{"value": "SDHMRCB", "name": "山东惠民农村商业银行"},
	{"value": "SDHMSFCUNZB", "name": "山东惠民舜丰村镇银行"},
	{"value": "SDJNYZRCB", "name": "山东济宁兖州农村商业银行"},
	{"value": "SDJIYRCB", "name": "山东济阳农村商业银行"},
	{"value": "SDJIAXRCB", "name": "山东嘉祥农村商业银行"},
	{"value": "SDJXLHCUNZB", "name": "山东金乡蓝海村镇银行"},
	{"value": "SDJXRCB", "name": "山东金乡农村商业银行"},
	{"value": "SDJNCUNZB", "name": "山东莒南村镇银行"},
	{"value": "SDJNRCB", "name": "山东莒南农村商业银行"},
	{"value": "SDJUXRCB", "name": "山东莒县农村商业银行"},
	{"value": "SDJYRCB", "name": "山东巨野农村商业银行"},
	{"value": "SDYCRCB", "name": "山东鄄城农村商业银行"},
	{"value": "SDKLRCB", "name": "山东垦利农村商业银行"},
	{"value": "SDLSQFCUNZB", "name": "山东莱山齐丰村镇银行"},
	{"value": "SDLWRCB", "name": "山东莱芜农村商业银行"},
	{"value": "SDLYRCB", "name": "山东莱阳农村商业银行"},
	{"value": "SDLAIZRCB", "name": "山东莱州农村商业银行"},
	{"value": "SDLLCUNZB", "name": "山东兰陵村镇银行"},
	{"value": "SDLLRCB", "name": "山东兰陵农村商业银行"},
	{"value": "SDLELRCB", "name": "山东乐陵农村商业银行"},
	{"value": "SDLCYRCUNZB", "name": "山东历城圆融村镇银行"},
	{"value": "SDLJRCB", "name": "山东利津农村商业银行"},
	{"value": "SDLJSFCUNZB", "name": "山东利津舜丰村镇银行"},
	{"value": "SDLSMFCUNZB", "name": "山东梁山民丰村镇银行"},
	{"value": "SDLSRCB", "name": "山东梁山农村商业银行"},
	{"value": "SDLCRCRCB", "name": "山东聊城润昌农村商业银行"},
	{"value": "SDLQRCB", "name": "山东临清农村商业银行"},
	{"value": "SDLQJFCUNZB", "name": "山东临朐聚丰村镇银行"},
	{"value": "SDLQURCB", "name": "山东临朐农村商业银行"},
	{"value": "SDLINSRCB", "name": "山东临沭农村商业银行"},
	{"value": "SDLYHDRCB", "name": "山东临沂河东农村商业银行"},
	{"value": "SDLYLSRCB", "name": "山东临沂兰山农村商业银行"},
	{"value": "SDLYLZRCB", "name": "山东临沂罗庄农村商业银行"},
	{"value": "SDLYIRCB", "name": "山东临邑农村商业银行"},
	{"value": "SDLZHJCUNZB", "name": "山东临淄汇金村镇银行"},
	{"value": "SDLZRCB", "name": "山东临淄农村商业银行"},
	{"value": "SDLKRCB", "name": "山东龙口农村商业银行"},
	{"value": "SDMYRCB", "name": "山东蒙阴农村商业银行"},
	{"value": "SDMYQFCUNZB", "name": "山东蒙阴齐丰村镇银行"},
	{"value": "SDNJRCB", "name": "山东宁津农村商业银行"},
	{"value": "SDNYRCB", "name": "山东宁阳农村商业银行"},
	{"value": "SDNXS", "name": "山东省农村信用社联合社"},
	{"value": "SDPLRCB", "name": "山东蓬莱农村商业银行"},
	{"value": "SDPYHYCUNZB", "name": "山东平邑汉源村镇银行"},
	{"value": "SDPYIRCB", "name": "山东平邑农村商业银行"},
	{"value": "SDPYINRCB", "name": "山东平阴农村商业银行"},
	{"value": "SDPYRCB", "name": "山东平原农村商业银行"},
	{"value": "SDQXRCB", "name": "山东栖霞农村商业银行"},
	{"value": "SDQHRCB", "name": "山东齐河农村商业银行"},
	{"value": "SDQZRCB", "name": "山东青州农村商业银行"},
	{"value": "SDQYRCB", "name": "山东庆云农村商业银行"},
	{"value": "SDQFRCB", "name": "山东曲阜农村商业银行"},
	{"value": "SDRCHFCUNZB", "name": "山东荣成汇丰村镇银行"},
	{"value": "SDRCRCB", "name": "山东荣成农村商业银行"},
	{"value": "SDRSRCB", "name": "山东乳山农村商业银行"},
	{"value": "SDSHHJCUNZB", "name": "山东商河汇金村镇银行"},
	{"value": "SDSHRCB", "name": "山东商河农村商业银行"},
	{"value": "SDSXRCB", "name": "山东莘县农村商业银行"},
	{"value": "SDSGRCB", "name": "山东寿光农村商业银行"},
	{"value": "SDSSRCB", "name": "山东泗水农村商业银行"},
	{"value": "SDSSQFCUNZB", "name": "山东泗水齐丰村镇银行"},
	{"value": "SDZCHYCUNZB", "name": "山东郯城汉源村镇银行"},
	{"value": "SDTCRCB", "name": "山东郯城农村商业银行"},
	{"value": "SDTZRCB", "name": "山东滕州农村商业银行"},
	{"value": "SDWHRCB", "name": "山东威海农村商业银行"},
	{"value": "SDWEISRCB", "name": "山东微山农村商业银行"},
	{"value": "SDWDRCB", "name": "山东文登农村商业银行"},
	{"value": "SDWSRCB", "name": "山东汶上农村商业银行"},
	{"value": "SDWLIRCB", "name": "山东无棣农村商业银行"},
	{"value": "SDWLRCB", "name": "山东五莲农村商业银行"},
	{"value": "SDWCRCB", "name": "山东武城农村商业银行"},
	{"value": "SDXJRCB", "name": "山东夏津农村商业银行"},
	{"value": "SDXTRCB", "name": "山东新泰农村商业银行"},
	{"value": "SDXTQFCUNZB", "name": "山东新泰齐丰村镇银行"},
	{"value": "SDYGRCB", "name": "山东阳谷农村商业银行"},
	{"value": "SDYXRCB", "name": "山东阳信农村商业银行"},
	{"value": "SDYNLHCUNZB", "name": "山东沂南蓝海村镇银行"},
	{"value": "SDYNRCB", "name": "山东沂南农村商业银行"},
	{"value": "SDYSRCB", "name": "山东沂水农村商业银行"},
	{"value": "SDYYRCB", "name": "山东沂源农村商业银行"},
	{"value": "SDYTRCB", "name": "山东鱼台农村商业银行"},
	{"value": "SDYUCRCB", "name": "山东禹城农村商业银行"},
	{"value": "SDYUNCRCB", "name": "山东郓城农村商业银行"},
	{"value": "SDZHQYCUNZB", "name": "山东沾化青云村镇银行"},
	{"value": "SDZDRCB", "name": "山东张店农村商业银行"},
	{"value": "SDZQRCB", "name": "山东章丘农村商业银行"},
	{"value": "SDCDRCB", "name": "山东长岛农村商业银行"},
	{"value": "SDZYRCB", "name": "山东招远农村商业银行"},
	{"value": "SDZZQFCUNZB", "name": "山东芝罘齐丰村镇银行"},
	{"value": "SDZCRCB", "name": "山东周村农村商业银行"},
	{"value": "SDZCQLCUNZB", "name": "山东周村青隆村镇银行"},
	{"value": "SDZHUCRCB", "name": "山东诸城农村商业银行"},
	{"value": "SDZOUCRCB", "name": "山东邹城农村商业银行"},
	{"value": "SDZPRCB", "name": "山东邹平农村商业银行"},
	{"value": "SDZPQLCUNZB", "name": "山东邹平青隆村镇银行"},
	{"value": "SXFZRCB", "name": "山西繁峙农村商业银行"},
	{"value": "SXFSRCB", "name": "山西浮山农村商业银行"},
	{"value": "SXGPRCB", "name": "山西高平农村商业银行"},
	{"value": "SXGJRCB", "name": "山西古交农村商业银行"},
	{"value": "SXHESRCB", "name": "山西和顺农村商业银行"},
	{"value": "SXHJRCB", "name": "山西河津农村商业银行"},
	{"value": "SXHQRCB", "name": "山西河曲农村商业银行"},
	{"value": "SXHDRCB", "name": "山西洪洞农村商业银行"},
	{"value": "SXHMRCB", "name": "山西侯马农村商业银行"},
	{"value": "SXHGRCB", "name": "山西壶关农村商业银行"},
	{"value": "SXHRRCB", "name": "山西怀仁农村商业银行"},
	{"value": "SXSSRCB", "name": "山西稷山农村商业银行"},
	{"value": "SXJXRCB", "name": "山西绛县农村商业银行"},
	{"value": "SXJCRCB", "name": "山西交城农村商业银行"},
	{"value": "SXJIEXRCB", "name": "山西介休农村商业银行"},
	{"value": "SXKLRCB", "name": "山西岢岚农村商业银行"},
	{"value": "SXLICRCB", "name": "山西黎城农村商业银行"},
	{"value": "SXLYRCB", "name": "山西临猗农村商业银行"},
	{"value": "SXLSRCB", "name": "山西灵石农村商业银行"},
	{"value": "SXLLRCB", "name": "山西柳林农村商业银行"},
	{"value": "SXLCRCB", "name": "山西潞城农村商业银行"},
	{"value": "SHXNXS", "name": "山西省农村信用社联合社"},
	{"value": "SXPLRCB", "name": "山西平陆农村商业银行"},
	{"value": "SXPSRCB", "name": "山西平顺农村商业银行"},
	{"value": "SXPYRCB", "name": "山西平遥农村商业银行"},
	{"value": "SXQSRCB", "name": "山西沁水农村商业银行"},
	{"value": "SXQINYRCB", "name": "山西沁源农村商业银行"},
	{"value": "SXQXRCB", "name": "山西清徐农村商业银行"},
	{"value": "SXQWRCB", "name": "山西曲沃农村商业银行"},
	{"value": "SXRCRCB", "name": "山西芮城农村商业银行"},
	{"value": "SXSYIRCB", "name": "山西山阴农村商业银行"},
	{"value": "SXSCRCB", "name": "山西神池农村商业银行"},
	{"value": "SXSYRCB", "name": "山西寿阳农村商业银行"},
	{"value": "SXTGRCB", "name": "山西太谷农村商业银行"},
	{"value": "SXTLRCB", "name": "山西屯留农村商业银行"},
	{"value": "SXWXRCB", "name": "山西闻喜农村商业银行"},
	{"value": "SXWTRCB", "name": "山西五台农村商业银行"},
	{"value": "SXWUXRCB", "name": "山西武乡农村商业银行"},
	{"value": "SXXIYRCB", "name": "山西昔阳农村商业银行"},
	{"value": "SXXXRCB", "name": "山西夏县农村商业银行"},
	{"value": "SXXNRCB", "name": "山西乡宁农村商业银行"},
	{"value": "SXXFRCB", "name": "山西襄汾农村商业银行"},
	{"value": "SXXYRCB", "name": "山西襄垣农村商业银行"},
	{"value": "SXXYIRCB", "name": "山西孝义农村商业银行"},
	{"value": "SXXZRCB", "name": "山西忻州农村商业银行"},
	{"value": "SXXINGXRCB", "name": "山西兴县农村商业银行"},
	{"value": "SXYCRCB", "name": "山西阳城农村商业银行"},
	{"value": "SXYQRCB", "name": "山西阳曲农村商业银行"},
	{"value": "SXYDRCB", "name": "山西尧都农村商业银行"},
	{"value": "SXYJRCB", "name": "山西永济农村商业银行"},
	{"value": "SXYXRCB", "name": "山西盂县农村商业银行"},
	{"value": "SXYUCRCB", "name": "山西榆次农村商业银行"},
	{"value": "SXYSRCB", "name": "山西榆社农村商业银行"},
	{"value": "SXYQURCB", "name": "山西垣曲农村商业银行"},
	{"value": "SXYPRCB", "name": "山西原平农村商业银行"},
	{"value": "SXYUNCRCB", "name": "山西运城农村商业银行"},
	{"value": "SXZZRCB", "name": "山西泽州农村商业银行"},
	{"value": "SXCZLDRCB", "name": "山西长治黎都农村商业银行"},
	{"value": "SXCZRCB", "name": "山西长子农村商业银行"},
	{"value": "SXZQRCB", "name": "山西左权农村商业银行"},
	{"value": "SXZUOYRCB", "name": "山西左云农村商业银行"},
	{"value": "SYXTXCUNZB", "name": "山阴县太行村镇银行"},
	{"value": "SXASRCB", "name": "陕西安塞农村商业银行"},
	{"value": "SXBHRCB", "name": "陕西白河农村商业银行"},
	{"value": "SXBJWBRCB", "name": "陕西宝鸡渭滨农村商业银行"},
	{"value": "SXBXRCB", "name": "陕西彬县农村商业银行"},
	{"value": "SXBZRCB", "name": "陕西彬州农村商业银行"},
	{"value": "SXDFRCB", "name": "陕西丹凤农村商业银行"},
	{"value": "SXDBRCB", "name": "陕西定边农村商业银行"},
	{"value": "SXFXRCB", "name": "陕西凤县农村商业银行"},
	{"value": "SXFXIANGRCB", "name": "陕西凤翔农村商业银行"},
	{"value": "SXFGRCB", "name": "陕西府谷农村商业银行"},
	{"value": "SXFPHFCUNZB", "name": "陕西富平汇发村镇银行"},
	{"value": "SXFXRCU", "name": "陕西富县农村合作银行"},
	{"value": "SXGQRCB", "name": "陕西甘泉农村商业银行"},
	{"value": "SXHCRCB", "name": "陕西韩城农村商业银行"},
	{"value": "SXHYRCB", "name": "陕西汉阴农村商业银行"},
	{"value": "SXHZNZHFCUNZB", "name": "陕西汉中南郑汇发村镇银行"},
	{"value": "SXHXHSCUNZB", "name": "陕西户县海丝村镇银行"},
	{"value": "SXIJXRCB", "name": "陕西佳县农村商业银行"},
	{"value": "SXJYTLCUNZB", "name": "陕西泾阳泰隆村镇银行"},
	{"value": "SXJBRCB", "name": "陕西靖边农村商业银行"},
	{"value": "SXLGRCB", "name": "陕西岚皋农村商业银行"},
	{"value": "SXLTRCB", "name": "陕西蓝田农村商业银行"},
	{"value": "SXLZHSCUNZB", "name": "陕西临潼海丝村镇银行"},
	{"value": "SXILYRCB", "name": "陕西麟游农村商业银行"},
	{"value": "SXLXRCB", "name": "陕西陇县农村商业银行"},
	{"value": "SXLXCYCUNZB", "name": "陕西陇县长银村镇银行"},
	{"value": "SXILCRCB", "name": "陕西洛川农村商业银行"},
	{"value": "SXLNYGCUNZB", "name": "陕西洛南阳光村镇银行"},
	{"value": "SXMXRCB", "name": "陕西眉县农村商业银行"},
	{"value": "SXMXTLCUNZB", "name": "陕西眉县泰隆村镇银行"},
	{"value": "SXMZRCB", "name": "陕西米脂农村商业银行"},
	{"value": "SXNZRCB", "name": "陕西南郑农村商业银行"},
	{"value": "SXNSRCB", "name": "陕西宁陕农村商业银行"},
	{"value": "SXNXS", "name": "陕西省农村信用社联合社"},
	{"value": "SXIPLRCB", "name": "陕西平利农村商业银行"},
	{"value": "SXQSCYCUNZB", "name": "陕西岐山长银村镇银行"},
	{"value": "SXQYRCB", "name": "陕西千阳农村商业银行"},
	{"value": "SXQNRCB", "name": "陕西秦农农村商业银行"},
	{"value": "SXQJRCB", "name": "陕西清涧农村商业银行"},
	{"value": "SXSYHSCUNZB", "name": "陕西三原海丝村镇银行"},
	{"value": "SXISYRCB", "name": "陕西山阳农村商业银行"},
	{"value": "SXSNJLCUNZB", "name": "陕西商南聚利村镇银行"},
	{"value": "SXSNRCB", "name": "陕西商南农村商业银行"},
	{"value": "SXSMRCB", "name": "陕西神木农村商业银行"},
	{"value": "SXSQRCB", "name": "陕西石泉农村商业银行"},
	{"value": "SXSDRCB", "name": "陕西绥德农村商业银行"},
	{"value": "SXTBRCB", "name": "陕西太白农村商业银行"},
	{"value": "SXTBCYCUNZB", "name": "陕西太白长银村镇银行"},
	{"value": "SXWBRCB", "name": "陕西吴堡农村商业银行"},
	{"value": "SXWQHFCUNZB", "name": "陕西吴起汇发村镇银行"},
	{"value": "SXWQRCU", "name": "陕西吴起农村合作银行"},
	{"value": "SXIXXRCB", "name": "陕西西乡农村商业银行"},
	{"value": "SXXYQDRCB", "name": "陕西咸阳秦都农村商业银行"},
	{"value": "SXXYWCHFCUNZB", "name": "陕西咸阳渭城汇发村镇银行"},
	{"value": "SXXYWCRCB", "name": "陕西咸阳渭城农村商业银行"},
	{"value": "SXIXYRCB", "name": "陕西旬阳农村商业银行"},
	{"value": "SXXYTLCUNZB", "name": "陕西旬阳泰隆村镇银行"},
	{"value": "SXYLRCB", "name": "陕西杨凌农村商业银行"},
	{"value": "SXYLHSHFCUNZB", "name": "陕西榆林横山汇发村镇银行"},
	{"value": "SXYLYYRCB", "name": "陕西榆林农村商业银行"},
	{"value": "SXZSJLCUNZB", "name": "陕西柞水聚利村镇银行"},
	{"value": "SXZSRCB", "name": "陕西柞水农村商业银行"},
	{"value": "SXCWRCB", "name": "陕西长武农村商业银行"},
	{"value": "SXZARCB", "name": "陕西镇安农村商业银行"},
	{"value": "SXZBRCB", "name": "陕西镇巴农村商业银行"},
	{"value": "SXZPRCB", "name": "陕西镇坪农村商业银行"},
	{"value": "SXZZNKCUNZB", "name": "陕西周至农科村镇银行"},
	{"value": "SXZZHRCB", "name": "陕西周至农村商业银行"},
	{"value": "SXZCRCB", "name": "陕西子长农村商业银行"},
	{"value": "SXIZZRCB", "name": "陕西子洲农村商业银行"},
	{"value": "SXZYRCB", "name": "陕西紫阳农村商业银行"},
	{"value": "STCYRHCUNZB", "name": "汕头潮阳融和村镇银行"},
	{"value": "STLHCJCUNZB", "name": "汕头龙湖长江村镇银行"},
	{"value": "SWRCB", "name": "汕尾农村商业银行"},
	{"value": "ZSZCCUNZB", "name": "鄯善中成村镇银行"},
	{"value": "SQHSRCB", "name": "商丘华商农村商业银行"},
	{"value": "SCAIHMCUNZB", "name": "上蔡惠民村镇银行"},
	{"value": "SHYH", "name": "上海银行"},
	{"value": "SHBSFMCUNZB", "name": "上海宝山富民村镇银行"},
	{"value": "SHBSYZCUNZB", "name": "上海宝山扬子村镇银行"},
	{"value": "SHCMHNSCUNZB", "name": "上海崇明沪农商村镇银行"},
	{"value": "SHFXPFCUNZB", "name": "上海奉贤浦发村镇银行"},
	{"value": "SHRB", "name": "上海华瑞银行股份有限公司"},
	{"value": "SHJDHDCUNZB", "name": "上海嘉定洪都村镇银行"},
	{"value": "SHJDMSCUNZB", "name": "上海嘉定民生村镇银行"},
	{"value": "SHJSHMCUNZB", "name": "上海金山惠民村镇银行"},
	{"value": "SHZXSYCUNZB", "name": "上海闵行上银村镇银行"},
	{"value": "SHRCB", "name": "上海农村商业银行"},
	{"value": "SHPDHTCUNZB", "name": "上海浦东恒通村镇银行"},
	{"value": "SHPDJNCUNZB", "name": "上海浦东江南村镇银行"},
	{"value": "SHQPHJCUNZB", "name": "上海青浦惠金村镇银行"},
	{"value": "SHCB", "name": "上海商业银行"},
	{"value": "SHSJFMCUNZB", "name": "上海松江富明村镇银行"},
	{"value": "SHSJMSCUNZB", "name": "上海松江民生村镇银行"},
	{"value": "SHZCCUNZB", "name": "上杭中成村镇银行"},
	{"value": "SRB", "name": "上饶银行"},
	{"value": "SRRCB", "name": "上饶农村商业银行"},
	{"value": "SZHXCUNZB", "name": "尚志惠鑫村镇银行"},
	{"value": "SSGDCUNZB", "name": "韶山光大村镇银行"},
	{"value": "SWCTHCUNZB", "name": "邵武刺桐红村镇银行"},
	{"value": "HNSYRCB", "name": "邵阳农村商业银行"},
	{"value": "SXYH", "name": "绍兴银行"},
	{"value": "SXQLCUNZB", "name": "涉县齐鲁村镇银行"},
	{"value": "ZXQLCUNZB", "name": "莘县青隆村镇银行"},
	{"value": "SZLFCUNZB", "name": "深泽利丰村镇银行"},
	{"value": "SZBAGYCUNZB", "name": "深圳宝安桂银村镇银行"},
	{"value": "SZBARXCUNZB", "name": "深圳宝安融兴村镇银行"},
	{"value": "FTYZCUNZB", "name": "深圳福田银座村镇银行"},
	{"value": "SZGMHNSCUNZB", "name": "深圳光明沪农商村镇银行"},
	{"value": "SZLGDYCUNZB", "name": "深圳龙岗鼎业村镇银行"},
	{"value": "SZLHXHCUNZB", "name": "深圳龙华新华村镇银行"},
	{"value": "SZLHLHCUNZB", "name": "深圳罗湖蓝海村镇银行"},
	{"value": "SZNSBSCUNZB", "name": "深圳南山宝生村镇银行"},
	{"value": "SZRCB", "name": "深圳农村商业银行"},
	{"value": "SZPSZJCUNZB", "name": "深圳坪山珠江村镇银行"},
	{"value": "SZFYCUNZB", "name": "深州丰源村镇银行"},
	{"value": "SZSYCUNZB", "name": "什邡思源村镇银行"},
	{"value": "SCXHDCUNZB", "name": "神池县河东村镇银行"},
	{"value": "SNJCNSCUNZB", "name": "神农架楚农商村镇银行"},
	{"value": "SYFKFMCUNZB", "name": "沈阳法库富民村镇银行"},
	{"value": "SYKPFYCUNZB", "name": "沈阳康平抚银村镇银行"},
	{"value": "SYLZFMCUNZB", "name": "沈阳辽中富民村镇银行"},
	{"value": "SHENYRCB", "name": "沈阳农村商业银行"},
	{"value": "SYSBFMCUNZB", "name": "沈阳沈北富民村镇银行"},
	{"value": "SYXMFMCUNZB", "name": "沈阳新民富民村镇银行"},
	{"value": "SYYHYACUNZB", "name": "沈阳于洪永安村镇银行"},
	{"value": "SJYH", "name": "盛京银行"},
	{"value": "SBJDCUNZB", "name": "施秉金鼎村镇银行"},
	{"value": "SHZGMCUNZB", "name": "石河子国民村镇银行"},
	{"value": "SJZHRRCU", "name": "石家庄汇融农村合作银行"},
	{"value": "SJZLCQLCUNZB", "name": "石家庄栾城齐鲁村镇银行"},
	{"value": "SJZXHHSCUNZB", "name": "石家庄新华恒升村镇银行"},
	{"value": "SMHNSCUNZB", "name": "石门沪农商村镇银行"},
	{"value": "SQCZCUNZB", "name": "石阡长征村镇银行"},
	{"value": "SSCNSCUNZB", "name": "石首楚农商村镇银行"},
	{"value": "SZSYH", "name": "石嘴山银行"},
	{"value": "SZSSDWKSYCUNZB", "name": "石嘴山市大武口石银村镇银行"},
	{"value": "SXDZCUNZB", "name": "始兴大众村镇银行"},
	{"value": "SGZNSCUNZB", "name": "寿光张农商村镇银行"},
	{"value": "SNCTHCUNZB", "name": "寿宁刺桐红村镇银行"},
	{"value": "SYXHDCUNZB", "name": "寿阳县汇都村镇银行"},
	{"value": "SHULJYCUNZB", "name": "舒兰吉银村镇银行"},
	{"value": "SCHMCUNZB", "name": "双城惠民村镇银行"},
	{"value": "SFHNSCUNZB", "name": "双峰沪农商村镇银行"},
	{"value": "SLJYCUNZB", "name": "双辽吉银村镇银行"},
	{"value": "SCMYCUNZB", "name": "水城蒙银村镇银行"},
	{"value": "SXSZRCB", "name": "朔州农村商业银行"},
	{"value": "SZSSCQMYCUNZB", "name": "朔州市朔城区蒙银村镇银行"},
	{"value": "SNCZCUNZB", "name": "思南长征村镇银行"},
	{"value": "SCAYRCB", "name": "四川安岳农村商业银行"},
	{"value": "SCAZRCB", "name": "四川安州农村商业银行"},
	{"value": "SCBCQZZZXFMCUNZB", "name": "四川北川羌族自治县富民村镇银行"},
	{"value": "SCCXRCB", "name": "四川苍溪农村商业银行"},
	{"value": "SCCDLQZCZCUNZB", "name": "四川成都龙泉驿稠州村镇银行"},
	{"value": "SCCDPJMFCUNZB", "name": "四川成都蒲江民富村镇银行"},
	{"value": "SCDYRCB", "name": "四川大英农村商业银行"},
	{"value": "SCDZRCB", "name": "四川大竹农村商业银行"},
	{"value": "SCDZYNSCUNZB", "name": "四川大竹渝农商村镇银行"},
	{"value": "SCDLRCB", "name": "四川丹棱农村商业银行"},
	{"value": "SCEMSRCB", "name": "四川峨眉山农村商业银行"},
	{"value": "SCFSRCB", "name": "四川富顺农村商业银行"},
	{"value": "SCGAOXRCB", "name": "四川高县农村商业银行"},
	{"value": "SCGXRCB", "name": "四川珙县农村商业银行"},
	{"value": "SCGLRCB", "name": "四川古蔺农村商业银行"},
	{"value": "SCGHRCB", "name": "四川广汉农村商业银行"},
	{"value": "SCGYRCB", "name": "四川广元农村商业银行"},
	{"value": "SCHJRCB", "name": "四川合江农村商业银行"},
	{"value": "SCHYRCB", "name": "四川华蓥农村商业银行"},
	{"value": "SCJWRCB", "name": "四川犍为农村商业银行"},
	{"value": "SCJYRCB", "name": "四川简阳农村商业银行"},
	{"value": "SCJGRCB", "name": "四川剑阁农村商业银行"},
	{"value": "SCJARCB", "name": "四川江安农村商业银行"},
	{"value": "SCJYHXCUNZB", "name": "四川江油华夏村镇银行"},
	{"value": "SCJLRCB", "name": "四川筠连农村商业银行"},
	{"value": "SCLZRCB", "name": "四川阆中农村商业银行"},
	{"value": "SCLEZRCB", "name": "四川乐至农村商业银行"},
	{"value": "SCLSRCB", "name": "四川邻水农村商业银行"},
	{"value": "SCCLRCB", "name": "四川隆昌农村商业银行"},
	{"value": "SCLXRCB", "name": "四川泸县农村商业银行"},
	{"value": "SCLJRCB", "name": "四川罗江农村商业银行"},
	{"value": "SCMZRCB", "name": "四川绵竹农村商业银行"},
	{"value": "SCMSJCCUNZB", "name": "四川名山锦程村镇银行"},
	{"value": "SCNBRCB", "name": "四川南部农村商业银行"},
	{"value": "SCNJRCB", "name": "四川内江农村商业银行"},
	{"value": "SCNXS", "name": "四川省农村信用社联合社"},
	{"value": "SCPXRCB", "name": "四川蓬溪农村商业银行"},
	{"value": "SCPWRCB", "name": "四川平武农村商业银行"},
	{"value": "SCPSRCB", "name": "四川屏山农村商业银行"},
	{"value": "SCQCRCB", "name": "四川青川农村商业银行"},
	{"value": "SCQSRCB", "name": "四川青神农村商业银行"},
	{"value": "SCQXRCB", "name": "四川渠县农村商业银行"},
	{"value": "SCRSRCB", "name": "四川仁寿农村商业银行"},
	{"value": "SCSTRCB", "name": "四川三台农村商业银行"},
	{"value": "SCSHRCB", "name": "四川射洪农村商业银行"},
	{"value": "SCSFRCB", "name": "四川什邡农村商业银行"},
	{"value": "CGNB", "name": "四川天府银行"},
	{"value": "SCWANYRCB", "name": "四川万源农村商业银行"},
	{"value": "SCWYRCB", "name": "四川威远农村商业银行"},
	{"value": "SCWSRCB", "name": "四川武胜农村商业银行"},
	{"value": "SCXCRCB", "name": "四川西充农村商业银行"},
	{"value": "SCXWSHRCB", "name": "四川兴文石海农村商业银行"},
	{"value": "SCXYRCB", "name": "四川叙永农村商业银行"},
	{"value": "SCXHRCB", "name": "四川宣汉农村商业银行"},
	{"value": "SCYLHMCUNZB", "name": "四川仪陇惠民村镇银行"},
	{"value": "SCYLRCB", "name": "四川仪陇农村商业银行"},
	{"value": "SCYBJJRCB", "name": "四川宜宾金江农村商业银行"},
	{"value": "SCYSRCB", "name": "四川营山农村商业银行"},
	{"value": "SCYCRCB", "name": "四川岳池农村商业银行"},
	{"value": "SCCNZHRCB", "name": "四川长宁竹海农村商业银行"},
	{"value": "SCZTRCB", "name": "四川梓潼农村商业银行"},
	{"value": "SPLHZYCUNZB", "name": "四平辽河蛟银村镇银行"},
	{"value": "SPTDDFCUNZB", "name": "四平铁东德丰村镇银行"},
	{"value": "SPTXDYCUNZB", "name": "四平铁西敦银村镇银行"},
	{"value": "SZWMYCUNZB", "name": "四子王蒙银村镇银行"},
	{"value": "STCZCUNZB", "name": "松桃长征村镇银行"},
	{"value": "SYNJHMCUNZB", "name": "松原宁江惠民村镇银行"},
	{"value": "ZMHNSCUNZB", "name": "嵩明沪农商村镇银行"},
	{"value": "SZYH", "name": "苏州银行"},
	{"value": "SUZRCB", "name": "苏州农村商业银行"},
	{"value": "SZWZZJCUNZB", "name": "苏州吴中珠江村镇银行"},
	{"value": "ZXDSCUNZB", "name": "睢县德商村镇银行"},
	{"value": "SYQBCUNZB", "name": "绥阳黔北村镇银行"},
	{"value": "SZCFCUNZB", "name": "绥中长丰村镇银行"},
	{"value": "SXCNSCUNZB", "name": "随县楚农商村镇银行"},
	{"value": "SCHDCUNZB", "name": "遂川洪都村镇银行"},
	{"value": "SNSCCB", "name": "遂宁市商业银行"},
	{"value": "SNAJRXCUNZB", "name": "遂宁安居融兴村镇银行"},
	{"value": "SNRCB", "name": "遂宁农村商业银行"},
	{"value": "SPZYCUNZB", "name": "遂平中原村镇银行"},
	{"value": "TCJHCUNZB", "name": "塔城津汇村镇银行"},
	{"value": "TCKLCUNZB", "name": "塔城昆仑村镇银行"},
	{"value": "TJFMCUNZB", "name": "台江富民村镇银行"},
	{"value": "TQDSCUNZB", "name": "台前德商村镇银行"},
	{"value": "TWYH", "name": "台湾银行"},
	{"value": "TWTDB", "name": "台湾土地银行"},
	{"value": "TWZXQYB", "name": "台湾中小企业银行"},
	{"value": "TZYH", "name": "台州银行"},
	{"value": "TAICMSCUNZB", "name": "太仓民生村镇银行"},
	{"value": "TCRCB", "name": "太仓农村商业银行"},
	{"value": "TGXXTCUNZB", "name": "太谷县兴泰村镇银行"},
	{"value": "TPSQZYCUNZB", "name": "太仆寺旗鑫源村镇银行"},
	{"value": "TYSJCPQXDCUNZB", "name": "太原市尖草坪区信都村镇银行"},
	{"value": "TACCB", "name": "泰安银行"},
	{"value": "TADYRCB", "name": "泰安岱岳农村商业银行"},
	{"value": "TAHNSCUNZB", "name": "泰安沪农商村镇银行"},
	{"value": "TATSRCB", "name": "泰安泰山农村商业银行"},
	{"value": "SIAMCB", "name": "泰国汇商银行"},
	{"value": "TGTJB", "name": "泰国泰京银行"},
	{"value": "ZJTLCCB", "name": "浙江泰隆商业银行"},
	{"value": "TZJYXZCUNZB", "name": "泰州姜堰锡州村镇银行"},
	{"value": "TSYH", "name": "唐山银行"},
	{"value": "TSSFNSFCUNZB", "name": "唐山市丰南舜丰村镇银行"},
	{"value": "TSSKPHJCUNZB", "name": "唐山市开平汇金村镇银行"},
	{"value": "TXHZCUNZB", "name": "唐县汇泽村镇银行"},
	{"value": "ZNHMCUNZB", "name": "洮南惠民村镇银行"},
	{"value": "TENGCMSCUNZB", "name": "腾冲民生村镇银行"},
	{"value": "TJYH", "name": "天津银行"},
	{"value": "TJBZPFCUNZB", "name": "天津宝坻浦发村镇银行"},
	{"value": "TJBHDSCUNZB", "name": "天津滨海德商村镇银行"},
	{"value": "TJBHHMCUNZB", "name": "天津滨海惠民村镇银行"},
	{"value": "TJBJJHCUNZB", "name": "天津滨海江淮村镇银行"},
	{"value": "TJBHB", "name": "天津滨海农村商业银行"},
	{"value": "TJBHYZCUNZB", "name": "天津滨海扬子村镇银行"},
	{"value": "TJHMCUNZB", "name": "天津华明村镇银行"},
	{"value": "TJJCB", "name": "天津金城银行"},
	{"value": "TJJNCUNZB", "name": "天津津南村镇银行"},
	{"value": "TJJHXHCUNZB", "name": "天津静海新华村镇银行"},
	{"value": "TJNHCUNZB", "name": "天津宁河村镇银行"},
	{"value": "TJRCB", "name": "天津农村商业银行"},
	{"value": "TJSBCCUNZB", "name": "天津市北辰村镇银行"},
	{"value": "TJSJZCUNZB", "name": "天津市蓟州村镇银行"},
	{"value": "TJWQCUNZB", "name": "天津武清村镇银行"},
	{"value": "TSMJRCU", "name": "天水麦积农村合作银行"},
	{"value": "TSMJRXCUNZB", "name": "天水麦积融兴村镇银行"},
	{"value": "TSQZRCU", "name": "天水秦州农村合作银行"},
	{"value": "TSQZCYCUNZB", "name": "天水秦州长银村镇银行"},
	{"value": "TSSQAZXCUNZB", "name": "天水市秦安众信村镇银行"},
	{"value": "TCMSCUNZB", "name": "天长民生村镇银行"},
	{"value": "TZXHDCUNZB", "name": "天镇县河东村镇银行"},
	{"value": "TDBBWCUNZB", "name": "田东北部湾村镇银行"},
	{"value": "TYXYCUNZB", "name": "田阳兴阳村镇银行"},
	{"value": "DBSHMCUNZB", "name": "调兵山惠民村镇银行"},
	{"value": "TLYH", "name": "铁岭银行"},
	{"value": "TLNSCUNZB", "name": "铁岭农商村镇银行"},
	{"value": "TLXXCUNZB", "name": "铁岭新星村镇银行"},
	{"value": "TMGJHCUNZB", "name": "铁门关津汇村镇银行"},
	{"value": "TCHMCUNZB", "name": "通城惠民村镇银行"},
	{"value": "THDCYYCUNZB", "name": "通化东昌榆银村镇银行"},
	{"value": "THEDJRFCUNZB", "name": "通化二道江瑞丰村镇银行"},
	{"value": "THRCB", "name": "通化农村商业银行股份有限公司"},
	{"value": "THRDCUNZB", "name": "通化融达村镇银行"},
	{"value": "TLJGCUNZB", "name": "通辽金谷村镇银行"},
	{"value": "TLNMRCU", "name": "通辽奈曼农村合作银行"},
	{"value": "TSCNSCUNZB", "name": "通山楚农商村镇银行"},
	{"value": "TXRXCUNZB", "name": "通许融信村镇银行"},
	{"value": "TYNSCUNZB", "name": "通榆农商村镇银行"},
	{"value": "TJHXCUNZB", "name": "同江汇鑫村镇银行"},
	{"value": "TCYZXHCUNZB", "name": "铜川耀州新华村镇银行"},
	{"value": "TCYTHTCUNZB", "name": "铜川印台恒通村镇银行"},
	{"value": "TGJYCUNZB", "name": "铜鼓九银村镇银行"},
	{"value": "TLRCB", "name": "铜陵农村商业银行"},
	{"value": "TLWJRCB", "name": "铜陵皖江农村商业银行"},
	{"value": "TRFYCUNZB", "name": "铜仁丰源村镇银行"},
	{"value": "TRRCB", "name": "铜仁农村商业银行"},
	{"value": "TRWSCZCUNZB", "name": "铜仁万山长征村镇银行"},
	{"value": "ZNMSCUNZB", "name": "潼南民生村镇银行"},
	{"value": "TQMYCUNZB", "name": "突泉蒙银村镇银行"},
	{"value": "TMDYCUNZB", "name": "图们敦银村镇银行"},
	{"value": "TMTYQMYCUNZB", "name": "土默特右旗蒙银村镇银行"},
	{"value": "TMTZQJGCUNZB", "name": "土默特左旗金谷村镇银行"},
	{"value": "TFCNSCUNZB", "name": "团风楚农商村镇银行"},
	{"value": "TLXSHCUNZB", "name": "屯留县三禾村镇银行"},
	{"value": "WFDCXCUNZB", "name": "瓦房店长兴村镇银行"},
	{"value": "WAHDCUNZB", "name": "万安洪都村镇银行"},
	{"value": "WNHHCUNZB", "name": "万年稻源村镇银行"},
	{"value": "WNGMCUNZB", "name": "万宁金谷村镇银行"},
	{"value": "WRXHMCUNZB", "name": "万荣县汇民村镇银行"},
	{"value": "WQHRCUNZB", "name": "汪清和润村镇银行"},
	{"value": "ZJWS", "name": "浙江网商银行股份有限公司"},
	{"value": "WDZCCUNZB", "name": "望都中成村镇银行"},
	{"value": "WJXHCUNZB", "name": "望江新华村镇银行"},
	{"value": "WZFMCUNZB", "name": "望谟富民村镇银行"},
	{"value": "WHCCB", "name": "威海市商业银行"},
	{"value": "WHFMCUNZB", "name": "威海富民村镇银行"},
	{"value": "WHLHB", "name": "威海蓝海银行"},
	{"value": "WNFMCUNZB", "name": "威宁富民村镇银行"},
	{"value": "WXXNSCUNZB", "name": "威县邢农商村镇银行"},
	{"value": "WSBHCUNZB", "name": "微山北海村镇银行"},
	{"value": "WEBANK", "name": "深圳前海微众银行"},
	{"value": "WCMZMGZZZXHSCUNZB", "name": "围场满族蒙古族自治县华商村镇银行"},
	{"value": "WFYH", "name": "潍坊银行"},
	{"value": "WFRCB", "name": "潍坊农村商业银行"},
	{"value": "WFSHTQMYCUNZB", "name": "潍坊市寒亭区蒙银村镇银行"},
	{"value": "WFSKWQZCCUNZB", "name": "潍坊市奎文区中成村镇银行"},
	{"value": "WFSWCQBHCUNZB", "name": "潍坊市潍城区北海村镇银行"},
	{"value": "WHUIFMCUNZB", "name": "卫辉富民村镇银行"},
	{"value": "WLDXJYCUNZB", "name": "尉犁达西冀银村镇银行"},
	{"value": "WSHYCUNZB", "name": "尉氏合益村镇银行"},
	{"value": "WXYTCUNZB", "name": "蔚县银泰村镇银行"},
	{"value": "WXQLCUNZB", "name": "魏县齐鲁村镇银行"},
	{"value": "WENXQLCUNZB", "name": "温县齐鲁村镇银行"},
	{"value": "WZYH", "name": "温州银行股份有限公司"},
	{"value": "WZMSYH", "name": "温州民商银行"},
	{"value": "WAXHMCUNZB", "name": "文安县惠民村镇银行"},
	{"value": "WCDZCUNZB", "name": "文昌大众村镇银行"},
	{"value": "WSFNCJCUNZB", "name": "文山富宁长江村镇银行"},
	{"value": "WSGNCJCUNZB", "name": "文山广南长江村镇银行"},
	{"value": "WSMGCJCUNZB", "name": "文山马关长江村镇银行"},
	{"value": "WSMFCUNZB", "name": "文山民丰村镇银行"},
	{"value": "WSQBCJCUNZB", "name": "文山丘北长江村镇银行"},
	{"value": "WSYSCJCUNZB", "name": "文山砚山长江村镇银行"},
	{"value": "WSXRDCUNZB", "name": "文水县润都村镇银行"},
	{"value": "WXXJRCUNZB", "name": "闻喜县晋融村镇银行"},
	{"value": "WNTLNCUNZB", "name": "翁牛特立农村镇银行"},
	{"value": "WAFMCUNZB", "name": "瓮安富民村镇银行"},
	{"value": "WHYH", "name": "乌海银行"},
	{"value": "WHQLSHTCUNZB", "name": "乌海千里山河套村镇银行"},
	{"value": "WHSHBWHHCUNZB", "name": "乌海市海勃湾黄河村镇银行"},
	{"value": "WHSWLTCUNZB", "name": "乌海市乌拉特村镇银行"},
	{"value": "WLTQQDZCUNZB", "name": "乌拉特前旗大众村镇银行"},
	{"value": "WLTZQMYCUNZB", "name": "乌拉特中旗蒙银村镇银行"},
	{"value": "WLCBRCB", "name": "乌兰察布农村商业银行"},
	{"value": "WLCBSJNBSCUNZB", "name": "乌兰察布市集宁蒙商村镇银行"},
	{"value": "WLMQYH", "name": "乌鲁木齐银行"},
	{"value": "WLMQMDPFCUNZB", "name": "乌鲁木齐米东浦发村镇银行"},
	{"value": "WLMQXLFCUNZB", "name": "乌鲁木齐县利丰村镇银行"},
	{"value": "WSQBSCUNZB", "name": "乌审旗蒙商村镇银行"},
	{"value": "WSLFCUNZB", "name": "乌苏利丰村镇银行"},
	{"value": "WZZCCUNZB", "name": "无棣中成村镇银行"},
	{"value": "WWHYCUNZB", "name": "无为徽银村镇银行"},
	{"value": "WXRCB", "name": "无锡农村商业银行"},
	{"value": "WXXSB", "name": "无锡锡商银行"},
	{"value": "WHJSRCB", "name": "芜湖津盛农村商业银行"},
	{"value": "WHYZRCB", "name": "芜湖扬子农村商业银行"},
	{"value": "WHYHCUNZB", "name": "芜湖圆融村镇银行"},
	{"value": "WQRXCUNZB", "name": "吴桥融信村镇银行"},
	{"value": "WZSBHCUNZB", "name": "吴忠市滨河村镇银行"},
	{"value": "WCHMCUNZB", "name": "五常惠民村镇银行"},
	{"value": "WDLCHFCUNZB", "name": "五大连池惠丰村镇银行"},
	{"value": "WFJGCUNZB", "name": "五峰金谷村镇银行"},
	{"value": "WHHMCUNZB", "name": "五华惠民村镇银行"},
	{"value": "WJQGMCUNZB", "name": "五家渠国民村镇银行"},
	{"value": "WTLSCUNZB", "name": "五台莱商村镇银行"},
	{"value": "WYMYCUNZB", "name": "五原蒙银村镇银行"},
	{"value": "WACUNZB", "name": "武安村镇银行"},
	{"value": "WCYRCUNZB", "name": "武城圆融村镇银行"},
	{"value": "WCLNCUNZB", "name": "武川立农村镇银行"},
	{"value": "WGBSCUNZB", "name": "武冈发展村镇银行"},
	{"value": "WHDXHYZCUNZB", "name": "武汉东西湖扬子村镇银行"},
	{"value": "WHJXMSCUNZB", "name": "武汉江夏民生村镇银行"},
	{"value": "WHRCB", "name": "武汉农村商业银行"},
	{"value": "WHZBB", "name": "武汉众邦银行"},
	{"value": "WLRXCUNZB", "name": "武隆融兴村镇银行"},
	{"value": "WNHTCUNZB", "name": "武宁恒通村镇银行"},
	{"value": "WQJYCUNZB", "name": "武强家银村镇银行"},
	{"value": "WWRCB", "name": "武威农村商业银行"},
	{"value": "WXXZDCUNZB", "name": "武乡县泽都村镇银行"},
	{"value": "WYSBFCUNZB", "name": "武夷山本富村镇银行"},
	{"value": "WYXNSCUNZB", "name": "武邑邢农商村镇银行"},
	{"value": "WZSYCUNZB", "name": "武陟射阳村镇银行"},
	{"value": "WYYCCUNZB", "name": "舞阳玉川村镇银行"},
	{"value": "XAYH", "name": "西安银行"},
	{"value": "XAGLYGCUNZB", "name": "西安高陵阳光村镇银行"},
	{"value": "XAHYRCB", "name": "西安鄠邑农村商业银行"},
	{"value": "XAYTHTCUNZB", "name": "西安雁塔恒通村镇银行"},
	{"value": "XACAXHCUNZB", "name": "西安长安新华村镇银行"},
	{"value": "BBVA", "name": "西班牙对外银行"},
	{"value": "SANTANDER", "name": "西班牙桑坦德银行"},
	{"value": "XICYH", "name": "西藏银行"},
	{"value": "XZDLMTCUNZB", "name": "西藏堆龙民泰村镇银行"},
	{"value": "XCJXCUNZB", "name": "西昌金信村镇银行"},
	{"value": "XFLCCUNZB", "name": "西丰鹿城村镇银行"},
	{"value": "XPCFCUNZB", "name": "西平中原村镇银行"},
	{"value": "XSBNZHCJCUNZB", "name": "西双版纳勐海长江村镇银行"},
	{"value": "XSBNZLCJCUNZB", "name": "西双版纳勐腊长江村镇银行"},
	{"value": "XWZMQBSHFCUNZB", "name": "西乌珠穆沁蒙商惠丰村镇银行"},
	{"value": "XFBSQLCUNZB", "name": "息烽发展村镇银行"},
	{"value": "XSCNSCUNZB", "name": "浠水楚农商村镇银行"},
	{"value": "XLHTRCU", "name": "锡林浩特农村合作银行"},
	{"value": "ZXXTCUNZB", "name": "隰县新田村镇银行"},
	{"value": "XJHDCUNZB", "name": "峡江洪都村镇银行"},
	{"value": "XPCTHCUNZB", "name": "霞浦刺桐红村镇银行"},
	{"value": "XJJDCUNZB", "name": "夏津胶东村镇银行"},
	{"value": "XXHDCUNZB", "name": "夏县河东村镇银行"},
	{"value": "XTCNSCUNZB", "name": "仙桃楚农商村镇银行"},
	{"value": "XXRHCUNZB", "name": "献县融和村镇银行"},
	{"value": "XHYMCUNZB", "name": "香河益民村镇银行"},
	{"value": "XTRCB", "name": "湘潭农村商业银行"},
	{"value": "XXCXCUNZB", "name": "湘西长行村镇银行"},
	{"value": "XXSCUNZB", "name": "湘乡市村镇银行"},
	{"value": "XCHPCUNZB", "name": "襄城中原村镇银行"},
	{"value": "XFXWDCUNZB", "name": "襄汾县万都村镇银行"},
	{"value": "XYXRHCUNZB", "name": "襄垣县融汇村镇银行"},
	{"value": "XSGMCUNZB", "name": "象山国民村镇银行"},
	{"value": "XCBFCUNZB", "name": "孝昌本富村镇银行"},
	{"value": "XJQLCUNZB", "name": "辛集齐鲁村镇银行"},
	{"value": "XZSXFQXDCUNZB", "name": "忻州市忻府区秀都村镇银行"},
	{"value": "XARXCUNZB", "name": "新安融兴村镇银行"},
	{"value": "XDGCCUNZB", "name": "新都桂城村镇银行"},
	{"value": "XHYH", "name": "新韩银行（中国）有限公司"},
	{"value": "XJB", "name": "新疆银行"},
	{"value": "XJAKSRCB", "name": "新疆阿克苏农村商业银行"},
	{"value": "XJBTRCB", "name": "新疆北屯农村商业银行"},
	{"value": "XJBHRCB", "name": "新疆博湖农村商业银行"},
	{"value": "XJBLRCB", "name": "新疆博乐农村商业银行"},
	{"value": "XJCJRCB", "name": "新疆昌吉农村商业银行"},
	{"value": "XJFKRCB", "name": "新疆阜康农村商业银行"},
	{"value": "XJHTBRCB", "name": "新疆呼图壁农村商业银行"},
	{"value": "XJHHB", "name": "新疆汇和银行"},
	{"value": "XJHCRCB", "name": "新疆霍城农村商业银行"},
	{"value": "XJJMSERCB", "name": "新疆吉木萨尔农村商业银行"},
	{"value": "XJJXCGCUNZB", "name": "新疆建新成功村镇银行"},
	{"value": "XJKSRCB", "name": "新疆喀什农村商业银行"},
	{"value": "XJKELFMCUNZB", "name": "新疆库尔勒富民村镇银行"},
	{"value": "XJKELRCB", "name": "新疆库尔勒农村商业银行"},
	{"value": "XJLTRCB", "name": "新疆轮台农村商业银行"},
	{"value": "XJLZGMCUNZB", "name": "新疆绿洲国民村镇银行"},
	{"value": "XJNXS", "name": "新疆维吾尔自治区农村信用社联合社"},
	{"value": "XJQTRCB", "name": "新疆奇台农村商业银行"},
	{"value": "XJSWRCB", "name": "新疆沙湾农村商业银行"},
	{"value": "XJSHZJYCUNZB", "name": "新疆石河子交银村镇银行"},
	{"value": "XJSHZRCU", "name": "新疆石河子农村合作银行"},
	{"value": "XJTCRCB", "name": "新疆塔城农村商业银行"},
	{"value": "XJTSRCB", "name": "新疆天山农村商业银行"},
	{"value": "XJYLIRCB", "name": "新疆尉犁农村商业银行"},
	{"value": "XJWSURCB", "name": "新疆温宿农村商业银行"},
	{"value": "XJWLMQRCB", "name": "新疆乌鲁木齐农村商业银行"},
	{"value": "XJWSRCB", "name": "新疆乌苏农村商业银行"},
	{"value": "XJYLRCB", "name": "新疆伊犁农村商业银行"},
	{"value": "XZXXTCUNZB", "name": "新绛县新田村镇银行"},
	{"value": "XJZJCUNZB", "name": "新津珠江村镇银行"},
	{"value": "XLSYYY", "name": "新联商业银行"},
	{"value": "XMZYCUNZB", "name": "新密郑银村镇银行"},
	{"value": "XWB", "name": "四川新网银行"},
	{"value": "XXZYCUNZB", "name": "新乡中原村镇银行"},
	{"value": "XYKMJCGCUNZB", "name": "新余孔目江成功村镇银行"},
	{"value": "XYRCB", "name": "新余农村商业银行"},
	{"value": "XYYSXHCUNZB", "name": "新余渝水湘淮村镇银行"},
	{"value": "XZZYCUNZB", "name": "新郑郑银村镇银行"},
	{"value": "XYPQZYCUNZB", "name": "信阳平桥中原村镇银行"},
	{"value": "XINYZJCUNZB", "name": "信阳珠江村镇银行"},
	{"value": "DBSBANK", "name": "星展银行"},
	{"value": "XTYH", "name": "邢台银行"},
	{"value": "XTXXNSCUNZB", "name": "邢台县邢农商村镇银行"},
	{"value": "XAMKEQBSCUNZB", "name": "兴安盟科尔沁蒙商村镇银行"},
	{"value": "XCCXCUNZB", "name": "兴城长兴村镇银行"},
	{"value": "XFCUNZB", "name": "兴福村镇银行"},
	{"value": "XHBSCUNZB", "name": "兴和蒙商村镇银行"},
	{"value": "XHSNCUNZB", "name": "兴化苏南村镇银行"},
	{"value": "XNZJCUNZB", "name": "兴宁珠江村镇银行"},
	{"value": "XRZXCUNZB", "name": "兴仁振兴村镇银行"},
	{"value": "XSBFCUNZB", "name": "兴山本富村镇银行"},
	{"value": "XXHZCUNZB", "name": "兴县汇泽村镇银行"},
	{"value": "CIB", "name": "兴业银行"},
	{"value": "XYWFCUNZB", "name": "兴义万丰村镇银行"},
	{"value": "XXFYCUNZB", "name": "雄县丰源村镇银行"},
	{"value": "XSJYCUNZB", "name": "修水九银村镇银行"},
	{"value": "XWJHCUNZB", "name": "修文江海村镇银行"},
	{"value": "XCXPCUNZB", "name": "许昌新浦村镇银行"},
	{"value": "XCWNRCB", "name": "宣城皖南农村商业银行"},
	{"value": "XHCMCUNZB", "name": "宣汉诚民村镇银行"},
	{"value": "XHZCCUNZB", "name": "宣化中成村镇银行"},
	{"value": "XDZCCUNZB", "name": "寻甸中成村镇银行"},
	{"value": "YASCCB", "name": "雅安市商业银行"},
	{"value": "YARCB", "name": "雅安农村商业银行"},
	{"value": "YAYCHMCUNZB", "name": "雅安雨城惠民村镇银行"},
	{"value": "YTYH", "name": "烟台银行"},
	{"value": "YTFSZJCUNZB", "name": "烟台福山珠江村镇银行"},
	{"value": "YTRCB", "name": "烟台农村商业银行"},
	{"value": "ZLZYCUNZB", "name": "鄢陵郑银村镇银行"},
	{"value": "YANRCB", "name": "延安农村商业银行"},
	{"value": "YBRCB", "name": "延边农村商业银行"},
	{"value": "YJHRCUNZB", "name": "延吉和润村镇银行"},
	{"value": "YSRXCUNZB", "name": "延寿融兴村镇银行"},
	{"value": "YHCZCUNZB", "name": "沿河长征村镇银行"},
	{"value": "SZZCCUNZB", "name": "兖州中成村镇银行"},
	{"value": "ZSRXCUNZB", "name": "偃师融兴村镇银行"},
	{"value": "YZHFCUNZB", "name": "扬中恒丰村镇银行"},
	{"value": "YZGLZCCUNZB", "name": "扬州广陵中成村镇银行"},
	{"value": "YCXSHCUNZB", "name": "阳城县三禾村镇银行"},
	{"value": "YGXXDCUNZB", "name": "阳高县兴都村镇银行"},
	{"value": "YGHNSCUNZB", "name": "阳谷沪农商村镇银行"},
	{"value": "YJYCCJCUNZB", "name": "阳江阳春长江村镇银行"},
	{"value": "YQXHMCUNZB", "name": "阳曲县汇民村镇银行"},
	{"value": "YXHYCUNZB", "name": "阳新汉银村镇银行"},
	{"value": "YXHHCUNZB", "name": "阳信河海村镇银行"},
	{"value": "YICQLCUNZB", "name": "伊川齐鲁村镇银行"},
	{"value": "YICRCB", "name": "伊春农村商业银行"},
	{"value": "YJHLJGCUNZB", "name": "伊金霍洛金谷村镇银行"},
	{"value": "YJHLLLCUNZB", "name": "伊金霍洛六菱村镇银行"},
	{"value": "YLGMCUNZB", "name": "伊犁国民村镇银行"},
	{"value": "YTYYCUNZB", "name": "伊通榆银村镇银行"},
	{"value": "YARSCUNZB", "name": "依安润生村镇银行"},
	{"value": "YLHXCUNZB", "name": "依兰惠鑫村镇银行"},
	{"value": "YYBSCUNZB", "name": "沂源博商村镇银行"},
	{"value": "YBSCCB", "name": "宜宾市商业银行"},
	{"value": "YIBRCB", "name": "宜宾农村商业银行"},
	{"value": "YBXYCUNZB", "name": "宜宾兴宜村镇银行"},
	{"value": "YCRCB", "name": "宜春农村商业银行"},
	{"value": "YDMSCUNZB", "name": "宜都民生村镇银行"},
	{"value": "YHFSCUNZB", "name": "宜黄抚商村镇银行"},
	{"value": "YXYXCUNZB", "name": "宜兴阳羡村镇银行"},
	{"value": "YZCXCUNZB", "name": "宜章长行村镇银行"},
	{"value": "YZSTCUNZB", "name": "宜州深通村镇银行"},
	{"value": "ZYLHCUNZB", "name": "弋阳蓝海村镇银行"},
	{"value": "YYRCB", "name": "益阳农村商业银行"},
	{"value": "YDLLHSBL", "name": "意大利联合圣保罗银行"},
	{"value": "UNICREDITO", "name": "意大利裕信银行"},
	{"value": "YCZZSYCUNZB", "name": "银川掌政石银村镇银行"},
	{"value": "INDIASB", "name": "印度国家银行"},
	{"value": "YDNXYMDLB", "name": "印度尼西亚曼底利银行"},
	{"value": "YJCZCUNZB", "name": "印江长征村镇银行"},
	{"value": "YGBLKYH", "name": "英国巴克莱银行有限公司"},
	{"value": "YINGTRCB", "name": "鹰潭农村商业银行"},
	{"value": "YTYHHTCUNZB", "name": "鹰潭月湖恒通村镇银行"},
	{"value": "XYLFCUNZB", "name": "荥阳利丰村镇银行"},
	{"value": "YKYH", "name": "营口银行"},
	{"value": "YKHCCUNZB", "name": "营口宏诚村镇银行"},
	{"value": "YKRCB", "name": "营口农村商业银行"},
	{"value": "YKRSRCB", "name": "营口融生农村商业银行"},
	{"value": "YCRXCUNZB", "name": "应城融兴村镇银行"},
	{"value": "YXJDCUNZB", "name": "应县金都村镇银行"},
	{"value": "YCQLCUNZB", "name": "永城齐鲁村镇银行"},
	{"value": "SINOPAC", "name": "永丰银行"},
	{"value": "YFHDCUNZB", "name": "永丰洪都村镇银行"},
	{"value": "YJJQCUNZB", "name": "永吉吉庆村镇银行"},
	{"value": "YJSSHCUNZB", "name": "永济市三禾村镇银行"},
	{"value": "YJXJCCUNZB", "name": "永靖县金城村镇银行"},
	{"value": "WINGLBANK", "name": "永隆银行有限公司"},
	{"value": "YQJYCUNZB", "name": "永清吉银村镇银行"},
	{"value": "YXLLCUNZB", "name": "永新庐陵村镇银行"},
	{"value": "YXHNSCUNZB", "name": "永兴沪农商村镇银行"},
	{"value": "YXZYCUNZB", "name": "永修浔银村镇银行"},
	{"value": "YZRCB", "name": "永州农村商业银行"},
	{"value": "PSBC", "name": "中国邮政储蓄银行"},
	{"value": "YLYH", "name": "友利银行（中国）有限公司"},
	{"value": "YYXCQCUNZB", "name": "右玉县长青村镇银行"},
	{"value": "YGHTCUNZB", "name": "余干恒通村镇银行"},
	{"value": "YYTJCUNZB", "name": "余姚通济村镇银行"},
	{"value": "YXHMCUNZB", "name": "盂县汇民村镇银行"},
	{"value": "YTQLCUNZB", "name": "鱼台青隆村镇银行"},
	{"value": "YLYYMSCUNZB", "name": "榆林榆阳民生村镇银行"},
	{"value": "YUSRXCUNZB", "name": "榆树融兴村镇银行"},
	{"value": "YZPFCUNZB", "name": "榆中浦发村镇银行"},
	{"value": "YCTSCUNZB", "name": "虞城通商村镇银行"},
	{"value": "YCJDCUNZB", "name": "禹城胶东村镇银行"},
	{"value": "YZXMSCUNZB", "name": "禹州新民生村镇银行"},
	{"value": "YPCZCUNZB", "name": "玉屏长征村镇银行"},
	{"value": "YSYH", "name": "玉山银行"},
	{"value": "YSSQSCUNZB", "name": "玉山三清山村镇银行"},
	{"value": "YTDSCUNZB", "name": "玉田大商村镇银行"},
	{"value": "YXCJZCCUNZB", "name": "玉溪澄江中成村镇银行"},
	{"value": "YXHTCUNZB", "name": "玉溪红塔村镇银行"},
	{"value": "YSXRCUNZB", "name": "元氏信融村镇银行"},
	{"value": "YJPFCUNZB", "name": "沅江浦发村镇银行"},
	{"value": "YQXHDCUNZB", "name": "垣曲县河东村镇银行"},
	{"value": "YPSHMCUNZB", "name": "原平市汇民村镇银行"},
	{"value": "YAJGCUNZB", "name": "远安金谷村镇银行"},
	{"value": "YAHMCUNZB", "name": "云安惠民村镇银行"},
	{"value": "YFXXDYCUNZB", "name": "云浮新兴东盈村镇银行"},
	{"value": "YMCNSCUNZB", "name": "云梦楚农商村镇银行"},
	{"value": "YNANCZCUNZB", "name": "云南安宁稠州村镇银行"},
	{"value": "YNBCRCB", "name": "云南宾川农村商业银行"},
	{"value": "YNCNRCB", "name": "云南昌宁农村商业银行"},
	{"value": "YNCXRCB", "name": "云南楚雄农村商业银行"},
	{"value": "YNDLRCB", "name": "云南大理农村商业银行"},
	{"value": "YNDLYNSCUNZB", "name": "云南大理渝农商村镇银行"},
	{"value": "YNDYRCB", "name": "云南大姚农村商业银行"},
	{"value": "YNEYRCB", "name": "云南洱源农村商业银行"},
	{"value": "YNFQRCB", "name": "云南凤庆农村商业银行"},
	{"value": "YNHKRCB", "name": "云南河口农村商业银行"},
	{"value": "YNHQYNSCUNZB", "name": "云南鹤庆渝农商村镇银行"},
	{"value": "YNHTBANK", "name": "云南红塔银行"},
	{"value": "YNJSRCB", "name": "云南建水农村商业银行"},
	{"value": "YNJDRCB", "name": "云南景东农村商业银行"},
	{"value": "YNJHRCB", "name": "云南景洪农村商业银行"},
	{"value": "YNLCLXRCB", "name": "云南临沧临翔农村商业银行"},
	{"value": "YNLCRCB", "name": "云南陇川农村商业银行"},
	{"value": "YNLLRCB", "name": "云南陆良农村商业银行"},
	{"value": "YNLFRCB", "name": "云南禄丰农村商业银行"},
	{"value": "YNLPRCB", "name": "云南罗平农村商业银行"},
	{"value": "YNMLBYCUNZB", "name": "云南马龙北银村镇银行"},
	{"value": "YNMSRCB", "name": "云南芒市农村商业银行"},
	{"value": "YNMZRCB", "name": "云南蒙自农村商业银行"},
	{"value": "YNMLRCB", "name": "云南勐腊农村商业银行"},
	{"value": "YNMILRCB", "name": "云南弥勒农村商业银行"},
	{"value": "YNNHRCB", "name": "云南南华农村商业银行"},
	{"value": "YNNXS", "name": "云南省农村信用社联合社"},
	{"value": "YNPESMRCB", "name": "云南普洱思茅农村商业银行"},
	{"value": "YNRLNPRCB", "name": "云南瑞丽南屏农村商业银行"},
	{"value": "YNSPBYCUNZB", "name": "云南石屏北银村镇银行"},
	{"value": "YNSFRCB", "name": "云南水富农村商业银行"},
	{"value": "YNSMRCB", "name": "云南嵩明农村商业银行"},
	{"value": "YNTCRCB", "name": "云南腾冲农村商业银行"},
	{"value": "YNTHRCB", "name": "云南通海农村商业银行"},
	{"value": "YNWXRCB", "name": "云南威信农村商业银行"},
	{"value": "YNWSRCB", "name": "云南巍山农村商业银行"},
	{"value": "YNWSSRCB", "name": "云南文山市农村商业银行"},
	{"value": "YNXSBYCUNZB", "name": "云南西山北银村镇银行"},
	{"value": "YNXSYNSCUNZB", "name": "云南西山渝农商村镇银行"},
	{"value": "YNXGLLYNSCUNZB", "name": "云南香格里拉渝农商村镇银行"},
	{"value": "YNXYRCB", "name": "云南祥云农村商业银行"},
	{"value": "YNXYYNSCUNZB", "name": "云南祥云渝农商村镇银行"},
	{"value": "YNXPBYCUNZB", "name": "云南新平北银村镇银行"},
	{"value": "YNXPRCB", "name": "云南新平农村商业银行"},
	{"value": "YNXDRCB", "name": "云南寻甸农村商业银行"},
	{"value": "YNYMRCB", "name": "云南易门农村商业银行"},
	{"value": "YNYJRCB", "name": "云南盈江农村商业银行"},
	{"value": "YNYSRCB", "name": "云南永胜农村商业银行"},
	{"value": "YNYULRCB", "name": "云南玉龙农村商业银行"},
	{"value": "YNYXHTRCB", "name": "云南玉溪红塔农村商业银行"},
	{"value": "YNYJBYCUNZB", "name": "云南元江北银村镇银行"},
	{"value": "YNYLRCB", "name": "云南云龙农村商业银行"},
	{"value": "YNYXRCB", "name": "云南云县农村商业银行"},
	{"value": "YNZTZYRCB", "name": "云南昭通昭阳农村商业银行"},
	{"value": "YXRFCUNZB", "name": "云霄润发村镇银行"},
	{"value": "YXICNSCUNZB", "name": "郧西楚农商村镇银行"},
	{"value": "YXCNSCUNZB", "name": "郧县楚农商村镇银行"},
	{"value": "ZCBHCUNZB", "name": "郓城北海村镇银行"},
	{"value": "ZHLXCUNZB", "name": "赞皇隆兴村镇银行"},
	{"value": "ZQFYCUNZB", "name": "枣强丰源村镇银行"},
	{"value": "ZAZYH", "name": "枣庄银行"},
	{"value": "ZZRCB", "name": "枣庄农村商业银行"},
	{"value": "ZZPFCUNZB", "name": "泽州浦发村镇银行"},
	{"value": "ZZTMYCUNZB", "name": "扎赉特蒙银村镇银行"},
	{"value": "ZLTMYCUNZB", "name": "扎兰屯蒙银村镇银行"},
	{"value": "SCB", "name": "渣打银行（中国）有限责任公司"},
	{"value": "ZJLJCJCUNZB", "name": "湛江廉江长江村镇银行"},
	{"value": "ZJRCB", "name": "湛江农村商业银行"},
	{"value": "ZBXDCUNZB", "name": "张北信达村镇银行"},
	{"value": "ZJJRCB", "name": "张家界农村商业银行"},
	{"value": "ZJKYH", "name": "张家口银行"},
	{"value": "ZJKCLXNSCUNZB", "name": "张家口崇礼邢农商村镇银行"},
	{"value": "ZJKRCB", "name": "张家口农村商业银行"},
	{"value": "ZJKWQJYCUNZB", "name": "张家口万全家银村镇银行"},
	{"value": "ZJKXHJYCUNZB", "name": "张家口宣化家银村镇银行"},
	{"value": "ZYRCB", "name": "张掖农村商业银行"},
	{"value": "ZQQLCUNZB", "name": "章丘齐鲁村镇银行"},
	{"value": "ZHB", "name": "彰化商业银行"},
	{"value": "ZPMSCUNZB", "name": "漳浦民生村镇银行"},
	{"value": "ZSSYCUNZB", "name": "樟树顺银村镇银行"},
	{"value": "CAYH", "name": "长安银行"},
	{"value": "CBSRCB", "name": "长白山农村商业银行"},
	{"value": "CBYYCUNZB", "name": "长白榆银村镇银行"},
	{"value": "GWB", "name": "长城华西银行"},
	{"value": "CCCYHRCUNZB", "name": "长春朝阳和润村镇银行"},
	{"value": "CCEDNSCUNZB", "name": "长春二道农商村镇银行"},
	{"value": "CCFZRCB", "name": "长春发展农村商业银行"},
	{"value": "CCGXHMCUNZB", "name": "长春高新惠民村镇银行"},
	{"value": "CCJKRFCUNZB", "name": "长春经开融丰村镇银行"},
	{"value": "CCJYYYCUNZB", "name": "长春净月榆银村镇银行"},
	{"value": "CCKCRHCUNZB", "name": "长春宽城融汇村镇银行"},
	{"value": "CCLYRTCUNZB", "name": "长春绿园融泰村镇银行"},
	{"value": "CCNGHMCUNZB", "name": "长春南关惠民村镇银行"},
	{"value": "CCRCB", "name": "长春农村商业银行"},
	{"value": "CCSYJYCUNZB", "name": "长春双阳吉银村镇银行"},
	{"value": "CGXYCUNZB", "name": "长葛轩辕村镇银行"},
	{"value": "CLZYCUNZB", "name": "长岭蛟银村镇银行"},
	{"value": "CNZCCUNZB", "name": "长宁中成村镇银行"},
	{"value": "CSCB", "name": "长沙银行"},
	{"value": "CSHARCB", "name": "长沙农村商业银行"},
	{"value": "CSXSHNSCUNZB", "name": "长沙星沙沪农商村镇银行"},
	{"value": "CSFMCUNZB", "name": "长顺富民村镇银行"},
	{"value": "CTTZHCUNZB", "name": "长汀汀州红村镇银行"},
	{"value": "CYMSCUNZB", "name": "长垣民生村镇银行"},
	{"value": "CZLZRCB", "name": "长治潞州农村商业银行"},
	{"value": "CZXTDCUNZB", "name": "长治市上党区泰都村镇银行"},
	{"value": "CZZZRCB", "name": "长治漳泽农村商业银行"},
	{"value": "CZRHCUNZB", "name": "长子县融汇村镇银行"},
	{"value": "CMBCHINA", "name": "招商银行"},
	{"value": "ZTZYFDCUNZB", "name": "昭通昭阳富滇村镇银行"},
	{"value": "ZFGJB", "name": "兆丰国际商业银行"},
	{"value": "ZCHHCUNZB", "name": "柘城黄淮村镇银行"},
	{"value": "ZRCTHCUNZB", "name": "柘荣刺桐红村镇银行"},
	{"value": "ZJAJJYCUNZB", "name": "浙江安吉交银村镇银行"},
	{"value": "ZJAJRCB", "name": "浙江安吉农村商业银行"},
	{"value": "ZJCNRCB", "name": "浙江苍南农村商业银行"},
	{"value": "ZJCSLHCUNZB", "name": "浙江常山联合村镇银行"},
	{"value": "ZJCSRCB", "name": "浙江常山农村商业银行"},
	{"value": "CZCB", "name": "浙江稠州商业银行"},
	{"value": "ZJCARCB", "name": "浙江淳安农村商业银行"},
	{"value": "ZJZSCZCUNZB", "name": "浙江岱山稠州村镇银行"},
	{"value": "ZJDSRCB", "name": "浙江岱山农村商业银行"},
	{"value": "ZJDQHSCUNZB", "name": "浙江德清湖商村镇银行"},
	{"value": "ZJDQRCB", "name": "浙江德清农村商业银行"},
	{"value": "ZJDHDSCUNZB", "name": "浙江定海德商村镇银行"},
	{"value": "ZJDYFMCUNZB", "name": "浙江东阳富民村镇银行"},
	{"value": "ZJDYRCB", "name": "浙江东阳农村商业银行"},
	{"value": "ZJDTFMCUNZB", "name": "浙江洞头富民村镇银行"},
	{"value": "ZJFYHTCUNZB", "name": "浙江富阳恒通村镇银行"},
	{"value": "ZJFYRCB", "name": "浙江富阳农村商业银行"},
	{"value": "ZJHNDSCUNZB", "name": "浙江海宁德商村镇银行"},
	{"value": "ZJHNRCB", "name": "浙江海宁农村商业银行"},
	{"value": "ZJHYHSCUNZB", "name": "浙江海盐湖商村镇银行"},
	{"value": "ZJHYRCB", "name": "浙江海盐农村商业银行"},
	{"value": "HZYHRCB", "name": "浙江杭州余杭农村商业银行"},
	{"value": "ZJHCRCB", "name": "浙江禾城农村商业银行"},
	{"value": "ZJJSLHCUNZB", "name": "浙江嘉善联合村镇银行"},
	{"value": "ZJJIASRCB", "name": "浙江嘉善农村商业银行"},
	{"value": "ZJJDHSCUNZB", "name": "浙江建德湖商村镇银行"},
	{"value": "ZJJDRCB", "name": "浙江建德农村商业银行"},
	{"value": "ZJJSRCB", "name": "浙江江山农村商业银行"},
	{"value": "ZJJHCTRCB", "name": "浙江金华成泰农村商业银行"},
	{"value": "ZJZYLHCUNZB", "name": "浙江缙云联合村镇银行"},
	{"value": "ZJJYRCB", "name": "浙江缙云农村商业银行"},
	{"value": "ZJJNRCB", "name": "浙江景宁农村商业银行"},
	{"value": "JNYZCUNZB", "name": "浙江景宁银座村镇银行"},
	{"value": "ZJKHRCB", "name": "浙江开化农村商业银行"},
	{"value": "ZJKQLHCUNZB", "name": "浙江柯桥联合村镇银行"},
	{"value": "ZJLXRCB", "name": "浙江兰溪农村商业银行"},
	{"value": "ZJLXYSCUNZB", "name": "浙江兰溪越商村镇银行"},
	{"value": "ZJLQLHCUNZB", "name": "浙江乐清联合村镇银行"},
	{"value": "ZJLQRCB", "name": "浙江乐清农村商业银行"},
	{"value": "ZJLSLDRCB", "name": "浙江丽水莲都农村商业银行"},
	{"value": "ZJLARCB", "name": "浙江临安农村商业银行"},
	{"value": "ZJLAZXCUNZB", "name": "浙江临安中信村镇银行"},
	{"value": "ZJLHHSCUNZB", "name": "浙江临海湖商村镇银行"},
	{"value": "ZJLHRCB", "name": "浙江临海农村商业银行"},
	{"value": "ZJLQMTCUNZB", "name": "浙江龙泉民泰村镇银行"},
	{"value": "ZJLQUANRCB", "name": "浙江龙泉农村商业银行"},
	{"value": "ZJLYRCB", "name": "浙江龙游农村商业银行"},
	{"value": "ZJLYYSCUNZB", "name": "浙江龙游义商村镇银行"},
	{"value": "ZJNXRCB", "name": "浙江南浔农村商业银行"},
	{"value": "ZJNXS", "name": "浙江农村商业联合银行"},
	{"value": "ZJPARCB", "name": "浙江磐安农村商业银行"},
	{"value": "ZJPAZSCUNZB", "name": "浙江磐安婺商村镇银行"},
	{"value": "ZJPHGYCUNZB", "name": "浙江平湖工银村镇银行"},
	{"value": "ZJPHRCB", "name": "浙江平湖农村商业银行"},
	{"value": "ZJPYRCB", "name": "浙江平阳农村商业银行"},
	{"value": "ZJPYPFCUNZB", "name": "浙江平阳浦发村镇银行"},
	{"value": "ZJPJJYCUNZB", "name": "浙江浦江嘉银村镇银行"},
	{"value": "ZJPJRCB", "name": "浙江浦江农村商业银行"},
	{"value": "ZJQTRCB", "name": "浙江青田农村商业银行"},
	{"value": "ZJQYRCB", "name": "浙江庆元农村商业银行"},
	{"value": "ZJQYTLCUNZB", "name": "浙江庆元泰隆村镇银行"},
	{"value": "ZJQZKCRCB", "name": "浙江衢州柯城农村商业银行"},
	{"value": "ZJQZQJRCB", "name": "浙江衢州衢江农村商业银行"},
	{"value": "ZJZZZJSYCUNZB", "name": "浙江衢州衢江上银村镇银行"},
	{"value": "ZJRAHSCUNZB", "name": "浙江瑞安湖商村镇银行"},
	{"value": "ZJRARCB", "name": "浙江瑞安农村商业银行"},
	{"value": "ZJSMRCB", "name": "浙江三门农村商业银行"},
	{"value": "SMYZCUNZB", "name": "浙江三门银座村镇银行"},
	{"value": "ZJSYFMCUNZB", "name": "浙江上虞富民村镇银行"},
	{"value": "ZJSYRCB", "name": "浙江上虞农村商业银行"},
	{"value": "ZJSXRFRCB", "name": "浙江绍兴瑞丰农村商业银行"},
	{"value": "ZJSSRCB", "name": "浙江嵊泗农村商业银行"},
	{"value": "ZJSZRCB", "name": "浙江嵊州农村商业银行"},
	{"value": "ZJSZRFCUNZB", "name": "浙江嵊州瑞丰村镇银行"},
	{"value": "ZJSYHTCUNZB", "name": "浙江松阳恒通村镇银行"},
	{"value": "ZJSONGYRCB", "name": "浙江松阳农村商业银行"},
	{"value": "ZJSCFMCUNZB", "name": "浙江遂昌富民村镇银行"},
	{"value": "ZJSCRCB", "name": "浙江遂昌农村商业银行"},
	{"value": "ZJTZHYHSCUNZB", "name": "浙江台州黄岩恒升村镇银行"},
	{"value": "ZJTZHYRCB", "name": "浙江台州黄岩农村商业银行"},
	{"value": "ZJTZJJRCB", "name": "浙江台州椒江农村商业银行"},
	{"value": "ZJTZLQFMCUNZB", "name": "浙江台州路桥富民村镇银行"},
	{"value": "ZJTZLQRCB", "name": "浙江台州路桥农村商业银行"},
	{"value": "ZJTSRCB", "name": "浙江泰顺农村商业银行"},
	{"value": "ZJTSWYCUNZB", "name": "浙江泰顺温银村镇银行"},
	{"value": "ZJTTMSCUNZB", "name": "浙江天台民生村镇银行"},
	{"value": "ZJTTRCB", "name": "浙江天台农村商业银行"},
	{"value": "ZJTLHFCUNZB", "name": "浙江桐庐恒丰村镇银行"},
	{"value": "ZJTLRCB", "name": "浙江桐庐农村商业银行"},
	{"value": "ZJTXMTCUNZB", "name": "浙江桐乡民泰村镇银行"},
	{"value": "ZJTXRCB", "name": "浙江桐乡农村商业银行"},
	{"value": "ZJWLLHCUNZB", "name": "浙江温岭联合村镇银行"},
	{"value": "ZJWLRCB", "name": "浙江温岭农村商业银行"},
	{"value": "ZJWZDTRCB", "name": "浙江温州洞头农村商业银行"},
	{"value": "ZJWZLWRCB", "name": "浙江温州龙湾农村商业银行"},
	{"value": "ZJWZLCRCB", "name": "浙江温州鹿城农村商业银行"},
	{"value": "ZJWZOHRCB", "name": "浙江温州瓯海农村商业银行"},
	{"value": "ZJWCBYCUNZB", "name": "浙江文成北银村镇银行"},
	{"value": "ZJWCRCB", "name": "浙江文成农村商业银行"},
	{"value": "ZJWYRCB", "name": "浙江武义农村商业银行"},
	{"value": "ZJXJFMCUNZB", "name": "浙江仙居富民村镇银行"},
	{"value": "ZJXJRCB", "name": "浙江仙居农村商业银行"},
	{"value": "ZJXSHSCUNZB", "name": "浙江萧山湖商村镇银行"},
	{"value": "ZJXSRCB", "name": "浙江萧山农村商业银行"},
	{"value": "ZJXCRCB", "name": "浙江新昌农村商业银行"},
	{"value": "ZJXCPFCUNZB", "name": "浙江新昌浦发村镇银行"},
	{"value": "ZJXZDSCUNZB", "name": "浙江秀洲德商村镇银行"},
	{"value": "ZJYWLHCUNZB", "name": "浙江义乌联合村镇银行"},
	{"value": "ZJYWRCB", "name": "浙江义乌农村商业银行"},
	{"value": "ZJYJHSCUNZB", "name": "浙江永嘉恒升村镇银行"},
	{"value": "ZJYJRCB", "name": "浙江永嘉农村商业银行"},
	{"value": "ZJYKRCB", "name": "浙江永康农村商业银行"},
	{"value": "ZJYHDSCUNZB", "name": "浙江余杭德商村镇银行"},
	{"value": "ZJYHRCB", "name": "浙江玉环农村商业银行"},
	{"value": "ZJYHYXCUNZB", "name": "浙江玉环永兴村镇银行"},
	{"value": "ZJYHLHCUNZB", "name": "浙江云和联合村镇银行"},
	{"value": "ZJYHERCB", "name": "浙江云和农村商业银行"},
	{"value": "ZJCXLHCUNZB", "name": "浙江长兴联合村镇银行"},
	{"value": "ZJCXRCB", "name": "浙江长兴农村商业银行"},
	{"value": "ZJZSDHHYRCB", "name": "浙江舟山定海海洋农村商业银行"},
	{"value": "ZJZSPTCZCUNZB", "name": "浙江舟山普陀稠州村镇银行"},
	{"value": "ZJZSPTRCB", "name": "浙江舟山普陀农村商业银行"},
	{"value": "ZJZZLHCUNZB", "name": "浙江诸暨联合村镇银行"},
	{"value": "ZJZJRCB", "name": "浙江诸暨农村商业银行"},
	{"value": "CZ", "name": "浙商银行"},
	{"value": "ZFXZCUNZB", "name": "贞丰兴贞村镇银行"},
	{"value": "ZJRZCJCUNZB", "name": "镇江润州长江村镇银行"},
	{"value": "ZNHSCUNZB", "name": "镇宁汇商村镇银行"},
	{"value": "ZDHSCUNZB", "name": "正定恒升村镇银行"},
	{"value": "ZLQHZCUNZB", "name": "正蓝旗汇泽村镇银行"},
	{"value": "ZYYCCUNZB", "name": "正阳玉川村镇银行"},
	{"value": "ZHENGZYH", "name": "郑州银行"},
	{"value": "ZZJSSNSCUNZB", "name": "郑州金水厦农商村镇银行"},
	{"value": "ZHENGZRCB", "name": "郑州农村商业银行"},
	{"value": "ZZZJCUNZB", "name": "郑州珠江村镇银行"},
	{"value": "ZJHYCUNZB", "name": "枝江汉银村镇银行"},
	{"value": "ZJHMCUNZB", "name": "织金惠民村镇银行"},
	{"value": "ZDMSCUNZB", "name": "志丹民生村镇银行"},
	{"value": "SGB", "name": "中德住房储蓄银行有限责任公司"},
	{"value": "ZGCBANK", "name": "北京中关村银行"},
	{"value": "CTBCBANK", "name": "中国信托商业银行"},
	{"value": "BOC", "name": "中国银行"},
	{"value": "ZJRXCUNZB", "name": "中江融兴村镇银行"},
	{"value": "ZMZYCUNZB", "name": "中牟郑银村镇银行"},
	{"value": "ZSDFZJCUNZB", "name": "中山东凤珠江村镇银行"},
	{"value": "ZSGZNYCUNZB", "name": "中山古镇南粤村镇银行"},
	{"value": "ZSRCB", "name": "中山农村商业银行"},
	{"value": "ZSXZCUNZB", "name": "中山小榄村镇银行"},
	{"value": "ZWXSCUNZB", "name": "中卫香山村镇银行"},
	{"value": "ECITIC", "name": "中信银行"},
	{"value": "HXBXB", "name": "中信百信银行"},
	{"value": "ZYXTXCUNZB", "name": "中阳县太行村镇银行"},
	{"value": "ZYFDCUNZB", "name": "中银富登村镇银行"},
	{"value": "ZYYH", "name": "中原银行"},
	{"value": "ZXMSCUNZB", "name": "钟祥民生村镇银行"},
	{"value": "CQYH", "name": "重庆银行"},
	{"value": "ZQBNPFCUNZB", "name": "重庆巴南浦发村镇银行"},
	{"value": "ZQBZCZCUNZB", "name": "重庆北碚稠州村镇银行"},
	{"value": "ZQZSGYCUNZB", "name": "重庆璧山工银村镇银行"},
	{"value": "ZQDZHFCUNZB", "name": "重庆大足汇丰村镇银行"},
	{"value": "ZQFDHFCUNZB", "name": "重庆丰都汇丰村镇银行"},
	{"value": "CQFMYH", "name": "重庆富民银行"},
	{"value": "ZQJBHFCUNZB", "name": "重庆江北恒丰村镇银行"},
	{"value": "ZQJJSYCUNZB", "name": "重庆江津石银村镇银行"},
	{"value": "ZQJLPMTCUNZB", "name": "重庆九龙坡民泰村镇银行"},
	{"value": "ZQLPAXCUNZB", "name": "重庆梁平澳新村镇银行"},
	{"value": "ZQNCSYCUNZB", "name": "重庆南川石银村镇银行"},
	{"value": "CQRCB", "name": "重庆农村商业银行"},
	{"value": "ZQPSMTCUNZB", "name": "重庆彭水民泰村镇银行"},
	{"value": "QJYZCUNZB", "name": "重庆黔江银座村镇银行"},
	{"value": "ZQRCHFCUNZB", "name": "重庆荣昌汇丰村镇银行"},
	{"value": "CQSXYH", "name": "重庆三峡银行"},
	{"value": "ZQSDDKRXCUNZB", "name": "重庆市大渡口融兴村镇银行"},
	{"value": "ZQSSPBRXCUNZB", "name": "重庆市沙坪坝融兴村镇银行"},
	{"value": "ZQSYYRXCUNZB", "name": "重庆市酉阳融兴村镇银行"},
	{"value": "ZQTLPFCUNZB", "name": "重庆铜梁浦发村镇银行"},
	{"value": "ZQXSBYCUNZB", "name": "重庆秀山北银村镇银行"},
	{"value": "ZQYCBYCUNZB", "name": "重庆永川北银村镇银行"},
	{"value": "YBYZCUNZB", "name": "重庆渝北银座村镇银行"},
	{"value": "ZQYYHFCUNZB", "name": "重庆云阳恒丰村镇银行"},
	{"value": "ZQZXCZCUNZB", "name": "重庆忠县稠州村镇银行"},
	{"value": "ZKRCB", "name": "周口农村商业银行"},
	{"value": "ZNCTHCUNZB", "name": "周宁刺桐红村镇银行"},
	{"value": "ZHHQCUNZB", "name": "珠海横琴村镇银行"},
	{"value": "ZHCCB", "name": "珠海华润银行"},
	{"value": "ZHNPCUNZB", "name": "珠海南屏村镇银行"},
	{"value": "ZHRCB", "name": "珠海农村商业银行"},
	{"value": "ZHUZRCB", "name": "株洲农村商业银行"},
	{"value": "ZZXRXCUNZB", "name": "株洲县融兴村镇银行"},
	{"value": "ZSCNSCUNZB", "name": "竹山楚农商村镇银行"},
	{"value": "ZXCNSCUNZB", "name": "竹溪楚农商村镇银行"},
	{"value": "ZMDRCB", "name": "驻马店农村商业银行"},
	{"value": "ZHHTCUNZB", "name": "庄河汇通村镇银行"},
	{"value": "ZGEQBSCUNZB", "name": "准格尔旗蒙商村镇银行"},
	{"value": "ZLLFCUNZB", "name": "涿鹿利丰村镇银行"},
	{"value": "ZZZCCUNZB", "name": "涿州中成村镇银行"},
	{"value": "ZZMYCUNZB", "name": "卓资蒙银村镇银行"},
	{"value": "ZXJYCUNZB", "name": "资溪九银村镇银行"},
	{"value": "ZXPFCUNZB", "name": "资兴浦发村镇银行"},
	{"value": "ZYMSCUNZB", "name": "资阳民生村镇银行"},
	{"value": "ZIYRCB", "name": "资阳农村商业银行"},
	{"value": "ZBBSBHCUNZB", "name": "淄博博山北海村镇银行"},
	{"value": "ZBBSRCB", "name": "淄博博山农村商业银行"},
	{"value": "ZBZCBHCUNZB", "name": "淄博淄川北海村镇银行"},
	{"value": "ZBZCRCB", "name": "淄博淄川农村商业银行"},
	{"value": "ZYFMCUNZB", "name": "紫云富民村镇银行"},
	{"value": "ZGCCB", "name": "自贡银行股份有限公司"},
	{"value": "ZGRCB", "name": "自贡农村商业银行"},
	{"value": "ZGZCCUNZB", "name": "自贡中成村镇银行"},
	{"value": "ZPPFCUNZB", "name": "邹平浦发村镇银行"},
	{"value": "ZHRHCUNZB", "name": "遵化融和村镇银行"},
	{"value": "ZYCCB", "name": "遵义市商业银行"},
	{"value": "ZYBZHLCUNZB", "name": "遵义播州汇隆村镇银行"},
	{"value": "ZYHHGFMCUNZB", "name": "遵义红花岗富民村镇银行"},
	{"value": "ZYHCQXCUNZB", "name": "遵义汇川黔兴村镇银行"},
	{"value": "ZYXPCZCUNZB", "name": "遵义新蒲长征村镇银行"},
	{"value": "ZYXCQCUNZB", "name": "左云县长青村镇银行"},
	{"value": "DTRCB", "name": "大同农村商业银行"},
	{"value": "GDHFRCB", "name": "广东海丰农村商业银行"},
	{"value": "GDLJRCB", "name": "广东廉江农村商业银行"},
	{"value": "GDLFRCB", "name": "广东陆丰农村商业银行"},
	{"value": "GDWCRCB", "name": "广东吴川农村商业银行"},
	{"value": "GDYXRCB", "name": "广东阳西农村商业银行"},
	{"value": "GXBMRCB", "name": "广西巴马农村商业银行"},
	{"value": "GXLPRCB", "name": "广西荔浦农村商业银行"},
	{"value": "GXLINGCRCB", "name": "广西灵川农村商业银行"},
	{"value": "GXLUOCRCB", "name": "广西罗城农村商业银行"},
	{"value": "GXRSRCB", "name": "广西融水农村商业银行"},
	{"value": "GZYPRCB", "name": "贵州玉屏农村商业银行"},
	{"value": "HNWNRCB", "name": "海南万宁农村商业银行"},
	{"value": "HNLBRCB", "name": "河南灵宝农村商业银行"},
	{"value": "HNXICRCB", "name": "河南淅川农村商业银行"},
	{"value": "HLJQARCB", "name": "黑龙江庆安农村商业银行"},
	{"value": "JLTYRCB", "name": "吉林通榆农村商业银行"},
	{"value": "NMGEWKRCB", "name": "内蒙古鄂温克农村商业银行"},
	{"value": "NMGLXRCB", "name": "内蒙古林西农村商业银行"},
	{"value": "NXHYRCB", "name": "宁夏海原农村商业银行"},
	{"value": "NXJYRCB", "name": "宁夏泾源农村商业银行"},
	{"value": "QHHLRCB", "name": "青海化隆农村商业银行"},
	{"value": "QHJZRCB", "name": "青海尖扎农村商业银行"},
	{"value": "QHMHRCB", "name": "青海民和农村商业银行"},
	{"value": "QHTJRCB", "name": "青海天峻农村商业银行"},
	{"value": "QHZJRCB", "name": "青海泽库农村商业银行"},
	{"value": "SXAZRCB", "name": "山西安泽农村商业银行"},
	{"value": "SXJLRCB", "name": "山西静乐农村商业银行"},
	{"value": "SXLANXRCB", "name": "山西岚县农村商业银行"},
	{"value": "SXQINXRCB", "name": "山西沁县农村商业银行"},
	{"value": "SXWRRCB", "name": "山西万荣农村商业银行"},
	{"value": "SXYHRCB", "name": "山西永和农村商业银行"},
	{"value": "SXBJJTRCB", "name": "陕西宝鸡金台农村商业银行"},
	{"value": "SXQISRCB", "name": "陕西岐山农村商业银行"},
	{"value": "SJZLQRCB", "name": "石家庄鹿泉农村商业银行"},
	{"value": "SDRCB", "name": "顺德农村商业银行"},
	{"value": "XJALTRCB", "name": "新疆阿勒泰农村商业银行"},
	{"value": "XJFYRCB", "name": "新疆富蕴农村商业银行"},
	{"value": "XJYNRCB", "name": "新疆伊宁农村商业银行"},
	{"value": "XCRCB", "name": "许昌农村商业银行"},
	{"value": "YQRCB", "name": "阳泉农村商业银行"},
	{"value": "YNGNRCB", "name": "云南广南农村商业银行"},
	{"value": "YNLHRCB", "name": "云南梁河农村商业银行"},
	{"value": "YNLONGLRCB", "name": "云南龙陵农村商业银行"},
	{"value": "YNMGRCB", "name": "云南马关农村商业银行"},
	{"value": "YNSDRCB", "name": "云南施甸农村商业银行"},
	{"value": "YNYUANMRCB", "name": "云南元谋农村商业银行"},
	{"value": "ZQRCB", "name": "肇庆农村商业银行"},
	{"value": "ZJSXHXRCB", "name": "浙江绍兴恒信农村商业银行"},
	{"value": "FJAXRCB", "name": "福建安溪农村商业银行"},
	{"value": "FJHACXCUNZB", "name": "福建华安长信村镇银行"},
	{"value": "FJLJRCB", "name": "福建连江农村商业银行"},
	{"value": "FJSWRCB", "name": "福建邵武农村商业银行"},
	{"value": "FJSXCXCUNZB", "name": "福建松溪长信村镇银行"},
	{"value": "FJXYRCB", "name": "福建仙游农村商业银行"},
	{"value": "FJYARCB", "name": "福建永安农村商业银行"},
	{"value": "FJYTCXRCB", "name": "福建永泰长信村镇银行"},
	{"value": "FJZPURCB", "name": "福建漳浦农村商业银行"},
	{"value": "SCGZRCB", "name": "甘孜农村商业银行"},
	{"value": "GDCYRCB", "name": "广东潮阳农村商业银行"},
	{"value": "GDCHRCB", "name": "广东澄海农村商业银行"},
	{"value": "GDHLRCB", "name": "广东惠来农村商业银行"},
	{"value": "GDSGRCB", "name": "广东韶关农村商业银行"},
	{"value": "GDYNRCB", "name": "广东郁南农村商业银行"},
	{"value": "GDYFRCB", "name": "广东云浮农村商业银行"},
	{"value": "GXBYRCB", "name": "广西宾阳农村商业银行"},
	{"value": "GXCWRCB", "name": "广西苍梧农村商业银行"},
	{"value": "GXDARCB", "name": "广西都安农村商业银行"},
	{"value": "GXGGRCB", "name": "广西贵港农村商业银行"},
	{"value": "GXJINXRCB", "name": "广西金秀农村商业银行"},
	{"value": "GXSJRCB", "name": "广西三江农村商业银行"},
	{"value": "GXTERCB", "name": "广西天峨农村商业银行"},
	{"value": "GXWXRCB", "name": "广西武宣农村商业银行"},
	{"value": "GZCHRCB", "name": "贵州册亨农村商业银行"},
	{"value": "GZGDRCB", "name": "贵州贵定农村商业银行"},
	{"value": "GZJHRCB", "name": "贵州剑河农村商业银行"},
	{"value": "GZWMRCB", "name": "贵州望谟农村商业银行"},
	{"value": "GZXSRCB", "name": "贵州习水农村商业银行"},
	{"value": "GZYJRCB", "name": "贵州印江农村商业银行"},
	{"value": "GZZNRCB", "name": "贵州镇宁农村商业银行"},
	{"value": "HNLZRCB", "name": "河南林州农村商业银行"},
	{"value": "HNPYKZRCB", "name": "河南濮阳开州农村商业银行"},
	{"value": "HNWHRCB", "name": "河南卫辉农村商业银行"},
	{"value": "HNXYERCB", "name": "河南新野农村商业银行"},
	{"value": "HLJADRCB", "name": "黑龙江安达农村商业银行"},
	{"value": "HLJSHRCB", "name": "黑龙江绥化农村商业银行"},
	{"value": "HNHJXNCUNZB", "name": "湖南洪江湘农村镇银行"},
	{"value": "HNJYXNCUNZB", "name": "湖南江永湘农村镇银行"},
	{"value": "HNSZXNCUNZB", "name": "湖南桑植湘农村镇银行"},
	{"value": "HNSPXNCUNZB", "name": "湖南双牌湘农村镇银行"},
	{"value": "HNSNXNCUNZB", "name": "湖南绥宁湘农村镇银行"},
	{"value": "HNXTXNCUNZB", "name": "湖南新田湘农村镇银行"},
	{"value": "HNYLXLCUNZB", "name": "湖南炎陵星龙村镇银行"},
	{"value": "JXWZFMCUNZB", "name": "江西万载富民村镇银行"},
	{"value": "LSBANK", "name": "辽沈银行"},
	{"value": "LYXNCUNZB", "name": "隆尧邢农商村镇银行"},
	{"value": "SSC", "name": "美国道富银行"},
	{"value": "NMGABGRCB", "name": "内蒙古阿巴嘎农村商业银行"},
	{"value": "NMGAHRCB", "name": "内蒙古敖汉农村商业银行"},
	{"value": "NMGHJRCB", "name": "内蒙古杭锦农村商业银行"},
	{"value": "NMGKLURCB", "name": "内蒙古开鲁农村商业银行"},
	{"value": "NMGKLRCB", "name": "内蒙古库伦农村商业银行"},
	{"value": "NMGZLTRCB", "name": "内蒙古扎鲁特农村商业银行"},
	{"value": "NBYCRCB", "name": "宁波甬城农村商业银行"},
	{"value": "NXHSBRCB", "name": "宁夏红寺堡农村商业银行"},
	{"value": "NXLDRCB", "name": "宁夏隆德农村商业银行"},
	{"value": "PJRCB", "name": "盘锦农村商业银行"},
	{"value": "PDSYCRCB", "name": "平顶山鹰城农村商业银行"},
	{"value": "QDHFCUNZB", "name": "祁东惠丰村镇银行"},
	{"value": "SXBDRCB", "name": "山西保德农村商业银行"},
	{"value": "SXDNRCB", "name": "山西大宁农村商业银行"},
	{"value": "SXDXRCB", "name": "山西定襄农村商业银行"},
	{"value": "SXFYRCB", "name": "山西汾阳农村商业银行"},
	{"value": "SXGXRCB", "name": "山西古县农村商业银行"},
	{"value": "SHXHYRCB", "name": "山西浑源农村商业银行"},
	{"value": "SXHZRCB", "name": "山西霍州农村商业银行"},
	{"value": "SXJIXRCB", "name": "山西吉县农村商业银行"},
	{"value": "SXLQRCB", "name": "山西灵丘农村商业银行"},
	{"value": "SXLVLRCB", "name": "山西吕梁农村商业银行"},
	{"value": "SXNWRCB", "name": "山西宁武农村商业银行"},
	{"value": "SXPGRCB", "name": "山西偏关农村商业银行"},
	{"value": "SXPDRCB", "name": "山西平定农村商业银行"},
	{"value": "SXPXRCB", "name": "山西蒲县农村商业银行"},
	{"value": "SXQIXRCB", "name": "山西祁县农村商业银行"},
	{"value": "SXWZRCB", "name": "山西五寨农村商业银行"},
	{"value": "SXXIXRCB", "name": "山西隰县农村商业银行"},
	{"value": "SXXJRCB", "name": "山西新绛农村商业银行"},
	{"value": "SXYIXRCB", "name": "山西应县农村商业银行"},
	{"value": "SXYYRCB", "name": "山西右玉农村商业银行"},
	{"value": "SXYZRCB", "name": "山西云州农村商业银行"},
	{"value": "SXFPRCB", "name": "陕西佛坪农村商业银行"},
	{"value": "STHWRCB", "name": "汕头海湾农村商业银行"},
	{"value": "SCJYORCB", "name": "四川江油农村商业银行"},
	{"value": "SCPARCB", "name": "四川蓬安农村商业银行"},
	{"value": "SCSMRCB", "name": "四川石棉农村商业银行"},
	{"value": "SCTQRCB", "name": "四川天全农村商业银行"},
	{"value": "SCWCRCB", "name": "四川旺苍农村商业银行"},
	{"value": "SCBANK", "name": "四川银行"},
	{"value": "SCZJRCB", "name": "四川中江农村商业银行"},
	{"value": "TYRCB", "name": "太原农村商业银行"},
	{"value": "XJAWTRCB", "name": "新疆阿瓦提农村商业银行"},
	{"value": "XJBEJKNSRCB", "name": "新疆布尔津喀纳斯农村商业银行"},
	{"value": "XJMNSRCB", "name": "新疆玛纳斯农村商业银行"},
	{"value": "XJMLRCB", "name": "新疆木垒农村商业银行"},
	{"value": "XJSYRCB", "name": "新疆沙雅农村商业银行"},
	{"value": "XJSSRB", "name": "新疆鄯善农村商业银行"},
	{"value": "XJWUSRCB", "name": "新疆乌什农村商业银行"},
	{"value": "XJXYRCB", "name": "新疆新源农村商业银行"},
	{"value": "XJZSRCB", "name": "新疆昭苏农村商业银行"},
	{"value": "XZRCB", "name": "徐州农村商业银行"},
	{"value": "YNCJRCB", "name": "云南澄江农村商业银行"},
	{"value": "YNHQRCB", "name": "云南鹤庆农村商业银行"},
	{"value": "YNHNRCB", "name": "云南华宁农村商业银行"},
	{"value": "YNHZRCB", "name": "云南会泽农村商业银行"},
	{"value": "YNJCRCB", "name": "云南剑川农村商业银行"},
	{"value": "YNLYRCB", "name": "云南隆阳农村商业银行"},
	{"value": "YNMLPRCB", "name": "云南麻栗坡农村商业银行"},
	{"value": "YNMLIRCB", "name": "云南孟连农村商业银行"},
	{"value": "YNMDRCB", "name": "云南弥渡农村商业银行"},
	{"value": "YNNLRCB", "name": "云南宁蒗农村商业银行"},
	{"value": "YNSBRCB", "name": "云南双柏农村商业银行"},
	{"value": "YNYSHRCB", "name": "云南砚山农村商业银行"},
	{"value": "YNYILRCB", "name": "云南彝良农村商业银行"},
	{"value": "YNYPRCB", "name": "云南永平农村商业银行"},
	{"value": "YNYYRCB", "name": "云南元阳农村商业银行"},
	{"value": "ZJLGRCB", "name": "浙江龙港农村商业银行"},
	{"value": "ZJYKNYCUNZB", "name": "浙江永康农银村镇银行"},
	{"value": "SXB", "name": "山西银行"},
	{"value": "FAB", "name": "阿联酋阿布扎比第一银行"},
	{"value": "ENB", "name": "北欧银行"},
	{"value": "FJPHRCB", "name": "福建平和农村商业银行"},
	{"value": "GXDHRCB", "name": "广西大化农村商业银行"},
	{"value": "GXDBRCB", "name": "广西德保农村商业银行"},
	{"value": "GXFESRCB", "name": "广西凤山农村商业银行"},
	{"value": "GXZSRCB", "name": "广西钟山农村商业银行"},
	{"value": "GZDJRCB", "name": "贵州德江农村商业银行"},
	{"value": "HENLYRCB", "name": "河南临颍农村商业银行"},
	{"value": "HNXXXZRCB", "name": "河南新乡新中农村商业银行"},
	{"value": "HLJBYRCB", "name": "黑龙江巴彦农村商业银行"},
	{"value": "HLJBLRCB", "name": "黑龙江勃利农村商业银行"},
	{"value": "HLJHNRCB", "name": "黑龙江桦南农村商业银行"},
	{"value": "HLJJYRCB", "name": "黑龙江嘉荫农村商业银行"},
	{"value": "HLJMLRCB", "name": "黑龙江木兰农村商业银行"},
	{"value": "HLJQGRCB", "name": "黑龙江青冈农村商业银行"},
	{"value": "HLJSZRCB", "name": "黑龙江尚志农村商业银行"},
	{"value": "HLJTLIRCB", "name": "黑龙江铁力农村商业银行"},
	{"value": "HNCBXNCUNZB", "name": "湖南城步湘农村镇银行"},
	{"value": "HNGDXLCUNZB", "name": "湖南桂东星龙村镇银行"},
	{"value": "HNJHXLCUNZB", "name": "湖南嘉禾星龙村镇银行"},
	{"value": "LESRCB", "name": "乐山农村商业银行"},
	{"value": "MYRCB", "name": "绵阳农村商业银行"},
	{"value": "NMGSNTZQRCB", "name": "内蒙古苏尼特左旗农村商业银行"},
	{"value": "NXHNRCB", "name": "宁夏惠农农村商业银行"},
	{"value": "NXQTXRCB", "name": "宁夏青铜峡农村商业银行"},
	{"value": "NXYNRCB", "name": "宁夏永宁农村商业银行"},
	{"value": "QTHRCB", "name": "七台河农村商业银行"},
	{"value": "SXFASRCB", "name": "山西方山农村商业银行"},
	{"value": "SXGLRCB", "name": "山西广灵农村商业银行"},
	{"value": "SXJKRCB", "name": "山西交口农村商业银行"},
	{"value": "SXLFRCB", "name": "山西娄烦农村商业银行"},
	{"value": "SXYICRCB", "name": "山西翼城农村商业银行"},
	{"value": "SHCSB", "name": "上海商业储蓄银行"},
	{"value": "SYSRCB", "name": "双鸭山农村商业银行"},
	{"value": "YNHPRCB", "name": "云南华坪农村商业银行"},
	{"value": "YNLVCRCB", "name": "云南绿春农村商业银行"},
	{"value": "YNMHRCB", "name": "云南勐海农村商业银行"},
	{"value": "YNNJRCB", "name": "云南南涧农村商业银行"},
	{"value": "YNQJRCB", "name": "云南巧家农村商业银行"},
	{"value": "YNYBRCB", "name": "云南漾濞农村商业银行"},
	{"value": "YNYDRCB", "name": "云南永德农村商业银行"},
	{"value": "YNZYRCB", "name": "云南镇沅农村商业银行"},
	{"value": "ZYYHWJB", "name": "中邮邮惠万家银行"},
	{"value": "LNRCB", "name": "辽宁农村商业银行"},
	{"value": "DYXFCUNZB", "name": "当阳兴福村镇银行"},
	{"value": "DIQRCB", "name": "迪庆农村商业银行"},
	{"value": "GYCU", "name": "高阳县农村信用联社"},
	{"value": "SCYTRCB", "name": "四川盐亭农村商业银行"},
	{"value": "SCRXRCB", "name": "四川荣县农村商业银行"},
	{"value": "ABRCB", "name": "阿坝农村商业银行"},
	{"value": "SCZZRCB", "name": "四川资中农村商业银行"},
	{"value": "ZXYHGJ", "name": "中信银行国际（中国）有限公司"},
}
